/*    .
 
  ..  ..*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdarg.h>

#ifdef _WIN32

#include <malloc.h>
#include <process.h>
#include <io.h>
#include <direct.h>

#else

#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <limits.h>
#include <libgen.h>

#endif

#include "normacnf.h"
#include "memcheck.h"
#include "paramcnf.h"
#include "outptcnf.h"

/**********************************************************/
/* */
/**********************************************************/
/*   */
BOOL bPrintDetail = FALSE;
/*   (==TRUE  )*/
BOOL bFatalErr = FALSE;
/*      INCLUDE*/
BOOL bNoInclude = FALSE;
/*,   ,     */
BOOL bUserInterface = FALSE;
/*  */
BOOL bDebug = FALSE;
/* */
int nIdentifierLength = 32;
/*  */
OUT_FILE_TYPE out_file_type = GNS;
/*  0-  1- 2-english*/
int language = 0;
/*  */
BOOL bFileMode = FALSE;
/* GNS*/
int fullhardnet = 0;
int linkquota = 0;
int section_number = 0;
int how_processors = 32;
/*    */
BOOL bDebugFortran = TRUE;
/* */
int WarningMask = 0;
/**********************************************************/
/*external variables*/
/**********************************************************/

/*   */
BOOL bNormaGeneratedProgram = TRUE;

/* */
char **message;

/*   */
char strCurrentPart[MAX_INDENT_LEN];
/*     */
char strOutPath[MYMAXPATH];
int nLenOutPath;
/*   */
BOOL bUppercaseExt = FALSE;
/* ,        */
BOOL bUserOutName = FALSE;
/*    */
char main_out_name[64];

/*  */
FILES *src_file=NULL;
/* header-*/
FILES *head_file=NULL;
/*  */
RASPR *begraspr=NULL;
/* */
HIERARHY begin_hi;

/**********************************************************/

/*   */
static STRINGS *src_string=NULL;
/*  header-*/
static STRINGS *head_string=NULL;

/* o*/
static int nErrors=0;
/* */
static int nWarnings=0;
/*  */
static int nDisWarnings=0;
/*   */
static DEFINES *first_def=NULL;

/**********************************************************/

char *s_strings_r[4]={
	" \n",
	" \n",
	"  \n",
	" ",
	};
char *s_strings_e[4]={
	"MAIN PART\n",
	"CONFIG INFORMATION\n",
	"END OF CONFIG INFORMATION\n",
	"DISTRNAME",
	};

char *message_rus[61]={
	"訡   .\n",
	"   ࠡ.\n",
	" ࠧ %s.\n",
	"!  %s 뢠 ᠬ ᥡ!\n",
	"ଠ 䨣 ࠧ %s ࠧ襭.\n",
	"",
	"믮  㤠.",
	" %s  .\n",
	" 㬥: %s\n",
	" ஥ %s  .\n",
	/*10*/
	"㦥   ࠧ : %s  %s.\n",
	"  ࠧ.\n",
	"⢮ ஢  ⭮  筮.\n",
	" 䨣樨 %s ᣥ஢.\n",
	"䨣  .\n",
	" ᠭ 䨣樨.\n",
	" %s :\n",
	"஢.\n",
	" .\n",
	" 諠 ᯥ譮.\n",
	/*20*/
	"㥬 䠩 .\n",
	"訡  䠩 .\n",
	"쭮 襭 ࠡ 䨣.\n",
	"訡 ⥭  䠩 %s.\n",
	"-ணࠬ ࠧ %s ,  ᠬ ࠧ - .\n",
	" ० \"\"    ⮫쪮 䠩   ࠧ.\n",
	"ணࠬ NCN.exe  .\n",
	" 樨  \"max\" ࠧ 祭   ࠧ  %s.\n",
	"  ࠧ %s   ⪠.\n",
	" ଠ樨 䨣  ࠧ %s.\n",
	/*30*/
	" । ࠧ    ᫮ ஢.\n",
	"맮 ⭮ ࠧ: %s.\n",
	" %d 訡  %d ।० (䨫஢: %d).  ࠢ!\n",
	"஢ઠ ࠬ஢ 맮 ࠧ %s  ࠧ %s ...\n",
	"୮ ⢮ ࠬ஢.\n",
	"  c  %d- ࠬ.\n",
	" ⨯ %d- ࠬ.\n",
	"୮ ⢮ ࠧ୮⥩ c  %d- ࠬ.\n",
	" ࠧ %d-   %d- ࠬ.\n",
	"୮ ⢮ IN-ࠬ஢.\n",
	/*40*/
	" ࠭ %d-   %d- ࠬ.\n",
	"  %d-   %d- ࠬ.\n",
	" %s - ன DISTRIBUTION-ࠧ  楯窥 맮.\n",
	"DISTRIBUTED-ࠧ %s 뢠  ᪠୮ %s.\n",
	"  ଠ ࠬ ࠧ %s.\n",
	"  䠪᪨ ࠬ ࠧ %s.\n",
	"INCLUE 䠩 %s  .\n",
	"।०: %d (䨫஢: %d).\n",
	" ⭮ 祭 ࠬ %s.\n",
	"⥭ ࠧ c  %d- ࠬ.\n",
	/*50*/
	"   ࠧ %s.\n",
	"ॢ  %s .\n",
	" ࠧ  %s ᪮஢  ࠧ 室 몠.\n",
	" %s  ᮤন ⫠筮 ଠ樨.\n",
	" %s ᮤন ⫠ ଠ.\n",
	"ᨢ %s  COMMON- /%s/   ࠧ୮.\n",
	"訡 ᨭ⠪.\n",
	"⨬ ⥪ 맮 ।  ࠧ %s.\n",
	"室 䠩 ࠥ 筨.\n",
	"  ࠧ   㭪 MPI_Init.\n",
	/*60*/
	};
char *message_eng[61]={
	"Error writing.\n",
	"No memory.\n",
	"No part %s.\n",
	"Recursion! Part %s call himself!\n",
	"Config information is destroyed in part %s.\n",
	"Command",
	"not perfomed.",
	"File %s not exist.\n",
	"Illegal argument: %s\n",
	"Project file %s not found.\n",
	/*10*/
	"Two main part found: %s and %s.\n",
	"No main part.\n",
	"The number of processors is too little.\n",
	"Config file %s generated.\n",
	"Config file not changed.\n",
	"Config description is generating.\n",
	"Generating %s from:\n",
	"Has generated.\n",
	"Not changed.\n",
	"Generating complete succesfuly.\n",
	/*20*/
	"Seeks command file.\n",
	"Error in command file.\n",
	"NORMA'l end of configurator work.\n",
	"Error read file %s.\n",
	"Start-program of part %s exist, but part is absent.\n",
	"In regime \"File\" only one file of main part must be place in command line.\n",
	"Program NCN.EXE not found.\n",
	"In compiler option \"max\" not the same value for main part and %s.\n",
	"Length of name part %s more identifyer length.\n",
	"No config information for part %s.\n",
	/*30*/
	"All distributed parts must have equal number of processors.\n",
	"Call unknown part: %s.\n",
	"Found %d errors and %d warnings (filtered: %d). Correct, please!\n",
	"Check parameters calling part %s from part %s ...\n",
	"Wrong number of arguments.\n",
	"Wrong domain ranges in %d argument.\n",
	"Wrong type %d argument.\n",
	"Wrong domain shape in %d argument.\n",
	"Wrong range %d domain in %d argument.\n",
	"Wrong number IN-arguments.\n",
	/*40*/
	"Different boundary of range %d domain in %d argument.\n",
	"Different indexes of range %d domain in %d argument.\n",
	"Part %s - second DISTRIBUTION-part in chain of calling.\n",
	"DISTRIBUTED-part %s called from SCALAR-part %s.\n",
	"Not found formal parameters of part %s.\n",
	"Not found actual parameters of part %s.\n",
	"INCLUDE - file %s not found.\n",
	"Warnings: %d (filtered: %d).\n",
	"Unknown value of parameter %s.\n",
	"Unknown domain ranges in %d argument.\n",
	/*50*/
	"End part %s not found.\n",
	"Ignored obsolete option %s.\n",
	"Main part and %s compiled for not the same output language.\n",
	"Part %s without debug information.\n",
	"Part %s with debug information.\n",
	"Dimension %s at COMMON-block /%s/ have unknown range.\n",
	"Syntax error.\n",
	"Forbidden context calling of distributed subpart %s.\n",
	"Output file replace sousce.\n",
	"MPI_Init fuction not found at main part.\n",
	/*60*/
	};
char **message=message_eng;

static void SetLanguage(int lang)
{
	language = lang;
	if(language==1) message=message_rus;
	else message=message_eng;
}

/**********************************************************/

static void About(void)
{
	char bufkey[80];

	while(language==0)
	{
		printf("\nSelect language: English (E) or Russian (R): ");
		fgets(bufkey, 80, stdin);
		switch(bufkey[0])
		{
		case 'R':case 'r':
		case 0x1372:
		case 0x1352:language=1;break;
		case 'E':case 'e':
		case 0x1245:
		case 0x1265:language=2;
		}
	}

	if(language==1)
	{
		puts("\n        䨣 ணࠬ  몥   । ⥬.");
		printf("(c) 㣥 .. 㤠஢ ..   .     1.03  %s\n",__DATE__);
		puts("  䠩     ணࠬ    ࠭,  祭묨     १  ࠡ");
		puts("-࠭,  ந  (  ࠧ  믮) ᠭ 䨣樨 ");
		puts("⥪   ࠭.");
		puts(": normacnf [樨] < 䠩> [< 䠩2>...]");
		puts("     normacnf /p=< 䠩 ஥> [樨]");
		puts("     normacnf /f [樨] < 䠩  ࠧ>");
		puts("   /f - ᯮ짮 ० \"\"  ࠭樨 -ணࠬ\n");
		puts("ਬ: normacnf /d=program /s=2_2 cmc_51.for cmc_51_f.for\n");
		puts(" ENTER  த ...");
		fgets(bufkey, 80, stdin);
		puts("\n        樨 ( 㬮砭  , ᫨  ᪠ ⭮):");
		puts("      ------------------------------------------------------------\n");
		puts("/d=<६>    - ।  ६  ( ᯮ짮   ");
		puts("    䠩: ifdef, ifndef). ஬ ⮣, ६ 'program' 㪠뢠 䨣-");
		puts("     ந  ணࠬ  ᠭ  䨣樨, , ᫨  'program'  ");
		puts("    ।, ᠭ 䨣樨 ࠧ ᯮ.");
		puts("/s=<ᥪ>        -  ᥪ,  ன 㤥 믮 ணࠬ.");
		puts("/lq=< 2 | 3 >      -  LinkQuota.");
		puts("/full              -  FullHardNet.");
		puts("/l=<ᨬ쭠  䨪> -  㬮砭 32.");
		puts("/n=< 室 㫥> -     䠩   ᠭ 䨣樨, btl-");
		puts("    䠩  ..   㬮砭    ஥     ࢮ  䠩 ");
		puts("       ப");
		puts("/err               - ० ண ஢ન ࠬ஢ ࠧ,");
		puts("/incl              - ० ண ஢ન ࠬ஢  ࠧ,");
		puts("                     ᮤঠ   INCLUDE - 䠩,");
		puts("/dwr=<᪠>       - 䨫 ।०  ᪥,");
		puts("/dtl               - ஡   ࠬ ࠧ,");
		puts("/rus               - ᮮ饭  ᪮ 몥,");
		puts("/eng               - ᮮ饭  ᪮ 몥.");
		puts(" 㬮砭 ᯮ     ࠧ.");
	}
	else
	{
		puts("\n        Configurator of NORMA programs for distributed systems.");
		printf("  (c) Bugerya A.B. Koludarov P.I.  KIAM  version 1.03 build at %s\n",__DATE__);
		puts("The describe  of  configuration  and texts  of  tasks  on  Fortran  are  create");
		puts("from files that  maked  by  NORMA  translator.  Describe  of configuration also");
		puts("can immediately run.");
		puts("Run:   normacnf [options] <file name> [<file name2>...]");
		puts("  or   normacnf /p=<project file> [options]");
		puts("  or   normacnf /f [options] <file of main part>");
		puts("   /f - was switch \"FILE\" during translaton NORMA program\n");
		puts("Example: normacnf /d=program /s=2_2 cmc_51.for cmc_51_f.for\n");
		puts("Press ENTER to continue ...");
		fgets(bufkey, 80, stdin);
		puts("\n           Options (default is off if other is not sayed):");
		puts("      ------------------------------------------------------------");
		puts("/d=<variable>    - define variable (may be use in command file: ifdef, ifndef).");
		puts("    Variable 'program' define configurator generate describe  of configuration.");
		puts("    Otherwise if 'program' not define describe is immediately run.");
		puts("/s=<section>       - Machine section to run program.");
		puts("/lq=< 2 | 3 >      - Switch 'LinkQuota'.");
		puts("/full              - Switch 'FullHardNet'.");
		puts("/l=<identifier length> - 32 by default.");
		puts("/n=<output name>   - Name for file with describe of configuration, btl-file and");
		puts("         other. By default it is name of the project or name of the first file.");
		puts("/err               - permissive checking parameters of parts,");
		puts("/incl              - permissive checking parameters for parts,");
		puts("                         containing not found INCLUDE - files,");
		puts("/dwr=<mask>        - disable warnings by mask,");
		puts("/dtl               - print detail about parameters of parts,");
		puts("/rus               - Russian language,");
		puts("/eng               - English language.");
		puts("The default language is the language of the main part.");
	}
}

/**********************************************************/

/*    */
static void PrintFileLine(CNFFILE *f, STRINGS *s)
{
	char* name=NULL;
	long line=0;
	int i;

	if(f)
	{
		name = f->filename;
		line = f->line;
	}
	if(s) GetFileLine(s, &name, &line);

	if(name)
	{
		if(bUserInterface) printf("(%ld 0 \"%s\" \"\")", line, name);
		else
		{
			for(i=strlen(name)-1; i>0; i--)
				if(name[i]==DIR_SEPARATOR) { name = &name[i+1]; break; }
			printf("%s:%ld ", name, line);
		}
	}
}

void CnfPrintError(CNFFILE *f, STRINGS *s, BOOL IsErr, int MssgCode, va_list ptrarg)
{
	if(IsErr) nErrors++;
	else
	{
		int CodeMask;
		switch(MssgCode)
		{
		case 29: CodeMask=0x0100; break; /* .*/
		case 44: CodeMask=0x0200; break; /*  */
		case 45: CodeMask=0x0400; break; /*  */
		case 46: CodeMask=0x0800; break; /* . */
		case 48: CodeMask=0x1000; break; /*   */
		default: CodeMask=0;
		}
		if(WarningMask&CodeMask)
		{
			nDisWarnings++;
			return;
		}
		nWarnings++;
	}

	if((f || s) && bUserInterface)
	{/*      */
		PrintFileLine(f, s);
		printf("\n");
		vprintf(message[MssgCode], ptrarg);
		if(IsErr) printf("END OF ERROR\n");
		else printf("END OF WARNING\n");
	}
	else
	{
		if(IsErr) printf("--- ");
		else printf("*** ");

		PrintFileLine(f, s);
		vprintf(message[MssgCode], ptrarg);
	}
}

void CnfError(STRINGS *s, int MssgCode, ...)
{
	va_list ptrarg;
	va_start(ptrarg, MssgCode);

	CnfPrintError(NULL, s, TRUE, MssgCode, ptrarg);

	va_end(ptrarg);
}

void CnfWarning(STRINGS *s, int MssgCode, ...)
{
	va_list ptrarg;
	va_start(ptrarg, MssgCode);

	CnfPrintError(NULL, s, FALSE, MssgCode, ptrarg);

	va_end(ptrarg);
}

void CnfNfErr(STRINGS *s, int MssgCode, ...)
{
	va_list ptrarg;
	va_start(ptrarg, MssgCode);

	CnfPrintError(NULL, s, !bFatalErr, MssgCode, ptrarg);

	va_end(ptrarg);
}

void CnfExitSay(CNFFILE *f, STRINGS *s, int MssgCode, ...)
{

	va_list ptrarg;
	va_start(ptrarg, MssgCode);

	CnfPrintError(f, s, TRUE, MssgCode, ptrarg);

	va_end(ptrarg);

	printf(message[32], nErrors, nWarnings, nDisWarnings);
	exit(1);
}

void CnfInfDestroyed(STRINGS *s)
{
	CnfExitSay(NULL, s, 4, strCurrentPart);
}

void OutOfMemory(void) { CnfExitSay(NULL, NULL, 1); }
void ErrWrite(void) { CnfExitSay(NULL, NULL, 0); }

/**********************************************************/
/*    */

static void PrntParamError(CALLPART *fcall, CALLPART *acall, char* partname,
		BOOL IsErr, int MssgCode, int n_set, int n_param)
{
	int n;
	PARAM *frm, *fkt;
	if(IsErr) nErrors++;
	else
	{
		int CodeMask;
		switch(MssgCode)
		{
		case 49: CodeMask=0x0001; break; /*  */
		case 41: CodeMask=0x0002; break; /*  */
		case 40: CodeMask=0x0004; break; /*  */
		case 36: CodeMask=0x0008; break; /* */
		case 35: CodeMask=0x0010; break; /*  */
		case 37: CodeMask=0x0020; break; /*  */
		case 38: CodeMask=0x0040; break; /*  */
		case 39: CodeMask=0x0080; break; /*  IN*/
		default: CodeMask=0;
		}
		if(!bPrintDetail && WarningMask&CodeMask)
		{
			nDisWarnings++;
			return;
		}
		nWarnings++;
	}

	PrintPartNames(fcall->name,  partname);

	if(!bUserInterface)
	{
		if(IsErr) printf("--- ");
		else printf("*** ");
		printf("%s:%ld ", acall->filename, acall->line);
	}
	else printf("(%ld %ld \"%s\" \"%s\")\n",
			acall->line, fcall->line, acall->filename, fcall->filename);

	if(n_param<1) printf(message[MssgCode]);
	else if(n_set<1) printf(message[MssgCode], n_param);
		else printf(message[MssgCode], n_set, n_param);

	frm=fcall->parameters;
	fkt=acall->parameters;
	for(n=1; n<=n_param; n++)
	{
		if(n==n_param) Print2Param(frm, fkt);
		frm=frm->next;
		fkt=fkt->next;
	}

	if(bUserInterface)
	{
		if(IsErr) printf("END OF ERROR\n");
		else printf("END OF WARNING\n");
	}
}

void CnfParamError(CALLPART *fcall, CALLPART *acall, char* partname, int MssgCode, int n_set, int n_param)
{
	PrntParamError(fcall, acall, partname, TRUE, MssgCode, n_set, n_param);
}

void CnfParamWarning(CALLPART *fcall, CALLPART *acall, char* partname, int MssgCode, int n_set, int n_param)
{
	PrntParamError(fcall, acall, partname, FALSE, MssgCode, n_set, n_param);
}

void CnfParamNfErr(CALLPART *fcall, CALLPART *acall, char* partname, int MssgCode, int n_set, int n_param)
{
	PrntParamError(fcall, acall, partname, !bFatalErr, MssgCode, n_set, n_param);
}

/**********************************************************/

#ifdef _WIN32

static char *realpath(const char *path, char *resolved_path)
{
	strcpy(resolved_path, path);

	return resolved_path;
}

#endif

#ifdef _WIN32
#define IS_DISK_SEPARATOR(c) (c == ':')
#else
#define IS_DISK_SEPARATOR(c) FALSE
#endif


static BOOL IsDirOrDiskSeparator(char c)
{
	return(IS_DISK_SEPARATOR(c) || c == DIR_SEPARATOR);
}

FILE *OpenTmpFile(char *start_path, char *mode)
{
	FILE *f;
#ifdef _WIN32
	char* tmpname = _tempnam(start_path, "hop");
	strcpy(start_path, tmpname);
	f = fopen(tmpname, mode);
#else
	strcat(start_path, "XXXXXX");
/* mode dummed because UNIX has only BIN mode */
	f = fdopen(mkstemp(start_path), "w");
#endif
	if(f == NULL) ErrWrite();
	return f;
}

/**********************************************************/
static BOOL mysearchpath(char *str, const char *filename)
{
	const char *s;
	int i=0,j=0;

	s=getenv("PATH");
	while(s[i])
	{
		while((s[i] != ':') && (s[i] != 0)) i++;
		if(i>j) /* The next item in the path */
		{
			memcpy(str, &s[j], i-j);
			str[i-j]=DIR_SEPARATOR;
			strcpy(&str[i-j+1], filename);
			if(access(str, 0) == 0) return TRUE;
			if(s[i]) i++;
			else break;
			j=i;
		}
	}
	return FALSE;
}
/**********************************************************/
/*   normalib  */
static void LibFileName(char* filename, char* argv)
{
	int k;
	/*     */
	strcpy(filename, argv);
	k=strlen(filename);
	while(k>0 && filename[k]!=DIR_SEPARATOR) k--;
	if(filename[k] == DIR_SEPARATOR) k++;
	/*  PATH*/
	if(k == 0)
	{
		if(mysearchpath(filename, argv))
		{
			k=strlen(filename);
			while(k>0 && filename[k]!=DIR_SEPARATOR) k--;
			if(filename[k] == DIR_SEPARATOR) k++;
		}
	}
	filename[k]=0;
	/*  */
	strcat(filename,"normalib.");
	/*    */
	if(C_OUT) strcat(filename,"c");
	else strcat(filename,"for");
}
/**********************************************************/
/* ,      */
CNFFILE *cnf_open(const char *filename, const char *mode)
{
	CNFFILE *f;
	FILE *file;
	file = myfopen(filename, mode);
	if(file == NULL) return NULL;

	f = (CNFFILE*)mymalloc(sizeof(CNFFILE));
	if(f == NULL) OutOfMemory();

	strcpy(f->filename, filename);
	f->line = 0;
	f->file = file;
	return f;
}

char *cnf_gets(char *s, int n, CNFFILE *f)
{
	int i;
	BOOL ns;
	if(fgets(s,n,f->file)==NULL) return NULL;
	f->line++;
	i=strlen(s);
	if(i==0) return s;
	/*    */
	i--;
	ns = (s[i]=='\n');

	while(i>=0 && (s[i]==' ' || s[i]=='\n'|| s[i]=='\t')) i--;

	i++;
	if(s[i] == ' ' || s[i]=='\t')
	{
		if(ns) {s[i]='\n'; i++;}
		s[i]=0;
	}
	return s;
}

static char *cnf_getsCRC(char *s, int n, CNFFILE *f, long*crc)
{
	int i,j;
	BOOL ns;
	if(fgets(s,n,f->file)==NULL) return NULL;
	f->line++;
	i=strlen(s);
	j=i;
	while(j>0)
	{
		j--;
		switch(s[j])
		{
		case'\r':
			continue;
		case'\n':
			(*crc)+=13;
			break;
		case'\t':
			(*crc)+=' ';
			break;
		default:
			(*crc)+=(unsigned char)s[j];
		}
	}

	if(i==0) return s;
	/*    */
	i--;
	ns = (s[i]=='\n');
	while(i>=0 && (s[i]==' ' || s[i]=='\n' || s[i]=='\r' || s[i]=='\t')) i--;
	i++;
	if(s[i] == ' ' || s[i]=='\t' || s[i]=='\r')
	{
		if(ns) {s[i]='\n'; i++;}
		s[i]=0;
	}
	return s;
}

int cnf_close(CNFFILE *f)
{
	int a = myfclose(f->file);
	myfree(f);
	return a;
}
/***************************************************************/
/*  (    )*/
BOOL CompareNames(const char *name1, const char *name2)
{
	int len1, len2;

	len1=strlen(name1);
	if(len1 > nIdentifierLength)
		len1=nIdentifierLength;
	if(len1>0 && name1[len1-1]=='\n')
		len1--;

	len2=strlen(name2);
	if(len2 > nIdentifierLength)
		len2=nIdentifierLength;
	if(len2>0 && name2[len2-1]=='\n')
		len2--;

	if(len1 != len2)
		return FALSE;

	if(C_OUT)
		return(strncmp(name1, name2, len1)==0);
	else
		return(strnicmp(name1, name2, len1)==0);
}

int IsCnfString(const char *s, int n)
{
	if(strncmp(&s[7], s_strings_e[n], strlen(s_strings_e[n])) == 0) return 2;
	if(strncmp(&s[7], s_strings_r[n], strlen(s_strings_r[n])) == 0) return 1;
	return 0;
}

char* GetDistrName(char *s, int j)
{
	return(&s[8+strlen(s_strings_r[3])*(j==1)+strlen(s_strings_e[3])*(j==2)]);
}

/**********************************************************/
static void FreeSends(RASPR *beg)
{
	SENDS *tek,*pred;

	tek=beg->s;
	if(tek!=(SENDS*)1) while(tek)
	{
		pred=tek;
		tek=tek->next;
		myfree(pred);
	}
	beg->s=NULL;
}

static void FreeDefines(DEFINES *beg)
{
	DEFINES *tek;
	while(beg)
	{
		tek=beg;
		beg=beg->next;
		myfree(tek->name);
		myfree(tek);
	}
}

static void FreeFiles(FILES *beg)
{
	FILES *tek;
	while(beg)
	{
		tek=beg;
		beg=beg->next;
		myfree(tek->name);
		myfree(tek);
	}
}

static void FreeStrings(STRINGS *beg)
{
	STRINGS *tek;
	while(beg)
	{
		tek=beg;
		beg=beg->next;
		myfree(tek->s);
		myfree(tek);
	}
}

/***************************************************************/

static void end_of_scal(HIERARHY *p, char *name)
{
	STR *tek;

	for(tek=p->scal; tek; tek=tek->next)
	{
		if(CompareNames(tek->name, name))
		{
			tek->see_now=FALSE;
			return;
		}
	}
}

/*      */
static STR* get_last_scal(HIERARHY *p)
{
	STR *tek=p->scal;
	if(tek==NULL) return NULL;
	while(tek->next!=NULL) tek=tek->next;
	return tek;
}

/*   */
static int AddPart(HIERARHY *p, char *name, FILES *pred_file, BOOL without_config_info, BOOL insert_debug_info)
{
	STR *next_scal, *nov;

	next_scal = p->scal;
	while(next_scal)
	{
		if(CompareNames(next_scal->name, name))
			return(1+(next_scal->see_now==TRUE));

		if(next_scal->next == NULL)
			break;

		next_scal=next_scal->next;
	}

	nov = (STR*)mycalloc(sizeof(STR), 1);
	if(nov==NULL) OutOfMemory();

	nov->next=NULL;
	nov->see_now=TRUE;
	nov->where=pred_file;
	nov->without_config_information=without_config_info;
	if(without_config_info)
		nov->where->exists_without_config=TRUE;
	nov->insert_debug_info = (pred_file->is_user_file && bDebug &&
		bDebugFortran && (insert_debug_info || without_config_info));
	strcpy(nov->name, name);
	if(next_scal) next_scal->next=nov;
	else p->scal=nov;
	return 0;
}

/**********************************************************/
/*   .     ..*/
char* GetNextInfStr(STRINGS **nov)
{
	if((*nov)->next==NULL) CnfInfDestroyed(*nov);
	*nov = (*nov)->next;
	return(*nov)->s;
}

/**********************************************************/

/*     header-  NULL
        */
STRINGS* ReadHeaderFile(char*filename)
{
	static STRINGS *head_last_str=NULL;
	static long nCurHeadLine=-1;

	FILES *tek_file, *next_file;
	STRINGS *nov;
	CNFFILE *fi;
	char strbuf[MAX_STR_LEN];

	next_file = head_file;
	while(next_file)
	{
		//     
		if(strcmp(next_file->name, filename) == 0)
			return next_file->sFirstStr;

		next_file=next_file->next;
	}

	tek_file=mymalloc(sizeof(FILES));
	if(tek_file==NULL)
		OutOfMemory();

	tek_file->name=mymalloc(strlen(filename)+1);
	if(tek_file->name==NULL)
		OutOfMemory();

	strcpy(tek_file->name, filename);
	tek_file->next=NULL;
	tek_file->exists_without_config=FALSE;
	tek_file->sFirstStr=NULL;
	tek_file->is_user_file = TRUE;
	tek_file->crc = 0;

	if(head_file==NULL)
	{
		head_file=tek_file;
	}
	else
	{
		next_file=head_file;
		while(next_file->next) next_file=next_file->next;
		next_file->next = tek_file;
	}

	fi = cnf_open(filename,"rt");
	if(fi==NULL)
		return NULL;

	while(cnf_getsCRC(strbuf, MAX_STR_LEN, fi, &(tek_file->crc)))
	{
		nov=(STRINGS*)mycalloc(sizeof(STRINGS),1);
		if(nov==NULL)
			OutOfMemory();
		if(tek_file->sFirstStr == NULL)/*    */
			tek_file->sFirstStr = nov;

		if((nov->s=mymalloc(strlen(strbuf)+1))==NULL)
			OutOfMemory();
		strcpy(nov->s, strbuf);
		nov->num=nCurHeadLine--;

		if(head_string==NULL) head_string=nov;
		else head_last_str->next=nov;
		head_last_str=nov;
	}
	cnf_close(fi);

	return tek_file->sFirstStr;
}

/**********************************************************/

void ReadSourceFile(char *name, BOOL bIsUserFile)
{
	static STRINGS *source_last_str=NULL;
	static long nCurrentLine=0;

	STRINGS *nov, *sFirstStr=NULL;
	FILES *tek_file, *next_file;
	CNFFILE *f;
	long crc = 0;
	char strbuf[MAX_STR_LEN];

	if((f=cnf_open(name,"rt"))==NULL)
	{
		if(bIsUserFile) CnfExitSay(NULL, NULL, 7, name);
		CnfWarning(NULL, 7, name);
		return;
	}

	/*    */
	while(cnf_getsCRC(strbuf, MAX_STR_LEN, f, &crc))
	{
		if((nov=(STRINGS*)mycalloc(sizeof(STRINGS),1))==NULL)
			OutOfMemory();
		if(sFirstStr == NULL)/*    */
			sFirstStr = nov;

		if((nov->s=mymalloc(strlen(strbuf)+1))==NULL)
			OutOfMemory();
		strcpy(nov->s, strbuf);
		nov->num=nCurrentLine++;
		if(src_string==NULL) src_string=nov;
		else source_last_str->next=nov;
		source_last_str=nov;
	}
	cnf_close(f);

	if((tek_file=mymalloc(sizeof(FILES)))==NULL)
		OutOfMemory();

	if((tek_file->name=mymalloc(strlen(name)+1))==NULL)
		OutOfMemory();

	strcpy(tek_file->name,name);
	tek_file->next=NULL;
	tek_file->exists_without_config=FALSE;
	tek_file->sFirstStr=sFirstStr;
	tek_file->is_user_file = bIsUserFile;
	tek_file->crc = crc;

	if(src_file==NULL)
	{
		src_file=tek_file;
	}
	else
	{
		next_file=src_file;
		while(next_file->next) next_file=next_file->next;
		next_file->next = tek_file;
	}
}

/*    s*/
FILES *GetFiles(STRINGS *s)
{
	FILES *tek_file, *next_file;
	if(s->num<0) /*header*/
	{
		tek_file=head_file;
		for(next_file=tek_file->next; next_file!=NULL; next_file=next_file->next)
		{
			if(next_file->sFirstStr == NULL)
				continue;

			if(next_file->sFirstStr->num < s->num) break;
			tek_file=next_file;
		}
	}
	else /*source*/
	{
		tek_file = src_file;
		for(next_file=tek_file->next; next_file!=NULL; next_file=next_file->next)
		{
			if(next_file->sFirstStr == NULL)
				continue;

			if(next_file->sFirstStr->num > s->num) break;
			tek_file=next_file;
		}
	}

	return tek_file;
}

/*       s*/
BOOL GetFileLine(STRINGS *s, char** name, long *line)
{
	FILES *tek_file = GetFiles(s);
	*name = tek_file->name;
	if(s->num<0) /*header*/
		*line = 1 - (s->num - tek_file->sFirstStr->num);
	else /*source*/
		*line = s->num - tek_file->sFirstStr->num + 1;
	return TRUE;
}

/*       s*/
long GetStringLine(STRINGS *s)
{
	if(s->num<0) /*header*/
		return 1 - (s->num - GetFiles(s)->sFirstStr->num);
	else /*source*/
		return s->num - GetFiles(s)->sFirstStr->num + 1;
}

/**********************************************************/

static BOOL Option(const char *arg, const char *sample, BOOL bPrecisely)
{
	int len;

	if(arg[0]!='-' && arg[0]!='/')
		return FALSE;

	len=strlen(sample);
	if(strnicmp(&arg[1], sample, len) != 0)
		return FALSE;

	if(bPrecisely && arg[len+1]!=0)
		return FALSE;

	return TRUE;
}

/*   ,  */
static BOOL ProcessCommandLine(int argc, char **argv)
{
	int pos;
	int nOutIndex=0, nProjectIndex=0;
	DEFINES *tek_def=NULL;

	if(argc<2 || (argc==2 && Option(argv[1],"?",TRUE)))
	{
		About();
		return FALSE;
	}

	pos=1;
	if(Option(argv[1],"f",TRUE))
	{
		bFileMode=TRUE;
		pos=2;
	}
	for(; pos<argc; pos++)
	{
		if(Option(argv[pos],"d=",FALSE))
		{
			DEFINES *nov_def;
			nov_def=mymalloc(sizeof(DEFINES));
			if(nov_def==NULL) OutOfMemory();
			nov_def->name=mymalloc(strlen(argv[pos])-2);
			if(nov_def->name==NULL) OutOfMemory();
			nov_def->next=NULL;
			strcpy(nov_def->name, &argv[pos][3]);

			if(first_def) tek_def->next=nov_def;
			else first_def=nov_def;
			tek_def=nov_def;
			continue;
		}
		if(Option(argv[pos],"out=",FALSE))
		{
			/*  -   */
			int fd_out;
			bUserInterface = TRUE;
			close(fileno(stderr));
			fd_out = open(&argv[pos][5], O_WRONLY | O_CREAT | O_TRUNC,
				S_IREAD|S_IWRITE);
			dup2(fd_out,fileno(stdout));
			continue;
		}
		if(Option(argv[pos],"l=",FALSE))
		{
			if(sscanf(&argv[pos][3], "%d", &nIdentifierLength)<1)
				CnfExitSay(NULL, NULL, 8, argv[pos]);
			if(nIdentifierLength>MAX_INDENT_LEN-1) nIdentifierLength=MAX_INDENT_LEN-1;
			continue;
		}
		if(Option(argv[pos],"n=",FALSE))
		{
			nOutIndex=pos;
			continue;
		}
		if(Option(argv[pos],"p=",FALSE) && nProjectIndex==0)
		{
			CNFFILE *fsrc;
			nProjectIndex=pos;
			if((fsrc=cnf_open(&argv[pos][3],"rt"))==NULL)
				CnfExitSay(NULL, NULL, 9, &argv[pos][3]);
			realpath(&argv[pos][3], strOutPath);

			nLenOutPath=strlen(strOutPath);
			while(nLenOutPath>0 &&
				!IsDirOrDiskSeparator(strOutPath[nLenOutPath])) nLenOutPath--;
			if(nLenOutPath>0) nLenOutPath++;
			while(cnf_gets(&strOutPath[nLenOutPath],80,fsrc))
			{
				int len=strlen(strOutPath);
				if(len>0 && strOutPath[len-1]==10) strOutPath[--len]=0;
				if(strOutPath[len-1]==DIR_SEPARATOR) continue;
				/*   */
				if(strOutPath[nLenOutPath] == DIR_SEPARATOR ||
					IS_DISK_SEPARATOR(strOutPath[nLenOutPath+1]))
						ReadSourceFile(&strOutPath[nLenOutPath], TRUE);
				else ReadSourceFile(strOutPath, TRUE);
			}
			cnf_close(fsrc);
			continue;
		}
		if(Option(argv[pos],"s=",FALSE)) { section_number=pos;continue;}
		if(Option(argv[pos],"lq=",FALSE)) { linkquota=argv[pos][4]-'0';continue;}
		if(Option(argv[pos],"full",TRUE)) { fullhardnet=1;continue;}
		if(Option(argv[pos],"eng",TRUE)) { SetLanguage(2);continue;}
		if(Option(argv[pos],"rus",TRUE)) { SetLanguage(1);continue;}
		if(Option(argv[pos],"err",TRUE)) { bFatalErr=TRUE; continue;}
		if(Option(argv[pos],"incl",TRUE)) { bNoInclude=TRUE; continue;}
		if(Option(argv[pos],"dtl",TRUE)) { bPrintDetail=TRUE; continue;}
		if(Option(argv[pos],"dwr=",FALSE))
		{
			if(sscanf(&argv[pos][5], "%d", &WarningMask)<1)
				CnfExitSay(NULL, NULL, 8, argv[pos]);
			continue;
		}
		if(Option(argv[pos],"debug",TRUE)) {bDebugFortran = TRUE; continue;}
		if(Option(argv[pos],"nodebug",TRUE)) {bDebugFortran = FALSE; continue;}
		/*  -   */
		if(Option(argv[pos],"pvm",TRUE) || Option(argv[pos],"mpi",TRUE) ||
		Option(argv[pos],"c",TRUE) || Option(argv[pos],"mpic",TRUE) ||
		Option(argv[pos],"proc=",FALSE))
		{
			CnfWarning(NULL, 51, argv[pos]);
			continue;
		}

		if(bFileMode && src_file) CnfExitSay(NULL, NULL, 25);
		ReadSourceFile(argv[pos], TRUE);
	}

	if(src_file==NULL)
	{
		About();
		return FALSE;
	}

	if(nOutIndex>0)
	{
		if((argv[nOutIndex][3] == DIR_SEPARATOR) ||
			(isalpha(argv[nOutIndex][3]) && (argv[nOutIndex][4] == ':')))/*Full path*/
		{
			strcpy(strOutPath, &argv[nOutIndex][3]);
		}
		else
		{
			int nLen;
			getcwd(strOutPath, MYMAXPATH);

			nLen=strlen(strOutPath);
			strOutPath[nLen]=DIR_SEPARATOR;
			strOutPath[nLen+1]=0;
			strcat(strOutPath, &argv[nOutIndex][3]);
		}
	}
	else if(nProjectIndex>0)
	{
		realpath(&argv[nProjectIndex][3], strOutPath);
	}
	else
	{
		realpath(src_file->name, strOutPath);
	}

	/*    */
	pos = strlen(src_file->name)-1;
	if(src_file->name[pos]>='A' && src_file->name[pos]<='Z')
		bUppercaseExt = TRUE;

	/* ,        */
	bUserOutName = (nOutIndex>0 || nProjectIndex>0);

	return TRUE;
}

/**********************************************************/

/*   ; mainpart -   */
static BOOL ReadCompOptions(char* s, BOOL mainpart)
{
	OUT_FILE_TYPE outlang;
	int n, offset=16;

	if(strncmp(s, "C $DIR OPTIONS: ", offset)!=0) return FALSE;
/*  */
	if(strncmp(&s[offset],"mpi ",4)==0) {outlang=FMPI;offset+=4;}
	else if(strncmp(&s[offset],"gns ",4)==0) {outlang=GNS;offset+=4;}
	else if(strncmp(&s[offset],"pvm ",4)==0) {outlang=PVM;offset+=4;}
	else if(strncmp(&s[offset],"pvm-p ",6)==0) {outlang=PVM;offset+=6;}
	else if(strncmp(&s[offset],"f-77 ",5)==0) {outlang=F77;offset+=5;}
	else if(strncmp(&s[offset],"c ",2)==0) {outlang=C;offset+=2;}
	else if(strncmp(&s[offset],"c-mpi ",6)==0) {outlang=CMPI;offset+=6;}
	else return FALSE;

	if(mainpart) out_file_type = outlang;
	else if(out_file_type != outlang) CnfError(NULL, 52, strCurrentPart);

/**/
	if(strncmp(&s[offset],"debug ",6)==0) {n=1;offset+=6;}
	else if(strncmp(&s[offset],"nodebug ",8)==0) {n=0;offset+=8;}
	else return FALSE;

	if(mainpart) bDebug = n;
	else if(bDebug != n)
		CnfError(NULL, n?54:53, strCurrentPart);

/**/
	if(strncmp(&s[offset],"max=",4)!=0) return FALSE;
	if(sscanf(&s[offset+4],"%d",&n)!=1) return FALSE;

	if(mainpart) how_processors = n;
	else if(how_processors != n && out_file_type == GNS)
		CnfError(NULL, 27, strCurrentPart);

/*     */
	if(mainpart)
	{
		if(!bDebug || outlang!=FMPI)
			bDebugFortran = FALSE;
	}

	return TRUE;
}

/*  . .     */
static SUBROUTINE* ReadSubList(STRINGS **nov)
{
	int len;
	SUBROUTINE *first_razd=NULL, *next_razd, *last_razd=NULL;
	char *strbuf;

	while(TRUE)
	{
		strbuf = (*nov)->s;
		if(strcmp(&strbuf[7], "send:\n") == 0) break;
		if(IsCnfString(strbuf, 2) !=0 ) break;

		next_razd = mymalloc(sizeof(SUBROUTINE));
		if(next_razd==NULL) OutOfMemory();
		next_razd->next=NULL;
		next_razd->formal=NULL;
		//  
		len = strlen(&strbuf[7]);
		next_razd->name = mymalloc(len+1);
		if(next_razd->name == NULL) OutOfMemory();
		strcpy(next_razd->name, &strbuf[7]);
		if(next_razd->name[len-1] == '\n')
			next_razd->name[len-1]='\0';
		if(next_razd->name[0] == 0) CnfInfDestroyed(*nov);

		if(first_razd==NULL) first_razd = next_razd;
		else last_razd->next=next_razd;
		last_razd=next_razd;
		
		GetNextInfStr(nov);
		last_razd->actual=ReadParam(nov, last_razd->name);

		if(last_razd->actual==NULL)
			last_razd->actual=FindActual(last_razd->name, *nov);

		if(bUserInterface) printf("<C %s>\n", last_razd->name);
	}
	return first_razd;
}

/***********************************************************/
/*   -,     */
/***********************************************************/
static void MakeCallTree(SUBROUTINE *this_razd, HIERARHY *parent, char *prec)
{
	/* DISTRIBUTION */
	static BOOL bDistribution = FALSE;
	static HIERARHY *last_hi=NULL;

	SUBROUTINE *beg_razd=NULL;
	STR *this_scal;
	STRINGS *nov_string;
	BOOL insert_debug_info = FALSE;
	int myi, myj;
	BOOL without_config_info;
	char PartFileName[MYMAXPATH]; /*   */
	long PartLine; /*    */
	int part_type; /*  0- 1-distribution 2-distributed*/
	char treetype;
	RASPR *nov_raspr;


/*       */
	int len=strlen(this_razd->name);
	if(len>nIdentifierLength) CnfExitSay(NULL, NULL, 28, this_razd->name);

	strcpy(strCurrentPart, this_razd->name);
	if(bFileMode)  /*   ''  */
	{
		strcpy(&strOutPath[nLenOutPath], this_razd->name);
		strcat(strOutPath, ".for");
		ReadSourceFile(strOutPath, TRUE);
	}
	without_config_info=FALSE;

	nov_string = src_string;
	while(nov_string)
	{
		int lang = IsCnfString(nov_string->s, 1);
		if(lang!=0 && nov_string->next!=NULL &&
			CompareNames(&nov_string->next->s[12+2*(lang==1)], this_razd->name)) break;
		nov_string=nov_string->next;
	}
	if(nov_string==NULL)/*   config-*/
	{
		nov_string=src_string;
		while(nov_string)
		{
			if(IsThisFuncOrSub(nov_string->s,this_razd->name))
			{
				without_config_info=TRUE;
				break;
			}
			nov_string=nov_string->next;
		}
		if(nov_string==NULL) CnfExitSay(NULL, NULL, 2, this_razd->name);
	}
	else/*  .  */
	{
		GetNextInfStr(&nov_string);
		GetNextInfStr(&nov_string);
		/*   */
		if(ReadCompOptions(nov_string->s,FALSE))
			GetNextInfStr(&nov_string);
		else insert_debug_info = TRUE;
		/*   */
		this_razd->formal=ReadParam(&nov_string, this_razd->name);
	}

	/*      */
	if(this_razd->formal==NULL)
		this_razd->formal = FindFormal(this_razd->name, nov_string);
	/* */
	if(this_razd->actual!=NULL)
	{
		if(this_razd->formal!=NULL)
			CompareParam(this_razd->formal, this_razd->actual, prec);
		FreeCalls(this_razd->actual);
	}

	if(this_razd->formal!=NULL)
	{
		strcpy(PartFileName, this_razd->formal->filename);
		PartLine = this_razd->formal->line;
		FreeCalls(this_razd->formal);
	}
	else
	{
		PartFileName[0] = 0;
		PartLine = 0;
	}

	if(without_config_info)
	{
		switch(AddPart(parent, this_razd->name, GetFiles(nov_string), TRUE, TRUE))
		{
		case 0: break; /*   ,   */
		case 1: return;/*   */
		default: CnfExitSay(NULL, NULL, 3, this_razd->name);
		}
		end_of_scal(parent, this_razd->name);/*   */
		CnfWarning(nov_string, 29, this_razd->name);
		if(bUserInterface) printf("<I %s><%ld %s>\n<E %s>\n",
			this_razd->name, PartLine, PartFileName, this_razd->name);
		return;
	}

	if(last_hi == NULL)
		last_hi=&begin_hi;

	if(strcmp("proc: distributed\n", &nov_string->s[7])==0)
	{
	/* DISTRIBUTED- */
		if (!bDistribution) CnfExitSay(NULL, NULL, 43, this_razd->name, prec);
		part_type=2;
		switch(AddPart(parent, this_razd->name, GetFiles(nov_string), FALSE, insert_debug_info))
		{
		case 0: break; /*   ,   */
		case 1: return;/*   */
		default: CnfExitSay(NULL, NULL, 3, this_razd->name);
		}
		nov_raspr=parent->raspr;
	}
	else if(strcmp("proc:\n", &nov_string->s[7])==0)
	{
	/*  */
		part_type=0;
		switch(AddPart(parent, this_razd->name, GetFiles(nov_string), FALSE, insert_debug_info))
		{
		case 0: break; /*   ,   */
		case 1: return;/*   */
		default: CnfExitSay(NULL, NULL, 3, this_razd->name);
		}
		nov_raspr=parent->raspr;
	}
	else
	{
	/**/
		static RASPR *endraspr=NULL;
		char raspr_name[MAX_INDENT_LEN];
		HIERARHY *next_hi;
		int smesi, smesj;
		int lang;

		FILES* pred_file = GetFiles(nov_string);
		if(bDistribution) CnfExitSay(NULL, NULL, 42, this_razd->name);
		bDistribution = TRUE;
		part_type=1;

		if(sscanf(&nov_string->s[7],"proc: %d+%d,%d+%d",
				&myi,&smesi,&myj,&smesj)<4) CnfInfDestroyed(nov_string);
		GetNextInfStr(&nov_string);
		lang=IsCnfString(nov_string->s, 3);
		if(lang==0) CnfInfDestroyed(nov_string);
		strcpy(raspr_name, GetDistrName(nov_string->s, lang));

		len=strlen(raspr_name);
		if(len<2) CnfInfDestroyed(nov_string);
		raspr_name[len-1]=0;
		if(len-1>nIdentifierLength) CnfExitSay(NULL, NULL, 28, raspr_name);

		/*  */
		for(next_hi = &begin_hi; next_hi; next_hi=next_hi->next)
		{
			if(CompareNames(next_hi->mainname, raspr_name))
				CnfExitSay(NULL, NULL, 3, raspr_name);
		}

		AddPart(parent, this_razd->name, pred_file, FALSE, insert_debug_info);

		nov_raspr=(RASPR *)mycalloc(sizeof(RASPR), 1);
		if(nov_raspr==NULL) OutOfMemory();
		strcpy(nov_raspr->name, raspr_name);
		nov_raspr->in=smesi+1;
		nov_raspr->jn=smesj+1;
		nov_raspr->i=myi;
		nov_raspr->j=myj;
		myi+=smesi;
		myj+=smesj;
		if(begraspr) endraspr->next=nov_raspr;
		else begraspr=nov_raspr;
		endraspr=nov_raspr;
		if(bFileMode)  /*   ''  */
		{
			strcpy(&strOutPath[nLenOutPath], raspr_name);
			strcat(strOutPath, ".for");
			ReadSourceFile(strOutPath, TRUE);
		}
		/*       */
		last_hi->next=(HIERARHY*)mycalloc(sizeof(HIERARHY),1);
		if(last_hi->next==NULL) OutOfMemory();
		last_hi=last_hi->next;
		strcpy(last_hi->mainname,raspr_name);
		last_hi->raspr=endraspr;
		last_hi->where=pred_file;
	}

	/*       */

	if(part_type == 1) treetype = 'D'; /*distribution*/
	else if(part_type == 2) treetype = 'T'; /*distributed*/
	else if(!insert_debug_info) treetype = 'S'; /*-*/
	else treetype = 'F'; /*-*/
	if(bUserInterface) printf("<%c %s><%ld %s>\n",
		treetype, this_razd->name, PartLine, PartFileName);

	/*      */
	GetNextInfStr(&nov_string);
	beg_razd = ReadSubList(&nov_string);

	if(bUserInterface) printf("<E %s>\n", this_razd->name);
	GetNextInfStr(&nov_string);
	while(nov_raspr && nov_raspr->s!=(SENDS*)1 && IsCnfString(nov_string->s, 2)==0)
	{
		SENDS *nov_send, *end_send=NULL, *temp_send;
		char *pStrBuf = &nov_string->s[7];

		if(strcmp(pStrBuf, "all\n")==0)
		{
			FreeSends(nov_raspr);
			nov_raspr->s=(SENDS*)1;
			break;
		}
		myi=myj=30000;
		if(sscanf(pStrBuf, "%d,%d",&myi,&myj)<2)
			if(sscanf(pStrBuf, "%d all",&myi)<1)
				if(sscanf(pStrBuf, "all %d",&myj)<1)
					CnfInfDestroyed(nov_string);

		if(myi<0)
		{
			/*myi  >0,     */
			myi=-myi;
			myj=-myj;
		}
		else if(myi==0 && myj<0)
		{
			myj=-myj;
		}
		nov_send=nov_raspr->s;
		while(nov_send)
		{
			if((nov_send->i==myi && nov_send->j==myj) ||/* */
				(nov_send->i==30000 && nov_send->j==myj) ||/*   i*/
				(nov_send->j==30000 && nov_send->i==myi)) break;/*   j*/
			if((myi==30000 && nov_send->j==myj) ||
				(myj==30000 && nov_send->i==myi))
			{
				if(nov_raspr->s==nov_send) nov_raspr->s=nov_send->next;
				else end_send->next=nov_send->next;
				temp_send=nov_send;
				nov_send=nov_send->next;
				myfree(temp_send);
			}
			else
			{
				end_send=nov_send;
				nov_send=nov_send->next;
			}
		}
		if(nov_send==NULL)
		{
			nov_send = (SENDS*)mycalloc(sizeof(SENDS), 1);
			if(nov_send==NULL) OutOfMemory();
			nov_send->i=myi;
			nov_send->j=myj;
			if(nov_raspr->s==NULL) nov_raspr->s=nov_send;
			else end_send->next=nov_send;
		}
		GetNextInfStr(&nov_string);
	}

	this_scal = get_last_scal(last_hi);
	while(beg_razd)
	{
		SUBROUTINE *nov_razd;
		STR *last_scal;
		STR *first_scal = get_last_scal(last_hi);
		/*   -    
		(last_hi)         */
		MakeCallTree(beg_razd, last_hi, this_razd->name);
		nov_razd=beg_razd;
		beg_razd=beg_razd->next;
		myfree(nov_razd->name);
		myfree(nov_razd);
		/*    */
		last_scal=get_last_scal(last_hi);
		if(first_scal!=NULL && first_scal!=last_scal && first_scal!=this_scal)
		{
			if(this_scal==NULL)
			{
				last_scal->next=last_hi->scal;
				last_hi->scal=first_scal->next;
			}
			else
			{
				last_scal->next=this_scal->next;
				this_scal->next=first_scal->next;
			}
			first_scal->next=NULL;
		}
	}
	/*  DISTRIBUTION */
	if(part_type==1)
		bDistribution = FALSE;
	end_of_scal(parent, this_razd->name);  /*   */
}

/*  */
static STRINGS* FindMainPart(char* mainpartname)
{
	STRINGS *strnext, *strfind = NULL;
	STRINGS *strfort = NULL;
	char programname[MAX_INDENT_LEN];

	for(strnext=src_string; strnext; strnext=strnext->next)
	{
		int len, word;

		if(IsCnfString(strnext->s, 1) == 0)
		{
			//     
			if(strfind == NULL && IsThisProgram(strnext->s, mainpartname))
			{
				if(strfort != NULL) /*  !*/
					CnfExitSay(NULL, NULL, 10, mainpartname, programname);

				strfort = strnext;
				strcpy(programname, mainpartname);
			}
			continue;
		}

		if(strnext->next == NULL)
			break;

		word = IsCnfString(strnext->next->s, 0);

		if(word == 0)
			continue;

		if(language == 0)
			SetLanguage(word);

		GetNextInfStr(&strnext);
		GetNextInfStr(&strnext);

		if(strfind != NULL)
		{
			/*  !*/
			strnext->s[strlen(strnext->s)-1] = 0;
			CnfExitSay(NULL, NULL, 10, mainpartname, &strnext->s[12]);
		}

		strfind = strnext;

		word = 12+2*(word==1);
		len = strlen(&strfind->s[word]);
		if(len>MAX_INDENT_LEN)
			len = MAX_INDENT_LEN;
		strncpy(mainpartname, &strfind->s[word], len);
		mainpartname[len]=0;
		if(mainpartname[len-1] == '\n')
			mainpartname[len-1]=0;
		begin_hi.where=GetFiles(strfind);
		/*   */
		GetNextInfStr(&strfind);
		if(!ReadCompOptions(strfind->s,TRUE))
			CnfInfDestroyed(strfind);
		GetNextInfStr(&strfind);
	}

	if(strfind == NULL)
	{
		bNormaGeneratedProgram = FALSE;
		strfind = strfort;
	}
	return strfind;
}

static void GenerateCnfDescription(char* out_name, char *section, char* mainraz);
static BOOL ExecuteCnfDescription(char* filepathname, DEFINES *beg_def, char *mpi_cfg_command, char* out_name);

/**********************************************************/
/*                                          */
/**********************************************************/
int main(int argc, char **argv)
{
	char mainpartname[MAX_INDENT_LEN]="";
	char mpi_cfg_command[100]="";
	char out_name[130];
	STRINGS *nov_string;
	HIERARHY *tek_hi;
	STR *tek_scal, *pred_scal;

	SetLanguage(0);
	/*    ,   */
	if(!ProcessCommandLine(argc, argv))
		return 0;

	strcpy(out_name, strOutPath);
	nLenOutPath=strlen(strOutPath);
	while(nLenOutPath>0 && !IsDirOrDiskSeparator(strOutPath[nLenOutPath])) nLenOutPath--;
	if(nLenOutPath>0) nLenOutPath++;

	/*    */
	nov_string = FindMainPart(mainpartname);
	if(nov_string == NULL)
		CnfExitSay(NULL, NULL, 11);

	strcpy(strCurrentPart, mainpartname);
	strcpy(begin_hi.mainname, mainpartname);

	begin_hi.scal=NULL;
	begin_hi.next=NULL;

	if(bNormaGeneratedProgram) /*-*/
	{
		int i;
		char libfilename[MYMAXPATH];
		SUBROUTINE *beg_razd=NULL, *nov_razd=NULL;
		STR *first_scal=NULL, *last_scal=NULL;
		RASPR *nextraspr;

		/*   */
		CALLPART *fr_par = ReadParam(&nov_string, mainpartname);
		if(fr_par!=NULL)
		{
			if(bUserInterface)
				printf("<M %s><%ld %s>\n", mainpartname, fr_par->line, fr_par->filename);
			FreeCalls(fr_par);
		}
		else
		{
			if(bUserInterface)
				printf("<M %s><0 >\n", mainpartname);
		}

		GetNextInfStr(&nov_string);
		if(strcmp(&nov_string->s[7],"proc:\n")==0) GetNextInfStr(&nov_string);

		/*      */
		beg_razd = ReadSubList(&nov_string);


		if(bUserInterface) printf("<E %s>\n", mainpartname);

		/*add file normalib*/
		LibFileName(libfilename, argv[0]);
		ReadSourceFile(libfilename, FALSE);

		/* ,       COMMON,
		      */
		SetLocalVariable("I");

		first_scal=NULL;
		while(beg_razd)
		{
		/*   -    
		(begin_hi)         */
			MakeCallTree(beg_razd, &begin_hi, mainpartname);
			nov_razd=beg_razd;
			beg_razd=beg_razd->next;
			myfree(nov_razd->name);
			myfree(nov_razd);
			/*    */
			if(first_scal!=NULL&&first_scal->next!=NULL)
			{
				last_scal=get_last_scal(&begin_hi);
				last_scal->next=begin_hi.scal;
				begin_hi.scal=first_scal->next;
				first_scal->next=NULL;
			}
		}

		/*,       */
		for(nextraspr=begraspr; nextraspr; nextraspr=nextraspr->next)
		{
			tek_hi = &begin_hi;
			while(tek_hi)
			{
				STR *next_scal = tek_hi->scal;
				while(next_scal)
				{
					if(CompareNames(nextraspr->name, next_scal->name))
						CnfExitSay(NULL, NULL, 57, nextraspr->name);
					next_scal = next_scal->next;
				}
				tek_hi = tek_hi->next;
			}
		}


		/*,      */
		if(nErrors>0) {printf(message[32], nErrors, nWarnings, nDisWarnings); exit(1);}
		if(nWarnings>0 || nDisWarnings>0) printf(message[47], nWarnings, nDisWarnings);

		for(i=nLenOutPath; out_name[i]; i++)
			if(out_name[i]=='.') break;
		strcpy(&out_name[i], ".c");

		if(C_OUT || FMPI_OR_F77)
		{
			int  ii=0, jj=0;

			if(begraspr)
			{
				ii=begraspr->i;
				jj=begraspr->j;
				for(nextraspr=begraspr; nextraspr; nextraspr=nextraspr->next)
				{
					if(jj!=nextraspr->j || ii!=nextraspr->i)
						CnfExitSay(NULL, NULL, 30);
				}
			}

			memcpy(main_out_name, &out_name[nLenOutPath], i-nLenOutPath);
			main_out_name[i-nLenOutPath]=0;
			if(section_number)
			{
				sprintf(mpi_cfg_command, "mpi_cfg -s%s %d(%s)",
					&argv[section_number][3], ii*jj+1, main_out_name);
			}
		}

		if(out_file_type == GNS)
			GenerateCnfDescription(out_name, &argv[section_number][3], mainpartname);
	}
	else  /*   */
	{
		if(bDebugFortran)
		{
			CALLPART* part;
			COMMON* common;
			SetCurrentString(nov_string);
			/* COMMON-  */

			part = PreparePartInfo(mainpartname);
			if(part)
			{
				PARAM *param;

				/*  mpi_init*/
				if(part->mpi_initline < 1)
					CnfExitSay(NULL, nov_string, 59);

				for(param = part->parameters; param; param=param->next)
				{
					/* ,       COMMON,
					      */
					if(!param->bCommon)
						SetLocalVariable(param->name);
				}
			}
			common = GetNextCommon(NULL);
			while(common)
			{
				common->bMainPart = TRUE;
				common = GetNextCommon(common);
			}
		}
	}

	/*  */
	WriteOutFile();

	FreeFiles(src_file);
	FreeStrings(src_string);
	FreeFiles(head_file);
	FreeStrings(head_string);
	FreeCommon();
	FreePartInfo();

	while(begraspr)
	{
		RASPR *nextraspr=begraspr;
		FreeSends(begraspr);
		begraspr=begraspr->next;
		myfree(nextraspr);
	}

	if(bNormaGeneratedProgram && out_file_type != PVM)
		ExecuteCnfDescription(argv[0], first_def, mpi_cfg_command, out_name);

	printf(message[22]);

	/*   */
	FreeDefines(first_def);

	tek_scal=begin_hi.scal;
	while(tek_scal)
	{
		pred_scal=tek_scal;
		tek_scal=tek_scal->next;
		myfree(pred_scal);
	}
	tek_hi=begin_hi.next;
	while(tek_hi)
	{
		HIERARHY *next_hi=tek_hi;
		tek_scal=next_hi->scal;
		while(tek_scal)
		{
			pred_scal=tek_scal;
			tek_scal=tek_scal->next;
			myfree(pred_scal);
		}
		tek_hi=tek_hi->next;
		myfree(next_hi);
	}

#ifdef _MEMCHECK
	IsMemLost();
#endif

	return 0;
}

/**********************************************************/
/*                 */
/**********************************************************/
#define NR_COM_FILE "normacnf.cnf"

#ifdef _WIN32
static char *mybasename(const char *fullpath)
{
	static char filename[_MAX_FNAME+_MAX_EXT];
	char drive[_MAX_DRIVE], dir[_MAX_DIR], ext[_MAX_EXT];
	_splitpath(fullpath,drive,dir,filename,ext);
	strcat(filename,ext);
	return filename;
}
#else
static char *mybasename(char *fullpath)
{
	return(basename(fullpath)+1);
}
#endif

static char *my_fgets(char *s, int n, CNFFILE *f)
{
	do
	{
		if(cnf_gets(s,n,f)==NULL) return NULL;
	}
	while(strlen(s)<2 || s[0]==';');
	return s;
}

static int older(char *file1,char *file2)
{
	struct stat a,b;
	if(stat(file1,&a) != 0) return 1;
	if(stat(file2,&b) != 0) return 1;

	return(a.st_mtime > b.st_mtime);
}

static int use(int i,int j)
{
	RASPR *tek=begraspr;
	i++;j++;
	while(tek)
	{
		if((tek->in<=i)&&(tek->jn<=j)&&((tek->in+tek->i-1)>=i)
			&&((tek->jn+tek->j-1)>=j)) return 1;
		tek=tek->next;
	}
	return 0;
}

static void replace(char *dest, const char *source, const char *find, const char *on)
{
	int i,j=0,lenf,lens,leno;
	lenf=strlen(find);
	lens=strlen(source);
	leno=strlen(on);

/*	puts("Before:");
	puts(source);
	puts(find);
	puts(on);
*/
	for(i=0;i<=lens;i++)
	{
		if(strnicmp(find,&source[i],lenf)==0)
		{
			strcpy(&dest[j],on);
			j+=leno;
			i+=lenf-1;
		}
		else dest[j++]=source[i];
	}
/*	puts("After:");
	puts(dest);*/
}

/*Universal execute UNIX command or DOS executeable file*/
static int u_exec(char **myargv)
{
#ifdef _WIN32
	return spawnvp(P_WAIT,myargv[0],myargv);
#else
	pid_t chpid;
	int status;

	chpid=fork();
	if(chpid == -1) return -1; /* error fork */
	if(chpid == 0) /* Child process */
	{
		execvp(myargv[0],myargv);
		exit(1);/* error */
	}
	/* Parent process */
	wait(&status);
/*	printf("Status=%X\n",status);*/
	return status;
#endif
}

/* Execute command */
static int ms_dos(char *s, char **myargv)
{
	int i=0,j=0,ip=0;
/*	myargv[0]=s;
	myargv[1]=NULL;*/
#ifdef _WIN32
	while((s[i]!='.')&&(s[i]!=' ')&&(s[i]!=0)) i++;
	if((strnicmp(&s[i],".exe",4)==0)||(strnicmp(&s[i],".com",4)==0))
	{
		i+=4;
#else
		while((s[i]!=' ')&&(s[i]!=0)) i++;
#endif
		while(1)
		{
			myargv[j++]=&s[ip];
			if(s[i]==0) break;
			s[i++]=0;
			while(s[i]==' ') i++;
			ip=i;
			while((s[i]!=' ')&&(s[i]!=0)) i++;
		}
		myargv[j]=NULL;
		return u_exec(myargv);
#ifdef _WIN32
	}
	else return system(s);
#endif
}

static void mycall(char *perem, char *on, CALLS *beg_call)
{
	int i;
	char strbuf[MAX_STR_LEN];
	char *myargv[30];

	replace(strbuf, beg_call->message, perem, on);
	puts("");
	printf(strbuf);
	puts("");
	printf(" ");
	puts("");
	replace(strbuf, beg_call->com_line, perem, on);
	if((i=ms_dos(strbuf, myargv))!=0)
	{
		if(i==-1)
		{
			puts("");
			printf(message[5]);
			puts("");
			for(i=0;myargv[i]!=0;i++) { printf(myargv[i]);printf(" ");}
			printf("");
			puts("");
			printf(message[6]);
			puts("");
		}
		else
		{
			ERRORS *tek_error=beg_call->e;
			while(tek_error)
			{
				if(i>=tek_error->cod)
				{
					replace(strbuf, tek_error->message, perem, on);
					puts("");
					printf(strbuf);
					puts("");
					printf(" ");
					puts("");
					exit(tek_error->return_cod);
				}
				tek_error=tek_error->next;
			}
		}
		printf(" ");
		puts("");
		exit(1);
	}
}

/*  */
static void GenerateCnfDescription(char* out_name, char* section, char* mainraz)
{
	int i, j, k, l, m;
	char tmp_name[MYMAXPATH];
	int change, flag, how;
	FILE *fo, *fr;
	SENDS *tek=NULL;
	char strbuf[MAX_STR_LEN];
	RASPR* endraspr;
	int maxi=0, maxj=0;

	if((fr=myfopen(out_name,"rt"))==NULL)
	{
		change=1;
		if((fo=fopen(out_name,"wt")) == NULL)
			ErrWrite();
	}
	else
	{
		change=0;
		strOutPath[nLenOutPath]=0;
		fo=OpenTmpFile(strOutPath, "wt");
		strcpy(tmp_name, strOutPath);
	}
	fputs("#include <stdio.h>\n#include <string.h>\n#include \"config.h\"\n",fo);
	fputs("int main(argc, argv)\nint     argc;\nchar    **argv;\n{  int i,j,k,l;\n",fo);
	fputs("   dsc_type mainTASK,*descPROC;\n",fo);

	endraspr=begraspr;
	while(endraspr)
	{
		if(maxi<endraspr->i) maxi=endraspr->i;
		if(maxj<endraspr->j) maxj=endraspr->j;
	}

	/*  .  */
	fprintf(fo,"   int matTASKnum[%d];\n",maxi*maxj+2);
	/*   .   */
	fprintf(fo,"   dsc_type matPROCessor[%d];\n",maxi*maxj+2);

	/*      */
	endraspr=begraspr;
	while(endraspr)
	{
		fprintf(fo,"   dsc_type TASK%s[%d][%d];\n",endraspr->name, endraspr->i,endraspr->j);
		endraspr=endraspr->next;
	}

	fputs("   ConfigInit(argc,argv);\n   SetTskFlag(\"PROCNUM\");\n",fo);
	/*        */
	fprintf(fo,"   matTASKnum[0]=%d;\n",maxi*maxj+1);
	fprintf(fo,"   for(i=0;i<%d;i++) for(j=0;j<%d;j++)\n",maxi,maxj);
	fprintf(fo,"      matTASKnum[i*%d+j+1]=%d*i+j+1;\n",maxj,how_processors);
	fprintf(fo,"   matTASKnum[%d]=0;\n",maxj*maxi+1);

	how=0;
	/*         */
	for(i=0;i<maxi;i++) for(j=0;j<maxj;j++)
	{
		if(use(i,j)==0)
		{  /*   I,J    */
			k=1;
			flag=0;
			m=0;
			for(l=i;l<maxi;l++)
			{
				if(l==i) m=j+1;
				else m=0;
				for(;m<maxj;m++) if(use(l,m)) { flag=1;break;} else k++;
				if(flag) break;
			}

			fprintf(fo,"   for(i=%d;i<=%d;i++) matTASKnum[i-%d]=matTASKnum[i+%d-%d];\n"
						,i*maxj+j+1,maxi*maxj+1-k,how,k,how);
			fprintf(fo,"   matTASKnum[0]-=%d;\n",k);

			i=l;
			j=m;
			how+=k;
		}
	}
	/*          */

	if(section_number) fprintf(fo,"   SetSecNum(\"%s\");\n", section);
	if(fullhardnet) fputs("   SetFullHardNet(1);\n",fo);
	if(linkquota) fprintf(fo,"   SetLinkQuota(%d);\n",linkquota);
	fputs("   descPROC=HardNet(matTASKnum[0]);\n",fo);
	fputs("   if((long)descPROC[0]<matTASKnum[0])\n"
			"   {   puts(\"\\n   "
			"  \");\n      return(1);\n   }\n",fo);
	/*   .    matPROCessor, 
		     */
	fputs("   memcpy(matPROCessor,descPROC,(matTASKnum[0]+1)"
					"*sizeof(dsc_type));\n",fo);

	/*         */
	for(i=maxi-1;i>=0;i--) for(j=maxj-1;j>=0;j--)
	{
		if(use(i,j)==0)
		{  /*   I,J    */
			k=1;
			m=0;
			flag=0;
			for(l=i;l>=0;l--)
			{
				if(l==i) m=j-1;
				else m=maxj-1;
				for(;m>=0;m--) if(use(l,m)) { flag=1;break;} else k++;
				if(flag) break;
			}
			how-=k;
			if(l==-1)  /*       */
			{
				fprintf(fo,"   for(i=%d;i>0;i--)\n   {\n"
					"      matPROCessor[i+%d-%d]=matPROCessor[i-%d];\n"
					"      matTASKnum[i+%d-%d]=matTASKnum[i-%d];\n   }\n"
						,maxi*maxj+1-k,k,how,how,k,how,how);
			}
			else
			{
				fprintf(fo,"   for(i=%d;i>%d;i--)\n   {\n"
						"      matPROCessor[i+%d-%d]=matPROCessor[i-%d];\n"
						"      matTASKnum[i+%d-%d]=matTASKnum[i-%d];\n   }\n"
							,maxi*maxj+1-k,l*maxj+m+1,k,how,how,k,how,how);
			}

			i=l;
			j=m;
		}
	}
	strcpy(&strOutPath[nLenOutPath], mainraz);
	strcat(strOutPath,".860");

	strcpy(strbuf, mainraz);
	strcat(strbuf, ".860");

	fprintf(fo,"   mainTASK=TaskCreate(matTASKnum[%d],\"%s\");\n", maxi*maxj+1, strbuf);
	fprintf(fo,"   Place( matPROCessor[%d],mainTASK);\n",maxi*maxj+1);
	fputs("   Set(mainTASK,ATTRBITS,(vvv)D_BIT);\n",fo);

	/*        */
	endraspr=begraspr;
	while(endraspr)
	{
		strcpy(&strOutPath[nLenOutPath], endraspr->name);
		strcat(strOutPath, ".860");

		strcpy(strbuf, endraspr->name);
		strcat(strbuf, ".860");

		fprintf(fo,"   for(i=0;i<%d;i++) for(j=0;j<%d;j++)\n",endraspr->i,endraspr->j);
		fprintf(fo,"   {  TASK%s[i][j]=TaskCreate(matTASKnum["
				"(i+%d)*%d+j+%d+1],\"%s\");\n",endraspr->name,endraspr->in-1,maxj,
							 endraspr->jn-1, strbuf);
		/*         */
		/*           
		get_parname(strbuf, endraspr->name);
			fprintf(f,"      ParChild(mainTASK,TASK%s[i][j]);\n",endraspr->name);
		*/
		fprintf(fo,"      SoftCon(mainTASK,TASK%s[i][j]);\n",endraspr->name);
		tek=endraspr->s;
		if(tek==(SENDS*)1)  /*       */
		{
			fprintf(fo,"      for(k=0;k<=i;k++)\n");
			fprintf(fo,"      {\n         if(k==i) l=j-1; else l=%d;\n",endraspr->j-1);
			fprintf(fo,"         for(;l>=0;l--) SoftCon(TASK%s[i][j],TASK%s[k][l])"
				  ";\n      }\n",endraspr->name,endraspr->name);
		}
		else while(tek)
		{
			if(tek->i==30000)  /*     j  */
				fprintf(fo,"      for(k=i-1;k>=0;k--)\n"
					  "           SoftCon(TASK%s[i][j],TASK%s[k][j]);\n",
						endraspr->name,endraspr->name);
			else if(tek->j==30000)  /*     i  */
				fprintf(fo,"      for(k=j-1;k>=0;k--)\n"
						"           SoftCon(TASK%s[i][j],TASK%s[i][k]);\n",
						 endraspr->name,endraspr->name);
			else  /*      */
			{
				if((tek->i!=0)||(tek->j!=0))
					if(tek->j>=0)
						fprintf(fo,"      if((i>=%d)&&(j>=%d)) "
							  "SoftCon(TASK%s[i-%d][j-%d],TASK%s[i][j]);\n",
								tek->i,tek->j,endraspr->name,
									 tek->i,tek->j,endraspr->name);
					else
						fprintf(fo,"      if((i>=%d)&&(j<=%d)) "
							  "SoftCon(TASK%s[i-%d][j+%d],TASK%s[i][j]);\n",
							  tek->i,endraspr->j+tek->j-1,endraspr->name,
									 tek->i,-tek->j,endraspr->name);
			}
			tek=tek->next;
		}
		/*       */
		fprintf(fo,"      Set(TASK%s[i][j],ATTRBITS,(vvv)D_BIT);\n",endraspr->name);
		fprintf(fo,"      Place(matPROCessor[(i+%d)*%d+j+%d+1],"
						"TASK%s[i][j]);\n   }\n",endraspr->in-1,maxj,
							 endraspr->jn-1,endraspr->name);

		endraspr=endraspr->next;
	}

	for(i=strlen(out_name);i>=0;i--) if(out_name[i]==DIR_SEPARATOR) break;
	if(out_name[i]==DIR_SEPARATOR) i++;
	strcpy(strbuf, &out_name[i]);
	i=0;
	while(strbuf[i]!='.') i++;
	strbuf[i]=0;

	if(fprintf(fo, "   return(Run(\"%s\"));\n}\n", strbuf)==EOF) ErrWrite();
	fclose(fo);
	if(change==0)
	{
		j=0;
		fo=myfopen(tmp_name,"rt");
		while(1)
		{
			i=getc(fo);
			j=getc(fr);
			if(i==EOF || j==EOF || i!=j) break;
		}
		myfclose(fo);
		myfclose(fr);
		if(i!=j)
		{
			unlink(out_name);
			rename(tmp_name, out_name);
			change=1;
		}
		else unlink(tmp_name);
	}
	if(change) printf(message[13], out_name);
	else printf(message[14]);

}

/*   */
static BOOL ExecuteCnfDescription(char* filepathname, DEFINES *beg_def, char* mpi_cfg_command, char* out_name)
{
	CNFFILE *fp;
	ERRORS *last_error=NULL;
	CALLS *tek_call=NULL, *last_call=NULL;
	char comfilename[MYMAXPATH+1];
	DEFINES *tek_def;
	char cStrBuf[MAX_STR_LEN], cBufStr[MAX_STR_LEN];
	char if_file1[130], if_file2[130];
	ERRORS *tek_error;
	CALLS *beg_call=NULL;

	char perem_conf[]="%config%";
	char perem_btl[]="%btl%";
	char perem_gns[]="%gns%";
	char s_perem_conf[]="%s_config%";
	char s_perem_btl[]="%s_btl%";
	char s_perem_gns[]="%s_gns%";


	strcpy(comfilename, NR_COM_FILE);

	if((fp=cnf_open(comfilename, "rt"))==NULL)
	{
		int k;
		strcpy(comfilename, filepathname);
		k=strlen(comfilename);
		while(k && (comfilename[k] != DIR_SEPARATOR)) k--;
		if(comfilename[k] == DIR_SEPARATOR) k++;
		if(k == 0) /* only file name */
		{
			if(mysearchpath(comfilename, filepathname))
			{
				k=strlen(comfilename);
				while(k && (comfilename[k]!=DIR_SEPARATOR)) k--;
				if(comfilename[k] == DIR_SEPARATOR) k++;
			}
		}
		strcpy(&comfilename[k], NR_COM_FILE);
		fp=cnf_open(comfilename, "rt");
	}

	if(fp==NULL && mpi_cfg_command[0]==0)
		return FALSE;

	if(fp!=NULL)
	{
		printf(message[20]);

		while(1)
		{
			int i, j;
			if(my_fgets(cBufStr,180,fp)==0) break;
			cBufStr[180]=0;
			if((tek_call=mymalloc(sizeof(CALLS)))==NULL) OutOfMemory();
			tek_call->next=NULL;
			tek_call->e=NULL;
			cBufStr[strlen(cBufStr)-1]=0;
			if(cBufStr[0]=='?')  /*        */
			{
				if(strnicmp(cBufStr,"?ifdef",6)==0)  /*      */
				{
					i=6;
					while(cBufStr[i]==' ') i++;
					tek_def=beg_def;
					while(tek_def)
					{
						if(strnicmp(&cBufStr[i],tek_def->name,strlen(tek_def->name))==0) break;
						tek_def=tek_def->next;
					}
					if(tek_def==NULL)
					{
						while(1) if(cnf_gets(cBufStr,180,fp)==0
									|| strnicmp(cBufStr,"[end command]",13)==0) break;
						myfree(tek_call);
						continue;
					}
					if(my_fgets(cBufStr,180,fp)==0) CnfExitSay(fp, NULL, 21);
					cBufStr[180]=0;
				}
				else if(strnicmp(cBufStr,"?ifndef",7)==0)  /*      */
				{
					i=6;
					while(cBufStr[i]==' ') i++;
					tek_def=beg_def;
					while(tek_def)
					{
						if(strnicmp(&cBufStr[i],tek_def->name,strlen(tek_def->name))==0) break;
						tek_def=tek_def->next;
					}
					if(tek_def!=NULL)
					{
						while(1) if(cnf_gets(cBufStr,180,fp)==0
									|| strnicmp(cBufStr,"[end command]",13)==0) break;
						myfree(tek_call);
						continue;
					}
					if(my_fgets(cBufStr,180,fp)==0) CnfExitSay(fp, NULL, 21);
					cBufStr[180]=0;
				}
				if(cBufStr[0]=='?')  /*        */
				{
					i=1;
					while(cBufStr[i]==' ') i++;
					j=i;
					while(cBufStr[j]>32 && (cBufStr[j]!='-' || cBufStr[j+1]!='>')) j++;
					if(cBufStr[j]<11) CnfExitSay(fp, NULL, 21);
					strncpy(tek_call->file1,&cBufStr[i],j-i);
					tek_call->file1[j-i]=0;
					while(cBufStr[j]>10 && (cBufStr[j]!='-' || cBufStr[j+1]!='>')) j++;
					if(cBufStr[j]<11) CnfExitSay(fp, NULL, 21);
					i=j+2;
					while(cBufStr[i]==' ') i++;
					j=i;
					while(cBufStr[j]>32) j++;
					strncpy(tek_call->file2,&cBufStr[i],j-i);
					tek_call->file2[j-i]=0;
					if(my_fgets(cBufStr,180,fp)==NULL) CnfExitSay(fp, NULL, 21);;
					cBufStr[180]=0;
					cBufStr[strlen(cBufStr)-1]=0;
				}
			}/*       */
			else tek_call->file1[0]=tek_call->file2[0]=0;
			memcpy(tek_call->message,cBufStr,79);
			tek_call->message[79]=0;
			if(my_fgets(tek_call->com_line,MAX_STR_LEN,fp)==NULL) CnfExitSay(fp, NULL, 21);
			tek_call->com_line[199]=0;
			tek_call->com_line[strlen(tek_call->com_line)-1]=0;
			while(1)
			{
				if(my_fgets(cBufStr,80,fp)==NULL || strnicmp(cBufStr,"[end command]",13)==0) break;
				if((tek_error=mymalloc(sizeof(ERRORS)))==0) OutOfMemory();
				tek_error->next=0;
				cBufStr[strlen(cBufStr)-1]=0;
				strcpy(tek_error->message,cBufStr);
				if(my_fgets(cBufStr,20,fp)==NULL) CnfExitSay(fp, NULL, 21);
				cBufStr[strlen(cBufStr)-1]=0;
				if(((tek_error->cod=atoi(cBufStr))==0)&&(cBufStr[0]!='0')) CnfExitSay(fp, NULL, 21);
				if(my_fgets(cBufStr,20,fp)==NULL) CnfExitSay(fp, NULL, 21);
				cBufStr[strlen(cBufStr)-1]=0;
				if(((tek_error->return_cod=atoi(cBufStr))==0)&&(cBufStr[0]!='0'))
												 CnfExitSay(fp, NULL, 21);
				if(tek_call->e==0) tek_call->e=tek_error;
				else last_error->next=tek_error;
				last_error=tek_error;
			}
			if(beg_call==NULL) beg_call=tek_call;
			else last_call->next=tek_call;
			last_call=tek_call;
		}
		cnf_close(fp);
	}

	out_name[strlen(out_name)-2]=0;

	if(mpi_cfg_command[0] != 0)
	{
		char *myargv[30];
		ms_dos(mpi_cfg_command, myargv);
	}

	while(beg_call)
	{
		int i, j;
		if(beg_call->file1[0]&&beg_call->file2[0])
		{
			replace(cStrBuf,beg_call->file1,perem_conf,out_name);
			replace(if_file1,cStrBuf,perem_btl,out_name);
			replace(cStrBuf,if_file1,s_perem_conf,mybasename(out_name));
			replace(if_file1,cStrBuf,s_perem_btl,mybasename(out_name));
			replace(cStrBuf,beg_call->file2,perem_conf,out_name);
			replace(if_file2,cStrBuf,perem_btl,out_name);
			replace(cStrBuf,if_file2,s_perem_conf,mybasename(out_name));
			replace(if_file2,cStrBuf,s_perem_btl,mybasename(out_name));
		}
		else if_file1[0]=if_file2[0]=0;
		j=strlen(beg_call->com_line);
		for(i=0;i<j;i++)
		{
			HIERARHY *next_hi;

			if(strnicmp(&beg_call->com_line[i],perem_conf,8)==0)
			{  /*   -  */
				if(older(if_file1,if_file2)) mycall(perem_conf,out_name,beg_call);
				break;
			}
			if(strnicmp(&beg_call->com_line[i],perem_btl,5)==0)
			{  /*   btl-  */
				if(older(if_file1,if_file2)) mycall(perem_btl,out_name,beg_call);
				break;
			}
			if(strnicmp(&beg_call->com_line[i],perem_gns,5)==0)
			{  /*   gns-  */
				next_hi=&begin_hi;
				while(next_hi)
				{
					strcpy(&strOutPath[nLenOutPath],next_hi->mainname);
					replace(cBufStr,if_file1,perem_gns,strOutPath);
					replace(cStrBuf,if_file2,perem_gns,strOutPath);
					if(older(cBufStr,cStrBuf)) mycall(perem_gns,strOutPath,beg_call);
					next_hi=next_hi->next;
				}
				break;
			}
			if(strnicmp(&beg_call->com_line[i],s_perem_conf,8)==0)
			{  /*   s_-  */
				if(older(if_file1,if_file2)) mycall(s_perem_conf,mybasename(out_name),beg_call);
				break;
			}
			if(strnicmp(&beg_call->com_line[i],s_perem_btl,5)==0)
			{  /*   s_btl-  */
				if(older(if_file1,if_file2)) mycall(s_perem_btl,mybasename(out_name),beg_call);
				break;
			}
			if(strnicmp(&beg_call->com_line[i],s_perem_gns,5)==0)
			{  /*   gns-  */
				next_hi=&begin_hi;
				while(next_hi)
				{
					replace(cBufStr,if_file1,s_perem_gns,next_hi->mainname);
					replace(cStrBuf,if_file2,s_perem_gns,next_hi->mainname);
					if(older(cBufStr,cStrBuf)) mycall(s_perem_gns,next_hi->mainname,beg_call);
					next_hi=next_hi->next;
				}
				break;
			}
		}

		if(i==j) mycall(out_name,out_name,beg_call);
		tek_error=beg_call->e;
		while(tek_error)
		{
			last_error=tek_error;
			tek_error=tek_error->next;
			myfree(last_error);
		}
		tek_call=beg_call;
		beg_call=beg_call->next;
		myfree(tek_call);
	}

	return TRUE;
}

/**********************************************************/
