/*   This file is part of Norma compiler.
File must located at configurator directory (pogram normacnf).
For more information please visit website:
http://www.keldysh.ru/pages/norma

File included C realisation of internal functions:
MIG, MAL, AMIN1, AMAX1, DMIN1, DMAX1

Copyright 2004 KIAM Russian Ac. Sci.*/

/*
C $DIR CONFIG INFORMATION
C $DIR PART MIG
C $DIR ("normalib.c"19?2?.-.-.+)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
int MIG(float a, float b)
{
	float s;
	int mig;

	if(a-b < 0) s=a;
	else s=b;

	if(s >= 0)
	{
		mig = s+1;
		if(s-mig < -0.0000001) mig--;
	}
	else
	{
		mig = s-1;
		if(s-mig > 0.9999999) mig++;
	}
	return(mig);
}

/*
C $DIR CONFIG INFORMATION
C $DIR PART MAL
C $DIR ("normalib.c"48?2?.-.-.+)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
int MAL(float a, float b)
{
	float s;
	int mal;

	if(a-b < 0) s=b;
	else s=a;

	if(s>=0)
	{
		mal = s+1;
		if(mal-s > 0.9999999) mal--;
	}
	else
	{
		mal = s+1;
		if(mal-s > 0.9999999) mal--;
	}
	return(mal);
}

/*
C $DIR CONFIG INFORMATION
C $DIR PART AMIN1
C $DIR ("normalib.c"77?3?.+.-.-.-)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
float AMIN1(int count, float A1, float A2, ...)
{
	va_list arg;

    va_start(arg, A2);

	while(1)
	{
		A1 = A1<A2?A1:A2;
		if(count<3)
		{
			va_end(arg);
			return A1;
		}
/* "float" is promoted to "double" when passed through "..."
so we should pass "double" not "float" to "va_arg" */
		A2 = (float)va_arg(arg, double);
		count--;
	}
}

/*
C $DIR CONFIG INFORMATION
C $DIR PART AMAX1
C $DIR ("normalib.c"106?3?.+.-.-.-)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
float AMAX1(int count, float A1, float A2, ...)
{
	va_list arg;

    va_start(arg, A2);

	while(1)
	{
		A1 = A1>A2?A1:A2;
		if(count<3)
		{
			va_end(arg);
			return A1;
		}
/* "float" is promoted to "double" when passed through "..."
so we should pass "double" not "float" to "va_arg" */
		A2 = (float)va_arg(arg, double);
		count--;
	}
}

/*
C $DIR CONFIG INFORMATION
C $DIR PART DMIN1
C $DIR ("normalib.c"135?3?.+./././)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
double DMIN1(int count, double A1, double A2, ...)
{
	va_list arg;

    va_start(arg, A2);

	while(1)
	{
		A1 = A1<A2?A1:A2;
		if(count<3)
		{
			va_end(arg);
			return A1;
		}
		A2 = va_arg(arg, double);
		count--;
	}
}

/*
C $DIR CONFIG INFORMATION
C $DIR PART DMAX1
C $DIR ("normalib.c"162?3?.+./././)
C $DIR proc:
C $DIR send:
C $DIR END OF CONFIG INFORMATION
*/
double DMAX1(int count, double A1, double A2, ...)
{
	va_list arg;

    va_start(arg, A2);

	while(1)
	{
		A1 = A1>A2?A1:A2;
		if(count<3)
		{
			va_end(arg);
			return A1;
		}
		A2 = va_arg(arg, double);
		count--;
	}
}
