/*    .
     - - - 
  ..*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#ifdef _WIN32

#else

#include <sys/types.h>
#include <unistd.h>
#include <limits.h>

#endif

#include "normacnf.h"
#include "memcheck.h"
#include "paramcnf.h"
#include "outptcnf.h"

/***************************************************************/

/***************************************************************/

#define PARAMETERS struct Parameters
PARAMETERS /*     PARAMETER*/
{
	char name[MAX_LEN_NAME+1]; /**/
	long value; /**/
	PARAMETERS *next;
};

#define IMPLICIT struct Implicit
IMPLICIT
{
	VARTYPES type; /**/
	char first; /*  */
	char last;  /*  */
	IMPLICIT *next;
};

#define FILENAMES struct FILENames
FILENAMES
{
	char *namefile;
	FILENAMES *next;
};

/***************************************************************/
static PARAMETERS *first_params;
static PARAMETERS *last_params;
static IMPLICIT *first_implicit;
static IMPLICIT *last_implicit;
static FILENAMES *first_filename;
/*   COMMON */
static COMMON *pCommonBlocks = NULL;
/*      (    COMMON)*/
static PARAMETERS *pMainVarNames = NULL;

static CALLPART* pPartsCall=NULL;
static CALLPART* pFirstCall;
static CALLPART* pLastCall;
static PARAM *pFirstPar;
static PARAM *pLastPar;
static PARAM *pLastRow;/* */

static BOOL bNoIncludeFile;
static BOOL bFindAllVars;/*  */
static BOOL bMeaningline;
/***************************************************************/

/***************************************************************/

/*   */
static DIAPAZON* LockDiapazon(long first, long last)
{
	DIAPAZON *diap;
	diap = mymalloc(sizeof(DIAPAZON));
	if(diap==NULL) OutOfMemory();
	diap->next=NULL;
	diap->first = first;
	diap->last = last;
	diap->fExpression = NULL;
	diap->lExpression = NULL;
	diap->bfUnknown = FALSE;
	diap->blUnknown = FALSE;

	diap->index = NULL;
	return diap;
}

/*     */
static CALLPART* LockCall(STRINGS* s)
{
	if(pFirstCall==NULL)
	{
		if((pFirstCall=mymalloc(sizeof(CALLPART)))==0) OutOfMemory();
		pLastCall = pFirstCall;
	}
	else
	{
		if((pLastCall->next=mymalloc(sizeof(CALLPART)))==0) OutOfMemory();
		pLastCall = pLastCall->next;
	}

	pLastCall->type=TYP_UNKNOWN;
	pLastCall->inparam=0;
	pLastCall->find=0;
	pLastCall->mpi_initline=0;
	pLastCall->parameters=NULL;
	pLastCall->next=NULL;

	/*   */
	if(s!= NULL)
	{
		char* name;
		GetFileLine(s, &name, &pLastCall->line);
		strcpy(pLastCall->filename, name);
	}
	else
	{
		pLastCall->filename[0] = 0;
		pLastCall->line = 0;
	}
	return pLastCall;
}

/*   */
static PARAM* LockParam(BOOL NewParam)
{
	if(pFirstPar==NULL)
	{
		if((pFirstPar=mymalloc(sizeof(PARAM)))==0) OutOfMemory();
		pLastRow=pFirstPar;
		pLastPar=pFirstPar;
		pLastCall->parameters=pLastPar;
	}
	else
	{
		if((pLastRow->row=mymalloc(sizeof(PARAM)))==0) OutOfMemory();
		if(NewParam)
		{/*   */
			if(pLastCall->parameters==NULL)
			{/*   */
				pLastCall->parameters=pLastRow->row;
			}
			else
			{
				pLastPar->next=pLastRow->row;
			}
			pLastPar=pLastRow->row;
		}
		else pLastRow->exp = pLastRow->row;/*   */
		pLastRow = pLastRow->row;
	}

	pLastRow->name[0] = 0;
	pLastRow->type = TYP_UNKNOWN;
	pLastRow->variety=VRT_UNKNOWN;
	pLastRow->diapazon=NULL;
	pLastRow->row=NULL;
	pLastRow->exp=NULL;
	pLastRow->next=NULL;
	pLastRow->bCommon=FALSE;
	pLastRow->strlen=0;

	return pLastRow;
}

/***************************************************************/
/* */

/*   ( )*/
static void FreePar(PARAM* pCurrVariable)
{
	DIAPAZON *tek_diap;
	if(!pCurrVariable)
		return;
	while(pCurrVariable->diapazon!=NULL)
	{
		tek_diap = pCurrVariable->diapazon;
		pCurrVariable->diapazon = tek_diap->next;
		if(tek_diap->index) myfree(tek_diap->index);
		if(tek_diap->fExpression) myfree(tek_diap->fExpression);
		if(tek_diap->lExpression) myfree(tek_diap->lExpression);
		myfree(tek_diap);
	}
	myfree(pCurrVariable);
}

/*      */
void FreeCalls(CALLPART* first_call)
{
	CALLPART *tek_call;
	PARAM *pCurrVariable;
	BOOL bParamsIsDel=FALSE;

	while(first_call)
	{
		if(!bParamsIsDel && first_call->parameters)
		{
			while(first_call->parameters)
			{
				pCurrVariable = first_call->parameters;
				first_call->parameters = pCurrVariable->row;
				FreePar(pCurrVariable);
			}
			bParamsIsDel=TRUE;
		}
		tek_call = first_call;
		first_call = first_call->next;
		myfree(tek_call);
	}
}

/*  PARAMETER  IMPLICIT*/
static void FreeParams(void)
{
	while(first_params!=NULL)
	{
		last_params = first_params;
		first_params = first_params->next;
		myfree(last_params);
	}

	while(first_implicit!=NULL)
	{
		last_implicit = first_implicit;
		first_implicit = first_implicit->next;
		myfree(last_implicit);
	}
}

/*   COMMON  */
void FreeCommon()
{
	while(pCommonBlocks)
	{
		COMMON *tek=pCommonBlocks;
		pCommonBlocks=pCommonBlocks->next;
		while(tek->parameters)
		{
			PARAM *pCurrVariable = tek->parameters;
			tek->parameters = pCurrVariable->next;
			FreePar(pCurrVariable);
		}

		myfree(tek);
	}

	/*       */
	while(pMainVarNames)
	{
		PARAMETERS *pNext = pMainVarNames;
		pMainVarNames = pNext->next;
		myfree(pNext);
	}
}

/***************************************************************/

/***************************************************************/

static CALLPART *ReadParamString(char *allst, char *partname)
{
	int i;
	long first, last;
	char *start, *pos = allst;
	CALLPART *tek_call;
	PARAM *tek_param;
	DIAPAZON* tek_diap=NULL;

	pFirstCall=NULL;
	pFirstPar=NULL;

	while(*pos != '\0')
	{
		if(*pos=='\"')
		{/*  */
			tek_call = LockCall(NULL);
			i = strlen(partname);
			if(i>MAX_LEN_NAME) i = MAX_LEN_NAME;
			strncpy(tek_call->name, partname, i);
			tek_call->name[i] = '\0';

			pos++;
			start = pos;
			for(i=0; *pos!='\"'; pos++) i++;
			if(i>=MYMAXPATH) i = MYMAXPATH-1;
			strncpy(tek_call->filename, start, i);
			tek_call->filename[i] = '\0';

			if(sscanf(pos, "\"%ld?%ld?", &first, &last) != 2) return NULL;
			tek_call->line = first;
			tek_call->inparam = (int)last;

			for(i=0; i<2; pos++) if(*pos=='?') i++;
			continue;
		}
		if(*pos!='.' && *pos!=',') return NULL;

		/* */
		tek_param = LockParam(TRUE);
		if(*pos == '.') tek_param->variety = VRT_SCALAR;
		else if(*pos == ',') tek_param->variety = VRT_DIMENSION;
		pos++;
		switch(*pos)
		{
		case '+': tek_param->type = TYP_INT; break;
		case '-': tek_param->type = TYP_REAL; break;
		case '/': tek_param->type = TYP_DOUBLE; break;
		case '&': tek_param->type = TYP_PARTNAME; break;
		case '%': tek_param->type = TYP_FUNCNAME; break;
		case 'O': tek_param->type = TYP_INT1; break;
		case 'T': tek_param->type = TYP_INT2; break;
		case 'E': tek_param->type = TYP_INT8; break;
		case 'S': tek_param->type = TYP_INT16; break;
		case 'L': tek_param->type = TYP_BOOL; break;
		case 'C': tek_param->type = TYP_CHAR; break;
		case 'V': tek_param->type = TYP_VOID; break;
		case '?': tek_param->type = TYP_OTHER; break;
		default: return NULL;
		}
		pos++;

		if(*pos=='[')
		{/* */
			pos++;
			start = pos;
			for(i=0; *pos!=']'; pos++) i++;
			if(i>MAX_LEN_NAME) i = MAX_LEN_NAME;
			strncpy(tek_param->name, start, i);
			tek_param->name[i] = '\0';
			pos++;
		}
		while(*pos!='.' && *pos!=',' && *pos!='\0' && *pos!='\"')
		{
			start = pos;
			for(i=0; *pos!='!'; pos++) i++;
			if(sscanf(pos, "!%ld?%ld?", &first, &last) != 2) return NULL;
			if(tek_param->diapazon == NULL)
			{
				tek_param->diapazon = LockDiapazon(first, last);
				tek_diap=tek_param->diapazon;
			}
			else
			{
				tek_diap->next=LockDiapazon(first, last);
				tek_diap=tek_diap->next;
			}
			tek_diap->index = mymalloc(i+1);
			if(tek_diap->index == NULL) OutOfMemory();
			strncpy(tek_diap->index, start, i);
			tek_diap->index[i] = '\0';

			for(i=0; i<2; pos++) if(*pos=='?') i++;
		}
	}

	return pFirstCall;
}

/*    */
CALLPART *ReadParam(STRINGS **nov_string, char* partname)
{
	char* strFull;
	CALLPART* call;
	STRINGS* start = *nov_string;
	long length = 0;

	/* */
	if((*nov_string)->s[2]!='$' || (*nov_string)->s[7]!='(')
		return NULL;
	if((*nov_string)->s[8]!='\"')
		CnfInfDestroyed(*nov_string);

	/*    
	    */
	for(;;)
	{
		long novlen = strlen((*nov_string)->s);
		length += novlen;
		if((*nov_string)->s[novlen-1] == ')' ||
			((*nov_string)->s[novlen-1]=='\n' && (*nov_string)->s[novlen-2] == ')'))
			break;

		GetNextInfStr(nov_string);
	}

	strFull = mymalloc(length);
	if(strFull == NULL)
		OutOfMemory();

	*nov_string = start;
	/*    */
	length = 0;
	for(;;)
	{
		int offset;
		if(length == 0) /*  C $DIR (*/
			offset=8;
		else /*   */
			offset=2;

		strcpy(&strFull[length], &(*nov_string)->s[offset]);
		length += strlen(&(*nov_string)->s[offset]);
		/* \n*/
		if(strFull[length-1] == '\n')
			length--;
		GetNextInfStr(nov_string);
		/* */
		if(strFull[length-1]==')')
		{
			length--;
			break;
		}
	}
	strFull[length] = 0;

	/*     */
	if(strlen((*nov_string)->s)<3)
		GetNextInfStr(nov_string);

	call = ReadParamString(strFull, partname);
	myfree(strFull);

	if(!call)
		CnfInfDestroyed(*nov_string);
	return call;
}

/***************************************************************/

/*  */
static int num_par(CALLPART *call)
{
	int n=0;
	PARAM *tek_par;
	for(tek_par=call->parameters; tek_par; tek_par=tek_par->next)
		n++;

	return n;
}

/*  */
static long setka(DIAPAZON *tek_diap, BOOL* bUnknown)
{
	long size=1;
	*bUnknown = FALSE;

	while(tek_diap)
	{
		if(tek_diap->bfUnknown || tek_diap->blUnknown)
		{
			*bUnknown = TRUE;
			return 0;/* */
		}

		size=size*(tek_diap->last - tek_diap->first + 1);
		tek_diap = tek_diap->next;
	}

	return size;
}

/***************************************************************/

/***************************************************************/

char* GetPrintedType(VARTYPES type)
{
	switch(type)
	{
	case TYP_INT: return "INTEGER";
	case TYP_REAL: return "REAL";
	case TYP_DOUBLE: return "DOUBLE PRECISION";
	case TYP_INT1: return "INTEGER*1";
	case TYP_INT2: return "INTEGER*2";
	case TYP_INT8: return "INTEGER*8";
	case TYP_INT16: return "INTEGER*16";
	case TYP_BOOL: return "LOGICAL";
	case TYP_CHAR: return "CHARACTER";
	case TYP_VOID: return "void*";
	case TYP_PARTNAME: return "PART";
	case TYP_FUNCNAME: return "FUNCTION";
	case TYP_PROGRAMNAME: return "PROGRAM";
	default: return "?";
	}
}

/*     */
int GetDebugerType(PARAM* var)
{
	switch(var->type)
	{
	case TYP_INT: return 0;
	case TYP_REAL: return 1;
	case TYP_DOUBLE: return 2;
	case TYP_INT1: return 3;
	case TYP_INT2: return 4;
	case TYP_INT8: return 5;
	case TYP_INT16: return 6;
	case TYP_BOOL: return 7;
	case TYP_CHAR: return 100+var->strlen; /* CHAR 100+ */
	case TYP_VOID: return 9;
	case TYP_PARTNAME: return 10;
	case TYP_FUNCNAME: return 11;
	default: return 12;
	}
}

/*    */
static void PrintParam(PARAM *frm)
{
	DIAPAZON *dfrm;
	BOOL f = FALSE;

	printf(GetPrintedType(frm->type));
	if(frm->type == TYP_CHAR) printf("*%ld", frm->strlen);

	if(frm->name[0]==0) printf(" ?");
	else printf(" %s", frm->name);

	if(frm->variety == VRT_SCALAR || frm->variety == VRT_FUNCTION)
		return;

	printf("(");
	for(dfrm=frm->diapazon; dfrm; dfrm=dfrm->next)
	{
		if(f) printf(", ");
		f=TRUE;

		if(dfrm->index == NULL)
		{
			if(dfrm->bfUnknown)
			{
				if(dfrm->fExpression==NULL) printf("?:");
				else printf("%s:", dfrm->fExpression);
			}
			else if(dfrm->first != 1) printf("%ld:", dfrm->first);
		}
		else
		{
			printf(dfrm->index);
			if(dfrm->bfUnknown)
			{
				if(dfrm->fExpression==NULL) printf("=?..");
				else printf("=%s..", dfrm->fExpression);
			}
			else printf("=%ld..", dfrm->first);
		}
		if(dfrm->blUnknown)
		{
			if(dfrm->lExpression==NULL) printf("?");
			else printf(dfrm->lExpression);
		}
		else printf("%ld", dfrm->last);
	}
	printf(")");
}

void Print2Param(PARAM *frm, PARAM *fkt)
{
	printf("  ");
	PrintParam(frm);
	printf("<-");
	PrintParam(fkt);
	printf(".\n");
}

static BOOL bIsPrinted;
/*  " "*/
void PrintPartNames(char *to , char*from)
{
	if(!bIsPrinted)
	{
		printf(message[33], to, from);
		bIsPrinted = TRUE;
	}
}

/***************************************************************/

/*    
frm -  fkt - 
partname-   */
void CompareParam(CALLPART *fcall, CALLPART *acall, char* partname)
{
	PARAM *frm, *fkt;
	DIAPAZON *dfrm, *dfkt;
	long frm_set, fkt_set;
	int flag_comp, n_param, n_set;

	for( ; acall; acall = acall->next)
	{
		if(fcall->find > acall->find) flag_comp=fcall->find;
		else flag_comp=acall->find;

		bIsPrinted = FALSE;
		if(bPrintDetail) PrintPartNames(fcall->name, partname);

		/*  */
		if(num_par(fcall)!=num_par(acall))
		{
			CnfParamError(fcall, acall, partname, 34, 0, 0);
			continue;
		}
		/*  -  RESULT*/
		if(fcall->inparam!=acall->inparam && flag_comp==0)
		{
			CnfParamNfErr(fcall, acall, partname, 39, 0, 0);
		}

		frm=fcall->parameters;
		fkt=acall->parameters;
		for(n_param=1; fkt; frm=frm->next,fkt=fkt->next,n_param++)
		{
			BOOL bIsParamPrinted = FALSE;
			BOOL bFrmDim, bFktDim;

			/* */
			if(frm->type != fkt->type)
			{
				if(flag_comp==2) CnfParamWarning(fcall, acall, partname, 36, 0, n_param);
				else CnfParamNfErr(fcall, acall, partname, 36, 0, n_param);
				bIsParamPrinted = TRUE;
			}

			bFrmDim = (frm->variety==VRT_DIMENSION || frm->variety==VRT_POINTER);
			bFktDim = (fkt->variety==VRT_DIMENSION || fkt->variety==VRT_POINTER);
			/*-*/
			if((bFrmDim && !bFktDim) || (!bFrmDim && bFktDim))
			{
				if(flag_comp==0) CnfParamError(fcall, acall, partname, 35, 0, n_param);
				else CnfParamWarning(fcall, acall, partname, 35, 0, n_param);
				bIsParamPrinted = TRUE;
			}
			if(bFrmDim && bFktDim)
			{

				/*  */
				BOOL bFrmUnknown, bFktUnknown;
				frm_set=setka(frm->diapazon, &bFrmUnknown);
				fkt_set=setka(fkt->diapazon, &bFktUnknown);

				/*  */
				if(bFrmUnknown || bFktUnknown)
				{
					CnfParamWarning(fcall, acall, partname, 49, 0, n_param);
					bIsParamPrinted = TRUE;
				}
				else if(frm_set != fkt_set)
				{/*  */
					if(flag_comp==0) CnfParamError(fcall, acall, partname, 35, 0, n_param);
					else CnfParamWarning(fcall, acall, partname, 35, 0, n_param);
					bIsParamPrinted = TRUE;
					continue;
				}

				/*  */
				dfrm=frm->diapazon;
				dfkt=fkt->diapazon;
				for(n_set=1; dfrm && dfkt; dfrm=dfrm->next,dfkt=dfkt->next,n_set++)
				{
					/*  */
					if(flag_comp==0 && strcmp(dfrm->index, dfkt->index)!=0)
					{
						CnfParamWarning(fcall, acall, partname, 41, n_set, n_param);
						bIsParamPrinted =	TRUE;
					}
					/* */
					if(!dfrm->bfUnknown && !dfrm->blUnknown && !dfkt->bfUnknown && !dfkt->blUnknown)
					{
						if(dfrm->last-dfrm->first != dfkt->last-dfkt->first)
						{/*  */
							if(flag_comp==0) CnfParamNfErr(fcall, acall, partname, 38, n_set, n_param);
							else CnfParamWarning(fcall, acall, partname, 38, n_set, n_param);
							bIsParamPrinted =	TRUE;
							continue;
						}
					}

					/*  */
					if((!C_OUT || flag_comp==0)&&
						((!dfrm->bfUnknown && !dfkt->bfUnknown && dfrm->first != dfkt->first) ||
						(!dfrm->blUnknown && !dfkt->blUnknown && dfrm->last != dfkt->last)))
					{
						CnfParamWarning(fcall, acall, partname, 40, n_set, n_param);
						bIsParamPrinted = TRUE;
					}
				}

				/*  */
				if(dfrm || dfkt)
				{
					if(flag_comp==0) CnfParamNfErr(fcall, acall, partname, 37, n_set, n_param);
					else CnfParamWarning(fcall, acall, partname, 37, n_set, n_param);
					bIsParamPrinted = TRUE;
				}
			}
			if(!bIsParamPrinted && bPrintDetail) Print2Param(frm, fkt);
		}
	}
}

/***************************************************************/

/*        IMPLICIT*/
static VARTYPES GetTypeByName(char name)
{
	IMPLICIT *tek_implicit;
	/*    */
	if(name>='a'&&name<='z') name = (char)(name-'a'+'A');
	/*   IMPLICIT*/
	for(tek_implicit=first_implicit;tek_implicit!=NULL;tek_implicit=tek_implicit->next)
	{
		if(name >= tek_implicit->first && name <= tek_implicit->last)
					return tek_implicit->type;
	}
	/*   */
	if(name > 'H' && name < 'O') return TYP_INT;
	return TYP_REAL;
}

/*   */
static CALLPART* MakeParams(void)
{
	int i;
	PARAM *tek_par, *sub_par;
	CALLPART *tek_call;
	VARTYPES types[] = {TYP_INT1,TYP_INT2,TYP_INT,TYP_INT8,TYP_INT16,TYP_REAL,TYP_DOUBLE};

	for(tek_call=pFirstCall; tek_call!=NULL; tek_call=tek_call->next)
	{
		if(bNoIncludeFile) tek_call->find = 2;
		else tek_call->find = 1;

		for(tek_par=tek_call->parameters;tek_par!=NULL;tek_par=tek_par->next)
		{
			/*  */
			if(tek_par->type==TYP_UNKNOWN)
					tek_par->type=GetTypeByName(tek_par->name[0]);
			if(tek_par->variety==VRT_UNKNOWN)
			{
				if(tek_par->diapazon) tek_par->variety = VRT_DIMENSION;
				else tek_par->variety = VRT_SCALAR;
			}
			if(tek_par->variety==VRT_DIMENSION && tek_par->diapazon==NULL)
				tek_par->variety=VRT_SCALAR; /*   */

			/* -   */
			while(tek_par->exp!=NULL)
			{
				tek_par->variety = VRT_SCALAR;
				sub_par = tek_par->exp;
				tek_par->exp = sub_par->exp;
				tek_par->row = sub_par->row;

				/*char  BOOL    */
				if(sub_par->type==TYP_UNKNOWN) sub_par->type=GetTypeByName(sub_par->name[0]);
				if(sub_par->type==tek_par->type ||
					sub_par->type==TYP_CHAR || sub_par->type==TYP_BOOL)
				{
					FreePar(sub_par);
					continue;
				}
				/*INT1<INT2<INT4<INT8<INT16<REAL<DOUBLE*/
				for(i=0; types[i] != 0; i++)
				{
					if(sub_par->type == types[i]) break;
					if(tek_par->type == types[i])
					{
						tek_par->type = sub_par->type;
						break;
					}
				}
				FreePar(sub_par);
			}
		}
	}
	return pFirstCall;
}

/***************************************************************/

/***************************************************************/

/*  */
#define OP_SUBROUTINE		0
#define OP_FUNCTION			1
#define OP_INTEGER			2
#define OP_REAL				3
#define OP_DOUBLE_PRECISION	4
#define OP_END				5
#define OP_RESULT			6
#define OP_IMPLICIT			7
#define OP_NONE				8
#define OP_DIMENSION		9
#define OP_PARAMETER		10
#define OP_INCLUDE			11
#define OP_CALL				12
#define OP_LOGICAL			13
#define OP_CHARACTER		14
#define OP_COMMON			15
#define OP_RETURN			16
#define OP_BLOCK_DATA		17
#define OP_ALLOCATE			18
#define OP_POINTER			19
#define OP_IF				20
#define OP_FORMAT			21
#define OP_CASE				22
#define OP_SELECT			23
#define OP_PROGRAM			24
#define OP_INTERFACE		25
#define OP_EXTERNAL			26
#define OP_EQUIVALENCE		27
#define OP_USE				28
#define OP_COMPLEX			29
#define OP_TYPE				30
#define OP_ALLOCATABLE		31
#define OP_INTENT			32
#define OP_INTRINSIC		33
#define OP_OPTIONAL			34
#define OP_NAMELIST			35
#define OP_ENTRY			36
#define OP_DATA				37
#define OP_CONTAINS			38

#define FORTRAN_WORD_LEN	39

static const char *arrFortranKeyWord[FORTRAN_WORD_LEN]=
{
	"SUBROUTINE",
	"FUNCTION",
	"INTEGER",
	"REAL",
	"DOUBLE PRECISION",
	"END",
	"RESULT",
	"IMPLICIT",
	"NONE",
	"DIMENSION",
	"PARAMETER",
	"INCLUDE",
	"CALL",
	"LOGICAL",
	"CHARACTER",
	"COMMON",
	"RETURN",
	"BLOCK DATA",
	"ALLOCATE",
	"POINTER",
	"IF",
	"FORMAT",
	"CASE",
	"SELECT",
	"PROGRAM",
	"INTERFACE",
	"EXTERNAL",
	"EQUIVALENCE",
	"USE",
	"COMPLEX",
	"TYPE",
	"ALLOCATABLE",
	"INTENT",
	"INTRINSIC",
	"OPTIONAL",
	"NAMELIST",
	"ENTRY",
	"DATA",
	"CONTAINS"
};

static const int arrFortranKeyLen[FORTRAN_WORD_LEN]=
	{10,8,7,4,16,3,6,8,4,9,9,7,4,7,9,6,6,10,8,7,2,6,4,6,7,9,8,11,3,7,4,11,6,9,8,8,5,4,8};
/*     */
BOOL IsFortranKeyword(char *st, int key)
{
	int len = arrFortranKeyLen[key];
	return(strnicmp(st, arrFortranKeyWord[key], len)==0 &&
		(st[len]<'A'||st[len]>'Z') && (st[len]<'a'||st[len]>'z') &&
		(st[len]<'0'||st[len]>'9') && st[len]!='_');
}

static int GetFortranKeyword(char *st)
{
	int key;
	for(key=0; key<FORTRAN_WORD_LEN; key++)
	{
		if(IsFortranKeyword(st, key))
			return key;
	}
	return -1;
}

/***************************************************************/

/***************************************************************/

/*  */
static BOOL TypeConvert(char *s, int *a, VARTYPES *type, long *size)
{
	char buf[30];
	int b;
	for(b=0; b<29; (*a)++)
	{
		if(s[*a]==' ' || s[*a]=='\t')
			continue;
		if(s[*a]<'0'||s[*a]>'9') break;
		buf[b] = s[*a];
		b++;
	}
	if(b==0 || b>28) return FALSE;
	buf[b] = '\0';

	*size = atol(buf);
	if(*size == 0) return FALSE;

	switch(type[0])
	{
		case TYP_INT:
			switch(*size)
			{
			case 1:
				type[0] = TYP_INT1;
				break;
			case 2:
				type[0] = TYP_INT2;
				break;
			case 4:
				break;
			case 8:
				type[0] = TYP_INT8;
				break;
			case 16:
				type[0] = TYP_INT16;
				break;
			default:
				type[0] = TYP_OTHER;
				break;
			}
			break;
		case TYP_REAL:
			if(*size != 4) type[0] = TYP_OTHER;
			if(*size == 8) type[0] = TYP_DOUBLE;
			break;
		case TYP_DOUBLE:
			if(*size != 8) type[0] = TYP_OTHER;
			break;
		case TYP_BOOL: break; /*LOGICAL*/
		case TYP_CHAR: break; /*CHARACTER*/
		default:
			return FALSE;
	}
	return TRUE;
}

/*  . : TYP_UNKNOWN- TYP_PROGRAMNAME-
 TYP_PARTNAME- TYP_FUNCNAME-     */
static VARTYPES FindPartDeclaration(char *s, int *a, char *partname, int nPartLen)
{
	VARTYPES type = TYP_UNKNOWN;
	int m=0, i;
	*a=0;
	if(strchr("Cc!*\n#", s[0])) return TYP_UNKNOWN;
	while(m==0)
	{
		while(s[*a]==' ' || s[*a]=='\t') (*a)++;
		if(m==0 && type!=TYP_UNKNOWN && s[*a]=='*')
		{
			long size;
			/*  */
			(*a)++;
			if(!TypeConvert(s, a, &type, &size)) return TYP_UNKNOWN;
		}
		i=GetFortranKeyword(&s[*a]);
		switch(i)/*  */
		{
		case OP_SUBROUTINE:
			m=1;
			type=TYP_PARTNAME;
			break;
		case OP_PROGRAM:
			m=1;
			type=TYP_PROGRAMNAME;
			break;
		case OP_FUNCTION:
			m=1;
			if(type == TYP_UNKNOWN)
				type = TYP_FUNCNAME;
			break;
		case OP_INTEGER:
			type=TYP_INT;
			break;
		case OP_REAL:
			type=TYP_REAL;
			break;
		case OP_DOUBLE_PRECISION:
			type=TYP_DOUBLE;
			break;
		case OP_LOGICAL:
			type=TYP_BOOL;
			break;
		case OP_CHARACTER:
			type=TYP_CHAR;
			break;
		default:
			return TYP_UNKNOWN;
		}
		*a=*a + arrFortranKeyLen[i];
	}
	while(s[*a]==' ' || s[*a]=='\t') (*a)++;
	if(strnicmp(&s[*a], partname, nPartLen)!=0) return TYP_UNKNOWN;
	*a+=nPartLen;
	if(!strchr("( \n\t", s[*a])) return TYP_UNKNOWN;
	return type;
}

/*   ( ,  )
 1    , 2  */
static int GetNextSymb(char **s, int *a)
{
	int b=0,c=0;
	while(1)
	{
		if(*a!=0)
		{
			while((*s)[*a]==' ' || (*s)[*a]=='\t') (*a)++;
			if((*s)[*a]!='\n' && (*s)[*a]!=0 && (*s)[*a]!='!') break;
		}
		while(strchr("Cc!*#\n", (*s)[*a]))
		{
			(*a)=0; b=1; c=0;
			(*s) = GetNextString(TRUE);
			if(*s==NULL) return 2;
		}
		for(*a=0;*a<5;(*a)++)
		{
			if((*s)[*a]=='\t'){ c=1; (*a)++; break; }
			if((*s)[*a]=='\n' || (*s)[*a]==0 || (*s)[*a]=='!') break;
		}
		if(*a==5 && c==0 && (*s)[*a]!='\n' && (*s)[*a]!=0) (*a)++;
	}
	if(c==1) return 1;
	if(b==1 && ((*s)[5]==' ' || (*s)[5]=='\t')) return 1;
	return 0;
}

/*   
 0        ,  ";"
1    , 2  */
static int GetNextOperator(char **s, int *a)
{
	while(TRUE)
	{
		char ch;

		int res = GetNextSymb(s, a);
		if(res>0)
			return res;

		ch = (*s)[*a];

		if(ch == ';')
			return 0;

		/* */
		if(ch=='"' || ch=='\'')
		{
			for((*a)++; (*s)[*a]!=ch && (*s)[*a]!=0; (*a)++)
				;
		}
		if((*s)[*a] != 0)
			(*a)++;
	}
}

/*       */
BOOL IsEndPart(char *s)
{
	int t,a=0;
	if(C_OUT)
	{
		if(strcmp(s,"}\n")==0||strcmp(s,"}")==0)return TRUE;
		return FALSE;
	}
	else
	{
		if(strchr("Cc!\n*#", s[a])) return FALSE;
		while(1)
		{
			while(s[a]==' ' ||s[a]=='\t') a++;
			if(IsFortranKeyword(&s[a], OP_END))
			{
				a += arrFortranKeyLen[OP_END];
				while(s[a]==' ' || s[a]=='\t') a++;
				if(s[a]=='\n' || s[a]=='!' || s[a]==0) return TRUE;
				t=GetFortranKeyword(&s[a]);
				if(t==OP_SUBROUTINE||t==OP_FUNCTION||t==OP_BLOCK_DATA) return TRUE;
			}

			/* ; c  */
			for(; s[a]!=';'; a++)
			{
				if(s[a]=='!' || s[a]==0)
					return FALSE;

				if(s[a]=='"' || s[a]=='\'')
				{
					char commas = s[a];
					for(a++; s[a] != commas; a++)
						if(s[a]==0)
							return FALSE;
				}
			}

			if(s[a]!=';')
				InternalError();
			a++;
		}
	}
}

/*      
:          
:       (  )*/
static BOOL SkipParenthesis(char **s, int *a)
{
	int count = 0;

	while(GetNextSymb(s, a) == 0)
	{
		if((*s)[*a]=='(')
		{
			count++;
		}
		else if((*s)[*a]==')')
		{
			count--;
			if(count<=0)
			{
				(*a)++;
				return TRUE;
			}
		}
		(*a)++;
	}
	return FALSE;
}

/***************************************************************/
/*     ( )
 1    , 2-  3-*/
static int CopyNameF77(char** s, int*a, char* dest)
{
	int b=0, r;

	while((r=GetNextSymb(s, a)) == 0 &&
		(((*s)[*a]>='A' && (*s)[*a]<='Z') || ((*s)[*a]>='a' && (*s)[*a]<='z') ||
		((*s)[*a]>='0' && (*s)[*a]<='9') || (*s)[*a]=='_'))
	{
		if(b==0 && (*s)[*a]>='0' && (*s)[*a]<='9') break;
		if(b < MAX_LEN_NAME)
		{
			dest[b]=(*s)[*a];
			b++;
		}
		(*a)++;
	}
	dest[b]=0;

	if(b>0) return r;
	return 3;
}

/***************************************************************/

/*  tek_par      */
static BOOL FindAllAndCopy(PARAM* tek_par, BOOL bArray)
{
	DIAPAZON* next_diap = NULL, *tek_diap;
	PARAM* next_par;
	unsigned int len;
	if(tek_par==NULL) return TRUE;
	len=strlen(tek_par->name);

	for(next_par=tek_par->row;next_par!=NULL;next_par=next_par->row)
	{
		if(strlen(next_par->name) == len &&
			strnicmp(next_par->name, tek_par->name, len) == 0)
		{
		/**/
			if(next_par->diapazon!=NULL) return FALSE;/*  ?*/
			next_par->type=tek_par->type;
			next_par->strlen=tek_par->strlen;
			if(next_par->variety==VRT_SCALAR ||
				next_par->variety == VRT_FUNCTION) continue;
			if(!bArray) { next_par->variety=VRT_SCALAR; continue; }
			next_par->variety=tek_par->variety;
			for(tek_diap=tek_par->diapazon;
								tek_diap!=NULL;tek_diap=tek_diap->next)
			{
				if(next_par->diapazon==NULL)
				{
					next_par->diapazon=LockDiapazon(tek_diap->first, tek_diap->last);
					next_diap = next_par->diapazon;
				}
				else
				{
					next_diap->next=LockDiapazon(tek_diap->first, tek_diap->last);
					next_diap = next_diap->next;
				}
				if(tek_diap->fExpression)
				{
					next_diap->fExpression = mymalloc(strlen(tek_diap->fExpression)+1);
					if(!next_diap->fExpression) OutOfMemory();
					strcpy(next_diap->fExpression, tek_diap->fExpression);
				}
				if(tek_diap->lExpression)
				{
					next_diap->lExpression = mymalloc(strlen(tek_diap->lExpression)+1);
					if(!next_diap->lExpression) OutOfMemory();
					strcpy(next_diap->lExpression, tek_diap->lExpression);
				}
				next_diap->bfUnknown = tek_diap->bfUnknown;
				next_diap->blUnknown = tek_diap->blUnknown;
			}
		}
	}
	return TRUE;
}

/***************************************************************/

/*   COMMON       ,    */
static COMMON* GetCommon(char* blockname)
{
	COMMON* tek;

	if(!bFindAllVars)
		return NULL;

	if(pCommonBlocks == NULL)
	{
		pCommonBlocks=mymalloc(sizeof(COMMON));
		if(pCommonBlocks == NULL)
			OutOfMemory();
		strcpy(pCommonBlocks->name, blockname);
		pCommonBlocks->parameters = NULL;
		pCommonBlocks->NextPosition = NULL;
		pCommonBlocks->bMainPart = FALSE;
		pCommonBlocks->next = NULL;
		return pCommonBlocks;
	}

	for(tek=pCommonBlocks; ; tek=tek->next)
	{
		if(stricmp(tek->name, blockname)==0)
			return tek;

		//   - 
		if(tek->next == NULL)
		{
			tek->next=mymalloc(sizeof(COMMON));
			if(tek->next == NULL)
				OutOfMemory();
			strcpy(tek->next->name, blockname);
			tek->next->parameters = NULL;
			tek->next->NextPosition = NULL;
			tek->next->bMainPart = FALSE;
			tek->next->next = NULL;

			return tek->next;
		}
	}

	return NULL;
}

COMMON* GetNextCommon(COMMON* tek)
{
	if(tek == NULL)
		return pCommonBlocks;
	else
		return tek->next;
}

/*    COMMON*/
static BOOL AddCommonVariable(COMMON *pCommon, PARAM *pVariable)
{
	PARAM *pNewVar, *pNextVar;
	COMMON *pNextCommon;
	BOOL bIsUniqueName;
	PARAMETERS *pNext;

	if(pCommon == NULL || pVariable == NULL)
		return TRUE;
	if(!bFindAllVars)
		return TRUE;

	/*   COMMON    ,    
	  */
	if(pCommon->NextPosition != NULL)
	{
		if(stricmp(pCommon->NextPosition->name, pVariable->name) == 0)
		{
			pVariable->bCommon=TRUE;
		}

		if(pCommon->NextPosition->next != NULL)
			pCommon->NextPosition = pCommon->NextPosition->next;

		return TRUE;
	}

	bIsUniqueName = TRUE;
	/*       ,
	   COMMON*/
	for(pNext=pMainVarNames; pNext; pNext=pNext->next)
	{
		if(stricmp(pNext->name, pVariable->name) == 0)
		{
			bIsUniqueName=FALSE;
			break;
		}
	}

	/*       COMMON.
	  ,     .
	            */
	for(pNextCommon = pCommonBlocks; pNextCommon != NULL && bIsUniqueName; pNextCommon = pNextCommon->next)
	{
		if(pNextCommon == pCommon) //    
			continue;

		for(pNextVar = pNextCommon->parameters; pNextVar != NULL; pNextVar = pNextVar->next)
		{
			if(stricmp(pNextVar->name, pVariable->name) == 0)
			{
				bIsUniqueName=FALSE;
				break;
			}
		}
	}

	for(pNextVar = pCommon->parameters; pNextVar != NULL; pNextVar = pNextVar->next)
	{
		if(pNextVar->next == NULL)
			break;
	}

	pNewVar=mymalloc(sizeof(PARAM));
	if(pNewVar == NULL) OutOfMemory();

	/*   ,  */
	strcpy(pNewVar->name, pVariable->name);
	pNewVar->type = TYP_UNKNOWN;
	pNewVar->variety=VRT_UNKNOWN;
	pNewVar->diapazon=NULL;
	pNewVar->row=NULL;
	pNewVar->exp=NULL;
	pNewVar->next=NULL;
	pNewVar->bCommon=bIsUniqueName;
	pNewVar->strlen=0;
	pVariable->bCommon=bIsUniqueName;

	if(pNextVar == NULL)
		pCommon->parameters = pNewVar;
	else
		pNextVar->next = pNewVar;

	return TRUE;
}

/*     COMMON*/
static BOOL SetCommonVariables(CALLPART* tek_call)
{
	PARAM *pCommonVar;
	COMMON* pCommon;

	if(!bFindAllVars)
		return TRUE;

	for(pCommon = pCommonBlocks; pCommon != NULL; pCommon = pCommon->next)
	{
		/*    */
		if(pCommon->NextPosition != NULL)
			continue;

		for(pCommonVar = pCommon->parameters; pCommonVar != NULL; pCommonVar = pCommonVar->next)
		{
			PARAM *tek_par;
			DIAPAZON *tek_diap, *pCommonDiap = NULL;

			for(tek_par=tek_call->parameters; tek_par!=NULL; tek_par=tek_par->next)
			{
				BOOL bUnknown;
				if(stricmp(pCommonVar->name, tek_par->name) != 0)
					continue;

				setka(tek_par->diapazon, &bUnknown);
				if(bUnknown)
				{
					/* :    COMMON    */
					CnfWarning(GetStrStatic(), 55, tek_par->name, pCommon->name);
				}

				/* */
				pCommonVar->type = tek_par->type;
				pCommonVar->variety = tek_par->variety;
				pCommonVar->strlen = tek_par->strlen;

				/* */
				for(tek_diap=tek_par->diapazon; tek_diap!=NULL; tek_diap=tek_diap->next)
				{
					if(pCommonVar->diapazon == NULL)
					{
						pCommonVar->diapazon = LockDiapazon(tek_diap->first, tek_diap->last);
						pCommonDiap = pCommonVar->diapazon;
					}
					else
					{
						pCommonDiap->next = LockDiapazon(tek_diap->first, tek_diap->last);
						pCommonDiap = pCommonDiap->next;
					}

					if(pCommonDiap->bfUnknown)
					{
						pCommonDiap->first = 1;
						pCommonDiap->bfUnknown = FALSE;
					}
					if(pCommonDiap->blUnknown)
					{
						pCommonDiap->last = 1;
						pCommonDiap->blUnknown = FALSE;
					}
				}
			}
		}
	}

	return TRUE;
}

/*  ,       COMMON,
      */
void SetLocalVariable(char* varname)
{
	PARAMETERS *pNext;
	int len;

	if(pMainVarNames == NULL)
	{
		pMainVarNames = mymalloc(sizeof(PARAMETERS));
		pNext = pMainVarNames;
	}
	else
	{
		for(pNext=pMainVarNames; ; pNext=pNext->next)
		{
			if(stricmp(pNext->name, varname) == 0)
				return;
			if(pNext->next == NULL)
				break;
		}
		pNext->next = mymalloc(sizeof(PARAMETERS));
		pNext=pNext->next;
	}

	if(pNext==NULL) OutOfMemory();
	pNext->next = NULL;

	len = strlen(varname);
	if(len>MAX_LEN_NAME) len = MAX_LEN_NAME;
	strncpy(pNext->name, varname, len);
	pNext->name[len] = '\0';
}

/***************************************************************/

#define VALUES struct Values
VALUES
{
	long value;
	char sign; /* + - * / P */
	VALUES *next;
};

static VALUES* AddValues(VALUES *last, long value, char sign)
{
	VALUES *newlast = mymalloc(sizeof(VALUES));
	if(newlast==NULL) OutOfMemory();

	newlast->value = value;
	newlast->sign = sign;
	newlast->next = NULL;
	if(last) last->next = newlast;
	return newlast;
}

static void FreeValues(VALUES* first)
{
	VALUES* next;
	while(first)
	{
		next = first->next;
		myfree(first);
		first = next;
	}
}

/*    value*/
static BOOL GetValue(char *varname, long *value, PARAM** determ, BOOL *bUnknown)
{
	PARAMETERS* find_params;
	*determ = NULL;
	*bUnknown = FALSE;

	/*  */
	find_params = first_params;
	while(find_params)
	{
		if(stricmp(find_params->name, varname)==0)
		{
			*value = find_params->value;
			return TRUE;
		}
		find_params=find_params->next;
	}

	*value = 0;
	*bUnknown = TRUE;
	/*   */
	for((*determ)=pFirstPar; *determ!=NULL; *determ=(*determ)->next)
	{
		if(stricmp((*determ)->name, varname)==0)
		{
			return TRUE;
		}
	}
	return FALSE;
}

/*   ,   ,  FALSE   */
static BOOL ReadNumber(char *s, int *a, long *value)
{
	char numb[22];
	int b=0;
	*value = 0;

	while(s[*a]>='0' && s[*a]<='9')
	{
		if(b < 21)
		{
			numb[b]=s[*a];
			b++;
		}
		(*a)++;
	}
	if(b==0) return FALSE;/* */
	numb[b]=0;
	*value = atol(numb);

	if(s[*a]=='.')/*  */
	{
		(*a)++;
		while(!strchr("(),;:/+-*\n", s[*a])) (*a)++;
	}
	return TRUE;
}

/*   ;  -  value*/
static BOOL CalcValues(VALUES* first, long *value)
{
	VALUES *next=first, *second;
	*value = 0;

	/*  */
	while(next && next->next)
	{
		second = next->next;
		if(second->sign == 'P')
		{
			next->value = (long)pow((double)next->value, (double)second->value);
			next->next = second->next;
			myfree(second);
		}
		else next = next->next;
	}

	/*  */
	next=first;
	while(next && next->next)
	{
		second = next->next;
		if(second->sign=='*')
		{
			next->value = next->value * second->value;
			next->next = second->next;
			myfree(second);
		}
		else if(second->sign=='/')
		{
			 /*    0  ,      - */
			if(second->value==0)
				next->value = 0;
			else
				next->value = next->value / second->value;
			next->next = second->next;
			myfree(second);
		}
		else next = next->next;
	}

	/*  */
	next=first;
	while(next)
	{
		switch(next->sign)
		{
			case '+':
			*value = (*value)+next->value;
			break;
			case '-':
			*value = (*value)-next->value;
			break;
			default:
			return FALSE;
		}
		next = next->next;
	}

	return TRUE;
}

/*   ,        
 , s-, a-  ,    value
bUnknown -    .
 bIsedVariables     ,    */
static BOOL CalculateExpression(char *s, int *a, long* value, BOOL bIsedVariables, BOOL *bUnknown)
{
	char varname[MAX_LEN_NAME+1];
	char sign = '+';
	long brvalue;
	VALUES *first=NULL, *last=NULL;
	*value = 0;

	while(s[*a]!='\0' && s[*a]!=')' && s[*a]!=',' && s[*a]!=':')
	{
		if(s[*a]=='+' || s[*a]=='-' || s[*a]=='*' || s[*a]=='/')
		{
			sign = s[*a];
			(*a)++;
			if(sign == '*' && s[*a] == '*')
			{
				sign = 'P';
				(*a)++;
			}
		}

		if(s[*a] == '(')
		{
			(*a)++;
			if(!CalculateExpression(s, a, &brvalue, bIsedVariables, bUnknown))
			{
				FreeValues(first);
				return FALSE;
			}
			if(*bUnknown)
			{
				FreeValues(first);
				return TRUE;
			}
			if(s[*a] != ')')
			{
				FreeValues(first);
				return FALSE;
			}
			(*a)++;
		}
		else
		{
			if(!ReadNumber(s, a, &brvalue))/* */
			{
				/*   */
				PARAM* determ;
				int b=0;
				while((s[*a]>='A' && s[*a]<='Z') || (s[*a]>='a' && s[*a]<='z') ||
					(s[*a]>='0' && s[*a]<='9') || s[*a]=='_')
				{
					if(b < MAX_LEN_NAME)
					{
						varname[b]=s[*a];
						b++;
					}
					(*a)++;
				}
				varname[b]=0;
				if(b==0)
				{
					FreeValues(first);
					return FALSE;
				}

				if(!GetValue(varname, &brvalue, &determ, bUnknown) && !bIsedVariables)
				{/*  */
					if(!CompareNames(varname, "MPI_STATUS_SIZE"))
					{
						if(!bNoIncludeFile)
							CnfNfErr(GetStrStatic(), 48, varname);
						else CnfWarning(GetStrStatic(), 48, varname);
					}
				}
				if(*bUnknown)
				{
					FreeValues(first);
					return TRUE;
				}
			}
		}
		last = AddValues(last, brvalue, sign);
		if(first==NULL) first=last;
	}

	/* */
	if(!CalcValues(first, value))
	{
		FreeValues(first);
		return FALSE;
	}

	FreeValues(first);
	return TRUE;
}

/*   ,   value
bUnknown -    
(      Expression)*/
static BOOL CalcExpression(char **s, int *a, long* value, char** expression, BOOL bIsedVariables, BOOL *bUnknown)
{
	int aa=0;
	int skobki = 0, len = 0, size = 50;
	*expression = mymalloc(size);
	if((*expression)==NULL) OutOfMemory();
	*bUnknown = FALSE;

	while(skobki>0 || ((*s)[*a]!=')'&&(*s)[*a]!=','&&(*s)[*a]!=':'))
	{
		if((*s)[*a] == '(') skobki++;
		if((*s)[*a] == ')') skobki--;

		(*expression)[len] = (*s)[*a];
		len++;
		(*a)++;
		if(len == size)
		{
			size += 50;
			*expression = myrealloc(*expression, size);
			if((*expression)==NULL) OutOfMemory();
		}
		if(GetNextSymb(s, a)>0) return FALSE;
	}
	(*expression)[len] = 0;

	if(!CalculateExpression(*expression, &aa, value, bIsedVariables, bUnknown))
		return FALSE;

	if(!(*bUnknown))
	{
		myfree(*expression);
		*expression=NULL;
	}
	return TRUE;
}

/***************************************************************/

static BOOL GetAllParameters(BOOL bEOFasError);
static void MarkFunctions(void);
static int ParseOperator(char* s, long* len);

/*  CALL
 2  , 1  */
static int ParsingCALL(char **s, int *a)
{
	char name[MAX_LEN_NAME+1];
	int res;

	if(GetNextSymb(s, a)!=0)
		return 2;

	res = CopyNameF77(s, a, name);
	if(res==2)
		return 1;
	if(res==3)
		return 2;

	/*  CALL Mpi_init(),  mpi_initline     */
	if(pLastCall->type==TYP_PROGRAMNAME &&
		pLastCall->mpi_initline<1 && stricmp(name, "MPI_Init")==0)
	{
		/*  ParseOperator   */
		ParseOperator(*s, &pLastCall->mpi_initline);
		pLastCall->mpi_initline += GetStringLine(GetStrStatic());
	}
	else
	{
		/*     ,     */
		PARAM *pNextPar;
		for(pNextPar=pFirstCall->parameters; pNextPar!=NULL; pNextPar=pNextPar->next)
		{
			if(stricmp(pNextPar->name, name)==0)
			{
				pNextPar->variety = VRT_FUNCTION;
				break;
			}
		}
	}

	if(res==0 && GetNextOperator(s, a) == 2)
		return 1;

	return 0;
}

/*    
 2  ,1- ; type-; oper-*/
static int ParsingDEFINES(char **s, int *a, VARTYPES type, char oper)
{
	int b;
	BOOL bArray;
	PARAM *pCurrVariable;
	DIAPAZON *tek_diap;
	COMMON *pCurrCommon = NULL;
	char varname[MAX_LEN_NAME+1];
	long strlen=0;

	if(oper!=OP_COMMON && (*s)[*a]=='*')/* */
	{
		(*a)++;
		if(GetNextSymb(s, a)>0) return 2;
		if(!TypeConvert(*s, a, &type, &strlen)) return 2;
		if(GetNextSymb(s, a)>0) return 2;
	}
	if(oper==OP_COMMON)
	{
		if(GetNextSymb(s, a)>0) return 2;
		if((*s)[*a]!='/') /*  */
			pCurrCommon = GetCommon("");
	}
	while(1)
	{
		if((b=GetNextSymb(s, a))>0) return(b-1);
		if((*s)[*a]==',' || (*s)[*a]==':'){(*a)++;continue;}
		if((*s)[*a]==';') return 0;
		/*    COMMON*/
		if(oper==OP_COMMON && (*s)[*a]=='/')
		{
			(*a)++;
			if(GetNextSymb(s, a)>0) return 2;
			if((*s)[*a]=='/') /*  */
			{
				pCurrCommon = GetCommon("");
			}
			else
			{
				b=CopyNameF77(s, a, varname);
				if(b==2 || b==3) return 2;

				pCurrCommon = GetCommon(varname);
				while((*s)[*a]!='/' && (*s)[*a]!=0) (*a)++;
				if((*s)[*a] == 0) return 2;
			}
			(*a)++;
			continue;
		}
		/*  */
		b=CopyNameF77(s, a, varname);
		if(b==3) return 2;

		if(IsFortranKeyword(varname, OP_POINTER))
			continue;

		/*    */
		for(pCurrVariable=pFirstPar; pCurrVariable!=NULL; pCurrVariable=pCurrVariable->row)
			if(stricmp(pCurrVariable->name, varname)==0) break;
		/*   */
		if(pCurrVariable==NULL && bFindAllVars)
		{
			pCurrVariable = LockParam(TRUE);
			strcpy(pCurrVariable->name, varname);
		}

		bArray = FALSE;
		while(pCurrVariable!=NULL)
		{
			if(oper!=OP_DIMENSION && oper!=OP_COMMON)
				pCurrVariable->type=type;
			if(oper==OP_CHARACTER)
				pCurrVariable->strlen=strlen;
			if(b==0)
				b=GetNextSymb(s, a);
			if(b==0 && (*s)[*a]=='*' && oper==OP_CHARACTER)/*  CHAR*/
			{
				(*a)++;
				if(GetNextSymb(s, a)>0)
					return 2;
				if(!TypeConvert(*s, a, &(pCurrVariable->type), &(pCurrVariable->strlen)))
					return 2;
				b=GetNextSymb(s, a);
			}
			if(b>0 || (*s)[*a]!='(') /**/
			{
				if(oper==OP_DIMENSION)
					return 2;/*DIMENSION  */
				if(oper==OP_COMMON && !bFindAllVars)
					pCurrVariable=NULL;/*COMMON -   */
				break;
			}
			bArray = TRUE;/**/
			(*a)++;
			if(pCurrVariable->variety == VRT_UNKNOWN)
				pCurrVariable->variety = VRT_DIMENSION;
			if(GetNextSymb(s, a)>0) return 2;
			if(pCurrVariable->diapazon!=NULL)
			{
				/*  ?*/
				/* -   */
				pCurrVariable=NULL;
				break;
			}
			pCurrVariable->diapazon=LockDiapazon(1, 1);
			tek_diap = pCurrVariable->diapazon;
			while((*s)[*a]!=')')
			{
				/* 90-     */
				if((*s)[*a]=='*')
				{
					pCurrVariable->variety = VRT_POINTER;
					tek_diap->last = 0;
					tek_diap->blUnknown = TRUE;
					tek_diap->lExpression = mymalloc(2);
					tek_diap->lExpression[0] = '*';
					tek_diap->lExpression[1] = 0;
					(*a)++;
					if(GetNextSymb(s, a)>0)
						return 2;
					if((*s)[*a]!=':' && (*s)[*a]!=',' && (*s)[*a]!=')')
						return 2;
				}
				else
				{
					/* */
					if(!CalcExpression(s, a, &tek_diap->last, &tek_diap->lExpression, FALSE, &tek_diap->blUnknown))
						return 2;
				}
				if((*s)[*a]==':')/*  */
				{
					tek_diap->first = tek_diap->last;
					tek_diap->fExpression = tek_diap->lExpression;
					tek_diap->lExpression = NULL;
					tek_diap->bfUnknown = tek_diap->blUnknown;
					tek_diap->blUnknown = FALSE;
					(*a)++;
					if(GetNextSymb(s, a)>0) return 2;
					continue;
				}
				if((*s)[*a]==',')
				{
					tek_diap->next=LockDiapazon(1, 1);
					tek_diap = tek_diap->next;
					(*a)++;
					if(GetNextSymb(s, a)>0) return 2;
				}
			}
			(*a)++;
			break;
		}

		if(!FindAllAndCopy(pCurrVariable, bArray)) return 2;
		if(!AddCommonVariable(pCurrCommon, pCurrVariable)) return 2;
		if(b>0) return(b-1);

		while(pCurrVariable==NULL)/*   , */
		{
			if((b=GetNextSymb(s, a)) > 0)
				return(b-1);
			if(strchr(",:;", (*s)[*a]))
				break;
			if((*s)[*a]=='(')
			{
				if(!SkipParenthesis(s, a)) return 2;
			}
			else
			{
				(*a)++;
			}
		}
	}
}

/*  PARAMETER
 2  */
static int ParsingPARAMETER(char **s, int *a)
{
	int b;
	char* determ;

	while(1)
	{
		BOOL bUnknown = FALSE;

		if((b=GetNextSymb(s, a))>0) return(b-1);
		if((*s)[*a]==','||(*s)[*a]=='('||(*s)[*a]==')'){(*a)++;continue;}
		if((*s)[*a]==';') return 0;
		if(first_params==NULL)
		{
			if((first_params=mymalloc(sizeof(PARAMETERS)))==0) OutOfMemory();
			last_params=first_params;
		}
		else
		{
			if((last_params->next=mymalloc(sizeof(PARAMETERS)))==0) OutOfMemory();
			last_params=last_params->next;
		}
		last_params->next=NULL;
		/*  */
		if(CopyNameF77(s, a, last_params->name)>0) return 2;
		if((*s)[*a]!='=') return 2;
		(*a)++;
		if(GetNextSymb(s, a)>0) return 2;
		determ = NULL;
		if(!CalcExpression(s, a, &last_params->value, &determ, FALSE, &bUnknown)) return 2;
		if(determ) myfree(determ);
		if(bUnknown) return 2;
	}
}

/*  IMPLICIT
 2  , 1  */
static int ParsingIMPLICIT(char **s, int *a)
{
	VARTYPES type;
	int b;
	while(TRUE)
	{
		if((*s)[*a]==',') (*a)++;
		if((GetNextSymb(s, a))>0) return 2;
		switch(GetFortranKeyword(&(*s)[*a]))/*  */
		{
			case OP_INTEGER: (*a)+=7;type=TYP_INT;break;
			case OP_REAL: (*a)+=4;type=TYP_REAL;break;
			case OP_DOUBLE_PRECISION: (*a)+=16;type=TYP_DOUBLE;break;
			case OP_LOGICAL: (*a)+=7;type=TYP_BOOL;break;
			case OP_CHARACTER: (*a)+=9;type=TYP_CHAR;break;
			case OP_NONE: (*a)+=4;return 0;
			default: return 2;
		}
		if(GetNextSymb(s, a)>0) return 2;
		/*      REAL*8 */
		if((*s)[*a]=='*')
		{
			long size;
			(*a)++;
			if(GetNextSymb(s, a)>0) return 2;
			if(!TypeConvert(*s, a, &type, &size)) return 2;
			if(GetNextSymb(s, a)>0) return 2;
		}
		if((*s)[*a]=='(') (*a)++;
		while((*s)[*a]!=')')
		{
			if(GetNextSymb(s, a)>0) return 2;
			if(((*s)[*a]<'A'||(*s)[*a]>'Z')&&((*s)[*a]<'a'||(*s)[*a]>'z')) return 2;
			if(first_implicit==NULL)
			{
				if((first_implicit=mymalloc(sizeof(IMPLICIT)))==0) OutOfMemory();
				last_implicit=first_implicit;
			}
			else
			{
				if((last_implicit->next=mymalloc(sizeof(IMPLICIT)))==0) OutOfMemory();
				last_implicit=last_implicit->next;
			}
			last_implicit->next=NULL;
			last_implicit->type=type;
			last_implicit->first=(*s)[*a];
			/*    */
			if(last_implicit->first>='a'&&last_implicit->first<='z')
					last_implicit->first = (char)(last_implicit->first-'a'+'A');
			(*a)++;
			if(GetNextSymb(s, a)>0) return 2;
			if((*s)[*a]=='-')
			{
				(*a)++;
				if(GetNextSymb(s, a)>0) return 2;
				if(((*s)[*a]<'A'||(*s)[*a]>'Z')
					&&((*s)[*a]<'a'||(*s)[*a]>'z'))return 2;
				last_implicit->last = (*s)[*a];
				/*    */
				if(last_implicit->last>='a' && last_implicit->last<='z')
						last_implicit->last = (char)(last_implicit->last-'a'+'A');
				(*a)++;
				if(GetNextSymb(s, a)>0) return 2;
			}
			else last_implicit->last = last_implicit->first;
			if((*s)[*a]!=','&&(*s)[*a]!=')') return 2;
			if((*s)[*a]==',') (*a)++;
		}
		(*a)++;
		if((b=GetNextSymb(s, a))>0) return(b-1);
		if((*s)[*a]==';') return 0;
		if((*s)[*a]!=',') return 2;
	}
}

/*  INCLUDE
 2  , 1  */
static int ParsingINCLUDE(char **s, int *a, BOOL bGetParameters)
{
	int n;
	FILENAMES *tek_filename;
	char inclname[MYMAXPATH];
	BOOL res;

	STRINGS *str = GetStrStatic();

	if(GetNextSymb(s, a)>0 || (*s)[*a]!='\'') return 2;
	(*a)++;
	for(n=0; (*s)[*a]!='\''; n++)
	{
		if(n>MYMAXPATH-1) return 2;
		inclname[n] = (*s)[*a];
		(*a)++;
	}
	inclname[n]=0;
	(*a)=0;

	if(first_filename==NULL)
	{
		if((first_filename=mymalloc(sizeof(FILENAMES)))==NULL) OutOfMemory();
		tek_filename = first_filename;
	}
	else
	{
		tek_filename = first_filename;
		while(1)
		{
			if(strcmp(tek_filename->namefile, inclname)==0)
			{/*    (    )*/
				*s = GetNextString(TRUE);
				if(*s==NULL) return 1;
				return 0;
			}
			if(tek_filename->next==NULL) break;
			tek_filename = tek_filename->next;
		}
		if((tek_filename->next=mymalloc(sizeof(FILENAMES)))==NULL) OutOfMemory();
		tek_filename=tek_filename->next;
	}
	tek_filename->namefile=inclname;
	tek_filename->next=NULL;

	res = TRUE;
	if(strcmp(inclname,"mpif.h")==0)
	{
		/* "mpif.h"  */
		/*   */
		bMeaningline = TRUE;
	}
	else
	{
		STRINGS* headstr;
		/*  */
		headstr = ReadHeaderFile(inclname);

		if(headstr == NULL)
		{
			/*  */
			if(bGetParameters)
			{
				CnfWarning(str, 46, inclname);
				if(bNoInclude) bNoIncludeFile=TRUE;
			}
		}
		else
		{
			/*    */
			SetCurrentString(headstr);
			if(bGetParameters)
				res=GetAllParameters(FALSE);
			else
				MarkFunctions();
		}
	}

	if(first_filename->next==NULL)
	{
		myfree(first_filename);
		first_filename=NULL;
	}
	else
	{
		tek_filename = first_filename;
		while(tek_filename->next->next!=NULL) tek_filename=tek_filename->next;
		myfree(tek_filename->next);
		tek_filename->next=NULL;

	}

	SetCurrentString(str);

	if(!res) return 2;
	*s = GetNextString(TRUE);
	if(*s==NULL) return 1;
	return 0;
}

/*  ALLOCATE
 2  , 1   */
static int ParsingALLOCATE(char **s, int *a)
{
	char varname[MAX_LEN_NAME+1];
	PARAM *pCurrVariable;
	DIAPAZON *tek_diap;
	long first, last;
	char *fExpression, *lExpression;
	BOOL bfUnknown, blUnknown;

	if(GetNextSymb(s, a)!=0 || (*s)[*a]!='(') return 2;
	(*a)++;

	while((*s)[*a]!=')')
	{
		if(GetNextSymb(s, a)!=0) return 2;
		if((*s)[*a]==',')
		{
			(*a)++;
			continue;
		}
		/*  */
		if(CopyNameF77(s, a, varname)>0) return 2;
		/*    */
		for(pCurrVariable=pFirstPar; pCurrVariable!=NULL; pCurrVariable=pCurrVariable->row)
			if(stricmp(pCurrVariable->name, varname)==0) break;

		if((*s)[*a]!='(')
		{
			if(GetNextOperator(s, a) == 2)
				return 1;
			return 0;
		}
		(*a)++;
		if(GetNextSymb(s, a)!=0) return 2;

		if(pCurrVariable)
			tek_diap = pCurrVariable->diapazon;
		else
			tek_diap = NULL;

		first=0; last=0;
		fExpression=NULL; lExpression=NULL;
		bfUnknown=FALSE; blUnknown=FALSE;

		while((*s)[*a]!=')')
		{
			/* */
			if(!CalcExpression(s, a, &last, &lExpression, TRUE, &blUnknown))
				return 2;

			if((*s)[*a]==':')/*  */
			{
				first = last;
				fExpression = lExpression;
				lExpression = NULL;
				bfUnknown = blUnknown;
				blUnknown = FALSE;
				(*a)++;
				if(GetNextSymb(s, a)>0) return 2;
				continue;
			}

			if(tek_diap)
			{
				if(tek_diap->fExpression)
					myfree(tek_diap->fExpression);
				if(tek_diap->lExpression)
					myfree(tek_diap->lExpression);
				tek_diap->fExpression = fExpression;
				tek_diap->lExpression = lExpression;
				tek_diap->first = first;
				tek_diap->last = last;
				tek_diap->bfUnknown = bfUnknown;
				tek_diap->blUnknown = blUnknown;

				tek_diap = tek_diap->next;
			}
			else
			{
				if(fExpression)
					myfree(fExpression);
				if(lExpression)
					myfree(lExpression);
				/*   */
				if(pCurrVariable) return 2;
			}

			first=0; last=0;
			fExpression=NULL; lExpression=NULL;

			if((*s)[*a]==',')
			{
				(*a)++;
				if(GetNextSymb(s, a)>0) return 2;
			}
		}
		(*a)++;

	}

	(*a)++;
	return 0;
}

/*    Statement Functions*/
BOOL IsStatementFunction(char **s, int *a, int *res)
{
	char name[MAX_LEN_NAME+1];
	PARAM *pCurrVariable;

	/*   : () =  */

	*res = CopyNameF77(s, a, name);
	if(*res > 0)
	{
		if(*res == 3)
			*res = GetNextOperator(s, a);

		if(*res==2)
			*res=1;
		else
			*res=0;
		return FALSE;
	}

	if((*s)[*a] != '(')
	{
		*res = GetNextOperator(s, a);
		if(*res > 0)
			(*res)--;
		return FALSE;
	}
	if(!SkipParenthesis(s, a))
	{
		*res = 2;
		return FALSE;
	}

	*res = GetNextSymb(s, a);
	if(*res > 0)
	{
		(*res)--;
		return FALSE;
	}

	if((*s)[*a] != '=')
	{
		*res = GetNextOperator(s, a);
		if(*res > 0)
			(*res)--;
		return FALSE;
	}

	*res = GetNextOperator(s, a);
	if(*res > 0)
		(*res)--;

	/*    
	   ,   Statement Function*/
	for(pCurrVariable=pFirstPar; pCurrVariable!=NULL; pCurrVariable=pCurrVariable->row)
		if(stricmp(pCurrVariable->name, name)==0)
			return FALSE;

	return TRUE;
}

/*  INTERFACE
 2  , 1  */
static int ParsingINTERFACE(char **s, int *a)
{
	int res = 0;
	for(;;)
	{
		/*  */
		if(res == 0 && GetNextOperator(s, a) == 2)
			return 2;
		if((*s)[*a] == ';')
		{
			(*a)++;
			if(GetNextSymb(s, a) == 2)
				return 2;
		}

		res = 0;
		if(GetFortranKeyword(&(*s)[*a]) == OP_END)
		{
			/* END INTERFACE*/
			(*a)+=arrFortranKeyLen[OP_END];
			res = GetNextSymb(s, a);
			if(res == 2)
				return 2;
			if(res==0 && GetFortranKeyword(&(*s)[*a])==OP_INTERFACE)
			{
				(*a)+=arrFortranKeyLen[OP_INTERFACE];
				if(GetNextOperator(s, a) == 2)
					return 1;

				return 0;
			}

		}
	}

	return 2;
}

/*    */
/* bEOFasError,    */
static BOOL GetAllParameters(BOOL bEOFasError)
{
	int a=0, res;
	char *s = GetCurrentString();
	if(s == NULL)
		return FALSE;

	while(TRUE)
	{
		if(GetNextSymb(&s, &a)==2)
		{
			if(bEOFasError)
			{
				CnfNfErr(GetStrStatic(), 50, strCurrentPart);
				return FALSE;
			}
			else return TRUE;
		}
		if(first_filename==NULL) bMeaningline = FALSE;
		/*  */
		if(IsEndPart(s))
			return TRUE;
		switch(GetFortranKeyword(&s[a]))/*  */
		{
			case OP_INTEGER:
				a+=arrFortranKeyLen[OP_INTEGER];
				res=ParsingDEFINES(&s, &a, TYP_INT, OP_INTEGER);
				bMeaningline = TRUE;
				break;
			case OP_REAL:
				a+=arrFortranKeyLen[OP_REAL];
				res=ParsingDEFINES(&s, &a, TYP_REAL, OP_REAL);
				bMeaningline = TRUE;
				break;
			case OP_DOUBLE_PRECISION:
				a+=arrFortranKeyLen[OP_DOUBLE_PRECISION];
				res=ParsingDEFINES(&s, &a, TYP_DOUBLE, OP_DOUBLE_PRECISION);
				bMeaningline = TRUE;
				break;
			case OP_LOGICAL:
				a+=arrFortranKeyLen[OP_LOGICAL];
				res=ParsingDEFINES(&s, &a, TYP_BOOL, OP_LOGICAL);
				bMeaningline = TRUE;
				break;
			case OP_CHARACTER:
				a+=arrFortranKeyLen[OP_CHARACTER];
				res=ParsingDEFINES(&s, &a, TYP_CHAR, OP_CHARACTER);
				bMeaningline = TRUE;
				break;
			case OP_PARAMETER:
				a+=arrFortranKeyLen[OP_PARAMETER];
				res=ParsingPARAMETER(&s, &a);
				bMeaningline = TRUE;
				break;
			case OP_IMPLICIT:
				a+=arrFortranKeyLen[OP_IMPLICIT];
				res=ParsingIMPLICIT(&s, &a);
				bMeaningline = TRUE;
				break;
			case OP_COMMON:
				a+=arrFortranKeyLen[OP_COMMON];
				res=ParsingDEFINES(&s, &a, TYP_UNKNOWN, OP_COMMON);
				bMeaningline = TRUE;
				break;
			case OP_DIMENSION:
				a+=arrFortranKeyLen[OP_DIMENSION];
				res=ParsingDEFINES(&s, &a, TYP_UNKNOWN, OP_DIMENSION);
				bMeaningline = TRUE;
				break;
			case OP_INCLUDE:
				a+=arrFortranKeyLen[OP_INCLUDE];
				res=ParsingINCLUDE(&s, &a, TRUE);
				break;
			case OP_ALLOCATE:
				a+=arrFortranKeyLen[OP_ALLOCATE];
				res=ParsingALLOCATE(&s, &a);
				break;
			case OP_INTERFACE:
				a+=arrFortranKeyLen[OP_INTERFACE];
				res=ParsingINTERFACE(&s, &a);
				break;
			case OP_CALL:
				a+=arrFortranKeyLen[OP_CALL];
				res=ParsingCALL(&s, &a);
				break;
			case OP_USE:
			case OP_COMPLEX:
			case OP_TYPE:
			case OP_ALLOCATABLE:
			case OP_EXTERNAL:
			case OP_INTENT:
			case OP_INTRINSIC:
			case OP_OPTIONAL:
			case OP_POINTER:
			case OP_NAMELIST:
			case OP_EQUIVALENCE:
				/*  ,      */
				bMeaningline = TRUE;
				res=GetNextOperator(&s, &a);
				if(res > 0)
					res--;
				break;
			case OP_IF:
				/*    */
				res = (SkipParenthesis(&s, &a) ? 0:2);
				break;
			case -1:
				/*    Statement Functions*/
				bMeaningline = IsStatementFunction(&s, &a, &res);
				break;
			default:
				res=GetNextOperator(&s, &a);
				if(res > 0)
					res--;
		}

		if(first_filename==NULL && bMeaningline)
		{
			bMeaningline = FALSE;
			
			/*     */
			pLastCall->meaningline = GetStringLine(GetStrStatic());
			if(s[a]==';') /*    */
				pLastCall->meaningline++;
		}

		if(res==1)
		{
			if(bEOFasError)
			{
				CnfNfErr(GetStrStatic(), 50, strCurrentPart);
				return FALSE;
			}
			else return TRUE;
		}
		if(res==2)
		{
			if(first_filename!=NULL)
				CnfNfErr(GetStrStatic(), 56);
			return FALSE;
		}
		if(s[a]==';') a++;
	}
}

/*    */
static CALLPART *FindFormalF77(char *partname)
{
	VARTYPES type;
	PARAM *pCurrVariable=NULL;
	CALLPART* tek_call;
	int a, b, nPartLen = strlen(partname);
	char *s = GetCurrentString();

	/*  */
	while((type=FindPartDeclaration(s, &a, partname, nPartLen))==TYP_UNKNOWN)
	{
		s = GetNextString(TRUE);
		if(s==NULL) return NULL;
	}
	/*  */
	tek_call = LockCall(GetStrStatic());
	strcpy(tek_call->name, partname);
	tek_call->type=type;

	/*  */
	/*  */
	if(GetNextSymb(&s, &a)==0 && s[a]=='(')
	{
		a++;
		while(s[a]!=')')
		{
			/* */
			pCurrVariable = LockParam(TRUE);
			/* */
			if(CopyNameF77(&s, &a, pCurrVariable->name)>0) return NULL;

			if(s[a]==',') a++;
			else if(s[a]!=')') return NULL;/* */
		}
	}

	/*     */
	tek_call->intrinsicline = GetStringLine(GetStrStatic());
	if(s[a]==')') tek_call->intrinsicline++;
	tek_call->meaningline = tek_call->intrinsicline;

	/*  */
	if((type==TYP_PROGRAMNAME||type==TYP_PARTNAME) &&
		pCurrVariable==NULL && !bFindAllVars)
		return MakeParams();

	/*:  */
	if(type!=TYP_PARTNAME && type!=TYP_PROGRAMNAME)
	{
		pCurrVariable = LockParam(TRUE);
		if(type != TYP_FUNCNAME) pCurrVariable->type=type;
		if(s[a]!=')') return NULL;/*    */
		a++;
		if(GetNextSymb(&s, &a)==0 && IsFortranKeyword(&s[a], OP_RESULT))/* RESULT*/
		{
			a+=6;/*   RESULT*/
			if(GetNextSymb(&s, &a)>0 || s[a]!='(') return NULL;
			a++;
			/* */
			if(CopyNameF77(&s, &a, pCurrVariable->name)>1) return NULL;
			s = GetNextString(TRUE);
			if(s==NULL) return NULL;
		}
		else /*     */
		{
			b = nPartLen;
			if(b>MAX_LEN_NAME) b=MAX_LEN_NAME;
			memcpy(pCurrVariable->name, partname, b);
			pCurrVariable->name[b]=0;
		}
	}
	else if(s[a]==')')
	{
		s = GetNextString(TRUE);
		if(s==NULL) return NULL;
	}

	/*    */
	if(!GetAllParameters(TRUE)) return NULL;

	return MakeParams();
}

/***************************************************************/
/*                                   */
/***************************************************************/

/*     */
static BOOL FindCalls(char* partname)
{
	int b, a=0, skobki;
	BOOL IsNewParam, function=FALSE;
	CALLPART* tek_call=NULL;
	PARAM *pCurrVariable;
	char* ptr;
	char* s;
	STRINGS *str = GetStrStatic();
	int part_len = strlen(partname);

	if(str==NULL)
		InternalError();

	s = GetNextString(TRUE);
	if(s==NULL) return FALSE;
	while(GetNextSymb(&s, &a)!=2)
	{
		/*   */
		if(IsEndPart(s))
		{
			SetCurrentString(str);
			s = GetNextString(TRUE);
			if(tek_call || function) return(tek_call!=NULL);
			function = TRUE;
		}
		if(function)/*  */
		{
			ptr = strstr(&s[a], partname);
			if(ptr)
			{
				a=a+(int)(ptr-&s[a]);
				if(a > 6 && (isalnum(s[a-1]) || s[a-1]=='_'))
				{
					a += part_len;
					continue;
				}
			}
			else
			{
				a=0; /*  */
				s = GetNextString(TRUE);
				continue;
			}
		}
		if(!function && IsFortranKeyword(&s[a], OP_IF))
		{
			/*    */
			SkipParenthesis(&s, &a);
			continue;
		}
		if(function || IsFortranKeyword(&s[a], OP_CALL))
		{
			if(!function) a+=5;
			if(GetNextSymb(&s, &a)==2) return FALSE;
			if(strnicmp(partname, &s[a], part_len)==0
				&& strchr("( \n\t;", s[a+part_len]))/* */
			{
				a+=part_len;
				if(GetNextSymb(&s, &a)==2) return FALSE;
				if(s[a] != '(' && function) continue;/*  */

				/*  */
				tek_call = LockCall(GetStrStatic());
				strcpy(tek_call->name, partname);
				if(s[a] != '(') continue;/*   */

				IsNewParam = TRUE;
				a++;
				if(GetNextSymb(&s, &a)==2) return FALSE;

			/* */
				skobki=0;
				while(s[a] != ')' || skobki!=0)
				{
					if(GetNextSymb(&s, &a)==2) return FALSE;
					if(strchr("+-*/", s[a])) {a++; continue;}
					if(s[a]==',') {a++; IsNewParam=TRUE; continue;}
					if(s[a]==')') {a++; skobki--; continue;}
					if(s[a]=='(') {a++; skobki++; continue;}

					pCurrVariable = LockParam(IsNewParam);
					IsNewParam = FALSE;

					if(s[a]>='0' && s[a]<='9')/**/
					{
						pCurrVariable->variety=VRT_SCALAR;
						pCurrVariable->type=TYP_INT;
						while(!GetNextSymb(&s, &a) && !strchr("+-*/,)", s[a]))
						{
							 if(s[a]=='.') pCurrVariable->type=TYP_REAL;
							 if(s[a]=='d'||s[a]=='D')pCurrVariable->type=TYP_DOUBLE;
							 if(s[a]=='d'||s[a]=='D'||s[a]=='e'||s[a]=='E') a++;
							 a++;
						}
					}
					else/**/
					{
						if(CopyNameF77(&s, &a, pCurrVariable->name)>0) return FALSE;
						if(s[a]=='(')/* */
						{
							pCurrVariable->variety=VRT_SCALAR;
							if(!SkipParenthesis(&s, &a)) return FALSE;
						}
					}
				}
				if(function)/* */
				{
					pCurrVariable = LockParam(TRUE);
					pCurrVariable->variety=VRT_SCALAR;
					b = part_len;
					if(b>MAX_LEN_NAME) b=MAX_LEN_NAME;
					memcpy(pCurrVariable->name, partname, b);
					pCurrVariable->name[b]=0;
				}
			}
			else a+=part_len;
		}
		if(!function)
		{
			if(GetNextOperator(&s, &a)==2) return FALSE;
			if(s[a]==';') a++;
		}
	}

	return FALSE;
}

/*   */
CALLPART* FindActual(char *partname, STRINGS *string)
{
	CALLPART* param=NULL;

	if(C_OUT) return NULL;

	pFirstCall=NULL;
	pFirstPar=NULL;
	first_params=NULL;
	first_implicit=NULL;
	first_filename=NULL;

	bNoIncludeFile=FALSE;
	bFindAllVars=FALSE;

	SetCurrentString(string);

	/*  */
	if(!FindCalls(partname) ||
	/*    */
		!GetAllParameters(TRUE) ||
		(param=MakeParams()) == NULL)
	{
		if(!bNoIncludeFile)
			CnfNfErr(GetStrStatic(), 45, partname);
		else
			CnfWarning(GetStrStatic(), 45, partname);
	}

	if(param == NULL) FreeCalls(pFirstCall);
	FreeParams();
	return param;
}

/***************************************************************/

/***************************************************************/

/*  */
#define C_WORD_LEN 12
static const char *arrCKeyWord[C_WORD_LEN]={
	"int",
	"float",
	"double",
	"BOOL",
	"void",
	"long",
	"char",
	"short",
	"signed",
	"unsigned",
	"static",
	"bool"};

static const int arrCKeyLen[C_WORD_LEN] = {3,5,6,4,4,4,4,5,6,8,6,4};
/*     */
static int GetCKeyWord(char *s)
{
	int n,l;
	for(n=0;n<C_WORD_LEN;n++)
	{
		l=arrCKeyLen[n];
		if(strncmp(s,arrCKeyWord[n],l)==0 && s[l]!='_'
			&& (s[l]<'A'||s[l]>'Z') && (s[l]<'a'||s[l]>'z')
			&& (s[l]<'0'||s[l]>'9')) return n;
	}
	return -1;
}

/*      */
static VARTYPES ConvertType(int i)
{
	switch(i)
	{
	case 0:/*int long*/
	case 5:
		return TYP_INT;
	case 1:/*float*/
		return TYP_REAL;
	case 2:/*double*/
		return TYP_DOUBLE;
	case 3:/*BOOL*/
	case 11:
		return TYP_BOOL;
	case 4:/*void*/
		return TYP_VOID;
	case 6:/*short char*/
	case 7:
		return TYP_CHAR;
	default:
		return TYP_UNKNOWN;
	}
}

/*      ( ,  )
 FALSE   */
static BOOL CGetNextSymb(char **s, int *a)
{
	while(TRUE)
	{
		while((*s)[*a]==' '|| (*s)[*a]=='\t'||(*s)[*a]=='\n') (*a)++;
		if((*s)[*a]==0||((*s)[*a]=='/'&&(*s)[(*a)+1]=='/'))
		{
			(*a)=0;
			(*s) = GetNextString(TRUE);
			if(*s==NULL) return FALSE;
			continue;
		}
		if((*s)[*a]=='/'&&(*s)[(*a)+1]=='*')
		{
			while(!((*s)[*a]=='*'&&(*s)[(*a)+1]=='/'))
			{
				(*a)++;
				if((*s)[*a]==0)
				{
					(*s) = GetNextString(TRUE);
					if(*s==NULL) return FALSE;
					(*a)=0;
				}
			}
			continue;
		}
		return TRUE;
	}
}

/*     ( )*/
static void CopyNameC(char* s, char* dest, int*a)
{
	int b;
	for(b=0; !((s[*a]<'A'||s[*a]>'Z') && (s[*a]<'a'||s[*a]>'z')
			&& (s[*a]<'0'||s[*a]>'9') && s[*a]!='_'); (*a)++)
	{
		if(b >= MAX_LEN_NAME) continue;
		dest[b]=s[*a];
		b++;
	}
	dest[b]=0;
}

/***************************************************************/

/*      */
static CALLPART *FindFormalC(char *partname)
{
	long l;
	int i, a=0;
	VARTYPES parttype=TYP_UNKNOWN, resulttype=TYP_UNKNOWN;
	PARAM *pCurrVariable;
	DIAPAZON *tek_diap;
	CALLPART *tek_call;
	char *s = GetCurrentString();

	/*   */
	while(!IsThisFuncOrSub(s, partname))
	{
		s = GetNextString(TRUE);
		if(s==NULL) return NULL;
	}

	/*  */
	tek_call = LockCall(GetStrStatic());
	strcpy(tek_call->name, partname);

	/*  */
	while(1)
	{
		i = GetCKeyWord(&s[a]);
		if(i<0) return NULL;
		resulttype = ConvertType(i);
		if(resulttype != TYP_UNKNOWN) break;
		a+=arrCKeyLen[i];
		if(!CGetNextSymb(&s, &a)) return NULL;
		if(s[a]=='*')
		{
			a++;
			if(!CGetNextSymb(&s, &a)) return NULL;
		}
	}
	while(s[a]!='(') a++;
	a++;
	while(1)
	{
		if(!CGetNextSymb(&s, &a)) return NULL;
		if(s[a]==')') break;
		if(s[a]==',') { a++; continue; }
		while(1)
		{
			i = GetCKeyWord(&s[a]);
			if(i<0) return NULL;
			parttype = ConvertType(i);
			a+=arrCKeyLen[i];
			if(!CGetNextSymb(&s, &a)) return NULL;
			if(s[a]=='*')
			{
				a++;
				if(!CGetNextSymb(&s, &a)) return NULL;
			}
			else if(parttype == TYP_VOID && s[a]==')')
			{
				parttype = TYP_PARTNAME;
				break;
			}
			if(parttype!=TYP_UNKNOWN) break;
		}
		/*  : (void)*/
		if(parttype == TYP_PARTNAME) break;

		pCurrVariable = LockParam(TRUE);
		pCurrVariable->type=parttype;

		/*    */
		if(!((s[a]>='A' && s[a]<='Z')||(s[a]>='a' && s[a]<='z')||s[a]=='_'))
			continue;

		/*  */
		CopyNameC(s, pCurrVariable->name, &a);
		if(!CGetNextSymb(&s, &a)) return NULL;
		tek_diap=NULL;
		while(s[a]=='[')
		{
			/* ,   */
			pCurrVariable->variety=VRT_DIMENSION;
			a++;
			if(!CGetNextSymb(&s, &a)) return NULL;
			if(sscanf(&s[a],"%ld",&l)!=1) return NULL;
			l--;
			if(tek_diap==NULL)
			{
				pCurrVariable->diapazon=LockDiapazon(0,l);
				tek_diap = pCurrVariable->diapazon;
			}
			else
			{
				tek_diap->next=LockDiapazon(0,l);
				tek_diap = tek_diap->next;
			}
			while(s[a]!=']')
			{
				a++;
				if(!CGetNextSymb(&s, &a)) return NULL;
			}
			a++;
			if(!CGetNextSymb(&s, &a)) return NULL;
		}
	}
	/* -*/
	if(resulttype!=TYP_VOID)
	{
		pCurrVariable = LockParam(TRUE);
		pCurrVariable->type = resulttype;
	}
	return MakeParams();
}

/***************************************************************/
/*          -     */
/***************************************************************/

CALLPART *FindFormal(char *partname, STRINGS *string)
{
	CALLPART *param;

	pFirstCall=NULL;
	pFirstPar=NULL;
	first_params=NULL;
	first_implicit=NULL;
	first_filename=NULL;

	bNoIncludeFile=FALSE;
	bFindAllVars=FALSE;

	SetCurrentString(string);

	if(C_OUT) param = FindFormalC(partname);
	else param = FindFormalF77(partname);

	if(param == NULL)
	{
		if(!bNoIncludeFile)
			CnfNfErr(GetStrStatic(), 44, partname);
		else
			CnfWarning(GetStrStatic(), 44, partname);
	}

	if(param == NULL) FreeCalls(pFirstCall);
	FreeParams();
	return param;
}

/***************************************************************/

/***************************************************************/

/*         
  ,   ;  ,  ,
      name*/
BOOL IsThisFuncOrSub(char *s, char *name)
{
	int i=0, j;

	if(C_OUT)
	{
		if(GetCKeyWord(s)<0) return FALSE;
		if(strchr(s, '(')==NULL) return FALSE;
		if(strchr(s, ';')!=NULL) return FALSE;
		while(s[i])
		{
			if(s[i]==' '||s[i]=='\t'||s[i]=='*') {i++; continue;}
			j=GetCKeyWord(&s[i]);
			if(j<0) break;
			i += arrCKeyLen[j];
		}
	}
	else
	{
		if(strchr("Cc!*\n#", s[0])) return FALSE;
		while(s[i])
		{
			if(IsFortranKeyword(&s[i], OP_FUNCTION))
			{
				i+=arrFortranKeyLen[OP_FUNCTION];
				break;
			}
			else if(IsFortranKeyword(&s[i], OP_SUBROUTINE))
			{
				i+=arrFortranKeyLen[OP_SUBROUTINE];
				break;
			}
			i++;
		}
	}
	if(s[i]==0) return FALSE;
	while(strchr(" \t", s[i]) != NULL) i++;
	j=strlen(name);
	if(j>0)/* , */
	{
		if(C_OUT){if(strncmp(&s[i], name, j)!=0) return FALSE;}
		else if(strnicmp(&s[i], name, j)!=0) return FALSE;
		if(strchr("( \n\t", s[i+j])) return TRUE;
		return FALSE;
	}
	else/*  , */
	{
		j=0;
		while(strchr("( \n\t", s[i+j])==NULL && j+1<MAX_INDENT_LEN) j++;
		if(j==0)return FALSE;

		strncpy(name, &s[i], j);
		name[j]=0;
		return TRUE;
	}
}

/*    
      name*/
BOOL IsThisProgram(char *s, char *name)
{
	int i=0, j;
	if(!IsNewFortranOperator(s)) return FALSE;
	while(strchr(" \t", s[i]) != NULL)
		i++;
	if(!IsFortranKeyword(&s[i], OP_PROGRAM))
		return FALSE;

	i+=arrFortranKeyLen[OP_FUNCTION];
	while(strchr(" \t", s[i]) != NULL)
		i++;

	j=0;
	while(strchr("( \n\t", s[i+j])==NULL && j+1<MAX_INDENT_LEN)
		j++;
	if(j==0)
		return FALSE;

	strncpy(name, &s[i], j);
	name[j]=0;

	return TRUE;
}

/***************************************************************/

/***************************************************************/

/*      */
static void MarkFunctions(void)
{
	char *s = GetCurrentString();
	int a=0;
	char varname[MAX_LEN_NAME+1];

	if(GetNextSymb(&s, &a) == 2)
		return;

	while(s)
	{
		int rez = 0;
		BOOL quote = FALSE, doublequote = FALSE;

		/*  */
		if(IsEndPart(s))
			break;

		/*INCLUDE*/
		if(GetFortranKeyword(&s[a]) == OP_INCLUDE)
		{
			a+=arrFortranKeyLen[OP_INCLUDE];
			if(ParsingINCLUDE(&s, &a, FALSE) != 0)
				break;
		}

		while(rez == 0)
		{
			rez = GetNextSymb(&s, &a);
			if(rez!=0)
				break;

			if(quote)
			{
				quote = (s[a] != '\'');
				a++;
				continue;
			}
			else if(doublequote)
			{
				doublequote = (s[a] != '\"');
				a++;
				continue;
			}

			if(!((s[a]>='A' && s[a]<='Z') || (s[a]>='a' && s[a]<='z') || s[a]=='_'))
			{
				if(s[a] == '\'')
					quote = TRUE;
				else if(s[a] == '\"')
					doublequote = TRUE;
				a++;
				continue;
			}

			rez = CopyNameF77(&s, &a, varname);
			if(rez!=0)
				break;

			if(s[a]=='(')
			{
				PARAM *pNextPar;
				for(pNextPar=pFirstCall->parameters; pNextPar!=NULL; pNextPar=pNextPar->next)
				{
					if(stricmp(pNextPar->name, varname)==0)
					{
						if(pNextPar->variety != VRT_SCALAR)
							break;
						pNextPar->variety = VRT_FUNCTION;
					}

				}

			}
		}
		if(rez>=2)
			break;
	}
}

/***************************************************************/

/*     */
CALLPART* PreparePartInfo(char* partname)
{
	CALLPART *param, *last;
	COMMON *pCommon;
	STRINGS *str;

	/*    ?*/
	for(last=pPartsCall; last; last=last->next)
	{
		if(stricmp(last->name, partname)==0)
			return last;
		if(last->next == NULL)
			break;
	}

	/*   */
	str = GetStrStatic();
	if(str==NULL)
		InternalError();

	pFirstCall=NULL;
	pFirstPar=NULL;
	first_params=NULL;
	first_implicit=NULL;
	first_filename=NULL;

	bNoIncludeFile=FALSE;
	bFindAllVars=TRUE;

	/*   */
	for(pCommon = pCommonBlocks; pCommon != NULL; pCommon = pCommon->next)
		pCommon->NextPosition = pCommon->parameters;

	param = FindFormalF77(partname);
	if(param == NULL)
		CnfWarning(GetStrStatic(), 44, partname);
	else if(!SetCommonVariables(param))
		InternalError();

	/*    */
	if(pFirstCall)
	{
		long srcline = GetStringLine(str);
		SetCurrentString(str);
		while(srcline < pFirstCall->meaningline)
		{
			GetNextStringInf();
			srcline++;
		}

		MarkFunctions();
	}

	/*   */
	SetCurrentString(str);

	if(param == NULL)
		FreeCalls(pFirstCall);
	FreeParams();

	/* ,   */
	if(param != NULL)
	{
		if(param->next != NULL)
			InternalError();

		if(last == NULL)
			pPartsCall = param;
		else
			last->next = param;
	}

	return param;
}

void FreePartInfo(void)
{
	FreeCalls(pPartsCall);
}

/***************************************************************/

/*  */
#define CALL_WAIT_LEN 2
static const char *arrCallWaitWord[CALL_WAIT_LEN]={
	"MPI_Recv",
	"MPI_Ssend"};
static const int arrCallWaitLen[CALL_WAIT_LEN]={8,9};

/*     */
static BOOL IsCallWait(char* st)
{
	int a, word, len = strlen(st);
	BOOL bIsWord = FALSE;

	for(a=0; a<len; a++)
	{
		/* */
		if(st[a]=='"' || st[a]=='\'')
		{
			char commas = st[a];
			for(a++; a<len; a++)
				if(st[a] == commas)
					break;
			if(a>=len)
				break;
		}

		if((st[a]<'A'||st[a]>'Z') && (st[a]<'a'||st[a]>'z') &&
			(st[a]<'0'||st[a]>'9') && st[a]!='_')
		{
			bIsWord = FALSE;
			continue;
		}

		if(bIsWord == TRUE)
			continue;

		if(st[a]>='0'&&st[a]<='9')
		{
			bIsWord = TRUE;
			continue;
		}

		for(word = 0; word<CALL_WAIT_LEN; word++)
		{
			int nWordLen = arrCallWaitLen[word];
			if(strnicmp(&st[a], arrCallWaitWord[word], nWordLen)!=0)
				continue;
			if((st[a+nWordLen]<'A'||st[a+nWordLen]>'Z') &&
				(st[a+nWordLen]<'a'||st[a+nWordLen]>'z') &&
				(st[a+nWordLen]<'0'||st[a+nWordLen]>'9') &&
				st[a+nWordLen]!='_')
				return TRUE;
		}
		bIsWord = TRUE;
	}
	return FALSE;
}


/*        
 4 -    1*/
static int ParseOperator(char* s, long* len)
{
	int a, nFlag = 1;
	/*   */
	STRINGS *str = GetStrStatic();
	if(str==NULL)
		InternalError();

	while(TRUE)
	{
		*len = GetStrStatic()->num - str->num + 1;

		if(nFlag == 1)
		{
			if(IsCallWait(s))
				nFlag = 4;
		}
		a = strlen(s)-1;
		if(GetNextSymb(&s, &a)>0) break;
	}
	/*   */
	SetCurrentString(str);

	return nFlag;
}

/*,      */
BOOL IsNewFortranOperator(char *s)
{
	BOOL bTab = FALSE;
	int a;

	if(strchr("Cc!*#\n", s[0]))
		return FALSE;

	for(a=0; s[a]!=0 && s[a]!='!' && s[a]!='\n'; a++)
	{
		if(a<5 && s[a]=='\t')
		{
			bTab = TRUE;
		}
		else if(s[a]!=' ' && s[a]!='\t')
		{
			if(!bTab && a==5)
				return FALSE;
			else
				return TRUE;
		}
	}

	return FALSE;
}

/*    
 2  RETURN, 3  END, 4    
  len    */
int IsStartOfOperator(char* s, long* len)
{
	int a=0;
	*len = 1;
	if(strchr("Cc!\n*#", s[0])) return 0;
	while(a<6)
	{
		if(a==5 && s[a]!=' ' && s[a]!='\t') return 0;
		if(s[a]=='\t') break;
		a++;
	}
	while(s[a]==' ' || s[a]=='\t') a++;
	/*END; END PART; END SUB*/
	if(IsFortranKeyword(&s[a], OP_END))
	{
		a += arrFortranKeyLen[OP_END];
		while(s[a]==' ' || s[a]=='\t') a++;
		if(s[a]=='\n' || s[a]=='!' || s[a]==0) return 3;
		if(IsFortranKeyword(&s[a], OP_SUBROUTINE) || IsFortranKeyword(&s[a], OP_FUNCTION))
			return 3;
		/*END SELECT  */
		if(IsFortranKeyword(&s[a], OP_SELECT))
			return 0;
	}
	/*RETURN*/
	else if(IsFortranKeyword(&s[a], OP_RETURN))
	{
		a += arrFortranKeyLen[OP_RETURN];
		while(s[a]==' ' || s[a]=='\t') a++;
		if(s[a]=='\n' || s[a]=='!' || s[a]==0) return 2;
	}
	/*   */
	else if(IsFortranKeyword(&s[a], OP_FORMAT) || IsFortranKeyword(&s[a], OP_ENTRY)
		|| IsFortranKeyword(&s[a], OP_INCLUDE) || IsFortranKeyword(&s[a], OP_DATA)
		|| IsFortranKeyword(&s[a], OP_CONTAINS)
	/* CASE  */
		|| IsFortranKeyword(&s[a], OP_CASE))
		return 0;

	/*   */
	return ParseOperator(s, len);
}

/***************************************************************/
