#ifndef _COMMON_MONITOR_DEFS_H
#define _COMMON_MONITOR_DEFS_H

#include <assert.h>
#ifndef TRUE
typedef int BOOL;
#define TRUE 1
#define FALSE 0
#endif

#define MAX_INTERNET_ADDRESS_SIZE 256
#define MAX_PART_NAME 20
#define MAX_FILE_NAME 256
#define MAX_VARIABLE_NAME 20
#define MAX_FORMULA_ITEMS 30
#define MAX_ERROR_LEN 250
#define MAX_DISPLAYED_VALUES 100
#define MAX_INDEX_INFO_LEN 50
#define MAX_NUMBER_LEN 30
#define MONITOR_INFO_FILENAME "NDmonpar.inf"
#define MONITOR_CFG_FILENAME "NDmoncfg.inf"
#define MONITOR_INFO_FILE_NOTFOUND "Monitor Info File %s not found"
#define MONITOR_INFO_FILE_FORMATERROR "Monitor Info File %s has wrong format"
#define MONITOR_CFG_FILE_FORMATERROR "Monitor config File %s has wrong format"
#define SERVER_ID "Server"
#define CLIENT_ID "Client"
#define OUT_MEMORY "Out Of Memory!"
#define CANT_CALC_REQUESTED_TASK_NOT_AVAILABLE "Can't calculate the value because at least one of requested tasks is not available"
#define ER_WR "Error write on disk!"

#define VERSIONID "0.15"
/* 0.15 - Fortran support */
/* 0.14 - New core, support different process threads */
/* 0.13 - support C */
/* 0.12 - support Windows */

typedef enum { INTEGER_T = 0, REAL_T, DOUBLE_T, CHARACTER_T} NormaVarType;
#define CHARACTER_ID_BASE 100

/* *************************************************** */
/* Vars INFO routines */
/* *************************************************** */
typedef struct DimInfo
{
	char name[MAX_VARIABLE_NAME];
	int start, end, declared_start, declared_end,
		requested_start, requested_end;
} DimInfo;

typedef struct VarInfo
{
	char name[MAX_VARIABLE_NAME];
	NormaVarType type;
	int len; /* for CHARACTER */
	void *pointer;
	int number_of_dimensions;
	DimInfo *dimensions;
	struct VarInfo *next;
} VarInfo;


#endif
