#ifndef _MONITOR_H
#define _MONITOR_H

#ifdef WIN32
#include <process.h>
#include <direct.h>
#else
#include <pthread.h>
#include <semaphore.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#endif

#include <signal.h>

#include "TCPIPlib.h"
#include "Thread_Semaphore.h"

void PrintErrorMessage(const char *msg);

void OnBreakExecution(TCPIPMessageType msg);
BOOL OnNotifyBreakExecution(void);

void StopPWaitTimer(void);

extern TCPIPConnectionHandle *tcp_ip_handle;

/* The amount of running Norma tasks */
extern int number_of_norma_tasks;


/* Thread identifiers: */
/*	threads that sends data to Norma tasks and UI*/
extern pthread_t *task_thread_send, 
/*	threads that receives data from Norma tasks and UI*/
	*task_thread_recv;
/* Semaphores: */
/* Semaphore that recv tread may receive */
extern sem_t *recv_thread_sem, 
/* Semaphore that send tread ready to send */
	*send_thread_sem,
/* Semaphore that send tread has anything to send */
	*send_thread_sem_has_work,
/* Semaphore that main tread is doing anything and can't process anything more */
	main_thread_sem_busy, 
/* Semaphore that main tread has work from any recv thread */
	main_thread_sem_has_work,
	/* Semaphores for calculating variable values */
	calc_wait_sem, calc_ready_sem;
/* Variable pointed what thread has received anything */
extern int active_thread_recv;

/* ID of messages */
extern int *mess_id_send, *mess_id_recv;
/* Data of messages */
extern char **task_buffer_send, **task_buffer_recv;

extern BOOL *thread_should_stops;

#endif // _MONITOR_H
