#ifndef _MONITOR_DEFS_H
#define _MONITOR_DEFS_H
#include "CommonMonitorDefs.h"
#include "Formula.h"


#ifndef DEBUG_TIMERS

/* Timer how to wait the processes before report to UI, msecs */
#define PWAIT_TIMER_VALUE 500
/* Timer how to wait all another processes before think thay are permanently hang */
#define TIMEOUT_TIMER_VALUE 5000

#else

/* the same timers in DEBUG mode - 2 minutes */
#define PWAIT_TIMER_VALUE 100
#define TIMEOUT_TIMER_VALUE 120000

#endif

typedef struct Breakpoint
{
	int id;
	char filename[MAX_FILE_NAME];/* '\0' means that there is no filename - this is condition only breakpoint */
	int line;
	Formula *condition; /* NULL if there is no condition */
	/* for only-condition breakpoints the last calculated value */
	ValuesProcArray *old_value;
	BOOL is_any; /* break when all processes reach it or when any one */
	struct Breakpoint *next;
} Breakpoint;

typedef struct PartInfo
{
	char name[MAX_PART_NAME], filename[MAX_FILE_NAME];
	int i, j, myi, myj, ipoints, jpoints;
	char iname[MAX_VARIABLE_NAME], jname[MAX_VARIABLE_NAME];
//	int number_of_members; /* how many other processes works with me in this part */
	int previous_operator, current_operator;
	int previous_operator_line_begin;
	int previous_operator_line_end;
	int current_operator_line_begin;
	int current_operator_line_end;
	BOOL is_step_into, is_step_over, is_tmp_breakpoint;
	VarInfo *vars;
	struct PartInfo *next;
	int number_from_root;
	BOOL is_External;
} PartInfo;

typedef struct CheckedFiles
{
	char filename[MAX_FILE_NAME];
	struct CheckedFiles *next;
	long CRC;
} CheckedFiles;

typedef struct TaskGroups
{
	int *task_numbers;
	int amount;
	int *IDs; /* IDs of worked breakpoints of this group */
	struct TaskGroups *next;
} TaskGroups;


#endif // _MONITOR_DEFS_H
