/* Header of TCP/IP communicating library */
#ifndef _NDMessages_H
#define _NDMessages_H
/* Messages */
#define ND_FAIL 1000
#define ND_OK 1001

#define ND_NOTIF_MY_IDS 1002

#define ND_NOTIF_PROGRAM_START 1003
/* "%s \"%s\" %d %ld", main_part_name,	filename, start_line, CRC */


#define ND_NOTIF_PROGRAM_END 1004

#define ND_NOTIF_MAIN_PART_START 1005
/* "%s \"%s\" %d %ld", name, filename, start_line, CRC */

#define ND_NOTIF_MAIN_PART_END 1006
/* "%d", end_line */

#define ND_NOTIF_PART_START 1007
/* "%s \"%s\" %d %ld %d", name, filename, start_line, CRC, is_External */

#define ND_NOTIF_PART_END 1008
/* "%d", end_line */

#define ND_NOTIF_DISTRIBUTION_PART_START 1009
/* "%s \"%s\" %d %ld", name, filename, start_line, CRC */

#define ND_NOTIF_DISTRIBUTION_PART_END 1010
/* "%d", end_line */

#define ND_NOTIF_PARAMETER_RECEIVED 1011
#define ND_NOTIF_OPERATOR_START 1012
/* MonitorConnect -> Monitor:
  "%d %d %d %d %d %d",
		*previous_operator,
		*previous_operator_line_begin,
		*previous_operator_line_end,
		*current_operator,
		*current_operator_line_begin,
		*current_operator_line_end
*/

/* Monitor -> UI
	(%d ... %d)        | - ids of reached breakpoints;
	%d (\"%s\" %d %d %d ... %d) ... (\"%s\" %d %d %d ... %d) | - info about tasks that reach any point
	%d (\"%s\" %d %d %d ... %d) ... (\"%s\" %d %d %d ... %d) | - info about blocked tasks 
	(%d ... %d)        | - ids of not started tasks

Info about tasks that reach any point and info about blocked tasks have the same structure:
<amount of groups> (<group1>) ... (<groupN>)
<group> ::=
	("<filename>" <line_begin> <line_end> <taskid1> ... <taskidK>)
*/
#define ND_NOTIF_EX_OPERATOR_START 1013
/* MonitorConnect -> Monitor:
  "%d %d %d %d %d",
		*is_potentially_lock,
		*previous_operator_line_begin,
		*previous_operator_line_end,
		*current_operator_line_begin,
		*current_operator_line_end
*/

#define ND_CONTINUE_EXECUTION 1014

#define ND_BREAK_EXECUTION 1015
#define ND_WAIT_SIGNAL 1016
#define ND_CONTINUE_SIGNAL0 1017
#define ND_CONTINUE_SIGNAL1 1024

#define ND_SET_BREAKPOINT 1018
/* "%d %d %d \"%s\"", breakpoint_ID, line, is_any, filename */
/* "%d %d %d \"%s\" %s", breakpoint_ID, line, is_any, filename, condition */
/* "%d %d \"\" %s", breakpoint_ID, break_when_true, condition */
/* breakpoint_ID > 0 */

#define ND_REMOVE_BREAKPOINT 1035
/* "%d", breakpoint_ID */

#define ND_RUN 1019
#define ND_STEP_OVER 1020
#define ND_STEP_INTO 1021
#define ND_UNTIL_RETURN 1022
#define ND_PAUSE 1023

#define ND_CHECK_CRC 1025
/* "\"%s\" %ld", filename, CRC */
/* No answer if OK, ND_BREAK_EXECUTION if program should be stoped */

#define ND_REGISTER_VAR 1030
/* "%s %d %d" */
#define ND_REGISTER_GLOBAL_VAR 1038
/* "%s %d %d" */
#define ND_REGISTER_DIM 1031
/* "%d %s %d %d %d %d" */

#define ND_GET_VALUE 1032
/* UI->M - %d free text
           %d - ID of request
	M->N:
	"%s %d %d %d ... %d %d", name, retrieve_index_info, diap1_start, diap1_end, ..., diapN_start, diapN_end */

#define ND_TAKE_VALUE 1033
/* M->UI - %d free text
           %d - ID of request
   N->M: free text */

#define ND_TAKE_VALUE_ERROR 1034
/* M->UI - "%d %d %s", ID of request, line position, error message
		or "%d %s", ID of request, error message
   N->M: free text */
#define ND_BREAKPOINT_CONDITION_ERROR 1036
/* "%d %d %s", breakpoint_ID, line position (-1 means no line position,
 error message */

#define ND_BREAKPOINT_DYNAMIC_CONDITION_ERROR 1037
/* "%d %d %s", breakpoint_ID, line position (-1 means no line position,
 error message */

#define ND_GET_STATUS 1040
#define ND_TAKE_STATUS 1041
/* free text */

#define ND_DEBUGED_PROGRAM_CANT_RUN 1050
/* free text */

#define ND_GET_VERSION_ID 1051
/* free text */
#define ND_TASK_ID 1052

#define ND_GET_STACK_INFO 1053
/* "%d", process_number */
#define ND_TAKE_STACK_INFO 1054
/* "%s \"%s\" %d ... %s \"%s\" %d" */
/* Func, filename, line ... */

#endif
