/* Thread and Semaphores defines for Windows */
#ifndef _THREAD_SEMAPHORE_H
#define _THREAD_SEMAPHORE_H

#ifdef WIN32
#include <windows.h>
#include <process.h>
#include <direct.h>
#else
#include <pthread.h>
#include <bits/local_lim.h>
#include <semaphore.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#endif


#ifdef WIN32
typedef DWORD pthread_t;
typedef int pthread_attr_t;

int pthread_create(pthread_t *thr_id, pthread_attr_t *attr, 
				   void (*start_func)(void*), 
				   void *args);

#define pthread_attr_init(attr) ;
#define pthread_attr_setdetachstate(attr, a) ;
#define pthread_attr_setstacksize(attr, a) ;
#define pthread_attr_destroy(attr) ;

typedef HANDLE sem_t;

int sem_init(sem_t *handle, long pshare, long init_count);
#define sem_destroy(handle) CloseHandle(*(handle))
#define sem_wait_not_intr(handle) WaitForSingleObject(*(handle), INFINITE)
int sem_post(sem_t *handle);
int sem_getvalue(sem_t *handle, int *value);

typedef int pid_t;
#define strcasecmp _stricmp
#define strncasecmp _strnicmp
#define THREADRETURN void

#else /* UNIX */

int sem_wait_not_intr(sem_t *sem);

#define THREADRETURN void*
typedef unsigned int UINT;

#endif

#endif // _THREAD_SEMAPHORE_H
