/* $Id: cgop.c,v 1.2 1999/09/24 10:29:31 alena Exp $ */
/*===============================================*/
/*                                               */
/*===============================================*/

/*   RULEX-0   REFASS OPERATORS GENERATION  */
/* 23/10/95 changed output to Macro_File for cases with Tag and Contents,
            e.g. LSC, NS, and the corresponding specifiers 
*/

#include "rcdecl.h"
 
static char rcs_id[]="$Id: cgop.c,v 1.2 1999/09/24 10:29:31 alena Exp $";

#if OBJECT==1 || MACRO==1
#include "../op_names.inc"
#include "../sp_names.inc"
#endif

extern int JADDR();

#define INS JWHERE()

void gfun(char * id, char * ide, int mod)
{
static char * nm[]={"ENTRY","EXTRN","SYSTEM","SWAP","EMPTY"};
if ( Opt_Macro )
        {
	  if (ide==NULL || strcmp(id,ide)==0 )
	    fprintf(Macro_File,"\n%s( %s )",nm[mod],id);
	  else
	    fprintf(Macro_File,"\n%s( %s , %s )",nm[mod],ide,id);
	}

}

void gop( k )
unsigned char k;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d \t\t; %s",INS,k,op_name[k]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s()",op_name[k]);
#endif

	JBYTE( k );
	return;
} /* end of gop */

void gopc( c )
unsigned char c;
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File," %c",c);
#endif

	JBYTE( c );
	return;
} /* end of gopc */

void gopi( d )
int d;
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File," %04x (%d)",d,d);
#endif
	JINT( d );

	return;
} /* end of gopi */

void GOPNI(K,N)
unsigned char K;
int N;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		{
		if ( K==N_WSPC || K==N_ESPC )
			{
			fprintf(Objlist_File,"\n%04d:   %d %d (@%04d)\t; %s",
				INS,K,N,INS-N,op_name[K]);

			}
		else
			{
			fprintf(Objlist_File,"\n%04d:   %d %04x (%d) \t; %s",
				INS,K,N,N,op_name[K]);
			}
		}
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		{
		if ( K==N_WSPC || K==N_ESPC )
			{
			fprintf(Macro_File,"\n\t%s( SPEC%04d )",
				op_name[K],INS-N);

			}
		else
			{
			fprintf(Macro_File,"\n\t%s( %d )",
				op_name[K],N);
			}
		}
#endif
	JBYTE(K);
	JINT(N);

	return;
}  /*   end of gopni */

void GOPN(K,N)
unsigned char K,N;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %d \t\t; %s",
			INS,K,N,op_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		if ( K==N_LSCO || K==N_NSO )
			{
			fprintf(Macro_File,"\n\t%s( %c )",op_name[K],N);
			}
		else
			{
			fprintf(Macro_File,"\n\t%s( %d )",op_name[K],N);
			}
#endif
	JBYTE(K);
	JBYTE(N);

	return;
}

void GOPNM(K,N,M)
unsigned char K,N,M;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %d %d \t\t; %s",
			INS,K,N,M,op_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s( %d,%d )",
			op_name[K],N,M);
#endif
	JBYTE(K);
	JBYTE(N);
	JBYTE(M);

	return;
}

void GOPSL(K,N,M)
unsigned char K,N;
int M;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %d %d \t; %s",
			INS,K,N,M,op_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s( %d,%d )",
			op_name[K],N,M);
#endif
	JBYTE(K);
	JBYTE(N);
	JINT(M);

	return;
} /* end of GOPSL */

void GOPL(K,N)
unsigned char K;
long N;
{
	NODE *Node1;

	Node1=(NODE*)N;
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %s \t; %s",
			INS,K,Node1->ident,op_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s( %s )",
			op_name[K],Node1->ident);
#endif
	JBYTE(K);

	if ( Node1->mode & M_local || Node1->mode & M_entry )
		JLOC ( Node1->ref );
	else if ( Node1->mode & M_extrn )
		JEXT ( Node1 );
	else if ( Node1->type & T_ss || Node1->type & T_xs )
		JLOC ( Node1->ref );
	else {
		msgerr( INVLABEL, Node1->ident );
		Shutdown();
		}
	return;
}

void GOPS(K,T,C)
unsigned char K;
unsigned char T;
long C;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		{
		fprintf(Objlist_File,"\n%04u:   %d %d %08lx",
			INS,K,T,C);
		fprintf(Objlist_File," ( %lu ) \t; %s",
			C,op_name[K]);
		}
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		{
		fprintf(Macro_File,"\n\t%s( %d,%08lx )",
			op_name[K],T,C);
		}
#endif
	JBYTE(K);
	GSYMBOL(T,C);

	return;
}  /* end of GOPS */

void GSYMBOL(T,C)
unsigned char T;
long C;
{
	JBYTE(T);
	JLONG(C);
	return;
}  /* end of GSYMBOL  */

void  GSP(K)
unsigned char K;
{
	if ( Left_Part  ) {
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File,"\n%04d   %d \t\t; %s",
		INS,K,sp_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) fprintf(Macro_File,"\n\t%s()",
		sp_name[K]);
#endif
		JBYTE(K);
		}
}  /*     END GSP;   */

void GSN(K,N)
unsigned char K,N;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %d \t\t; %s",
			INS,K,N,sp_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		if ( K==S_CHR )
			{
			fprintf(Macro_File,"\n\t%s( %c )",sp_name[K],N);
			}
		else
			{
			fprintf(Macro_File,"\n\t%s( %d )",sp_name[K],N);
			}
#endif
	JBYTE(K);
	JBYTE(N);

	return;
} /* end GSN */

void GSSL(K,N,M)
unsigned char K,N;
int M;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %d %d \t; %s",
			INS,K,N,M,sp_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s( %d,%d )",
			sp_name[K],N,M);
#endif
	JBYTE(K);
	JBYTE(N);
	JINT(M);

	return;
} /* end of GSSL */

void GSL(K,N)
unsigned char K;
long N;
{
	NODE *Node1;

	Node1=(NODE*)N;
#if OBJECT==1
	if ( Opt_Obj ) 
		fprintf(Objlist_File,"\n%04d:   %d %s \t\t; %s",
			INS,K,Node1->ident,sp_name[K]);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		fprintf(Macro_File,"\n\t%s( %s )",
			sp_name[K],Node1->ident);
#endif
	JBYTE(K);

	if ( Node1->mode & M_local || Node1->mode & M_entry )
		JLOC ( Node1->ref );
	else if ( Node1->mode & M_extrn )
		JEXT ( Node1 );
	else if ( Node1->type & T_ss || Node1->type & T_xs )
		JLOC ( Node1->ref );
	else {
		msgerr( INVLABEL, Node1->ident );
		Shutdown();
		}
	return;
} /* end GSL */

void GSS(K,T,C)
unsigned char K;
unsigned char T;
long C;
{
#if OBJECT==1
	if ( Opt_Obj ) 
		{
		fprintf(Objlist_File,"\n%04u:   %d %d %08lx",
			INS,K,T,C);
		fprintf(Objlist_File," ( %lu ) \t; %s",
			C,sp_name[K]);
		}
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) 
		{
		fprintf(Macro_File,"\n\t%s( %d,%08lx )",
			sp_name[K],T,C);
		}
#endif
	JBYTE(K);
	GSYMBOL(T,C);

	return;
}  /* end of GSS */


#if OBJECT==1 || MACRO_CODE==1

#if OBJECT==1
void gnl( )
{
	if ( Opt_Obj ) fprintf(Objlist_File,"\n%04d:   ",0);
	return;
} /* end of gnl */
#endif

void gof( ident )
char* ident;
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File,"\n\t;Function %s",ident);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) fprintf(Macro_File,"\nFUNCTION( %s )",ident);
#endif
}  /* end of gof */

void gos( num )
int num;
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File,"\n\t;Stmt %d",num);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) fprintf(Macro_File,"\nSTATEMENT( %d )",num);
#endif
} /* end of gos */

void gosp( ident )
char* ident;
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File,"\n\t;Specificator %s",ident);
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) fprintf(Macro_File,"\nSPECIFICATOR( %s )",ident);
#endif
}  /* end of gosp */

void gospi( )
{
#if OBJECT==1
	if ( Opt_Obj ) fprintf(Objlist_File,"\n\t;Anonymous specificator");
#endif
#if MACRO_CODE==1
	if ( Opt_Macro ) fprintf(Macro_File,"\nSPECIFICATOR( SPEC%04d )",INS);
#endif
}  /* end of gospi */

void gopcorr1( o,c )
int o;
unsigned char c;
{
#if OBJECT==1
	if ( Opt_Obj ) 
	  fprintf(Objlist_File,"\n\t;Byte correction to %04d: %d", JADDR()+o,c);
#endif
#if MACRO_CODE
	if ( Opt_Macro ) 
	  fprintf(Macro_File, "\n\tByte correction to %04d: %d", o,c);
#endif

	JINBUF1(o,c);
}  /* end of gopcorr1 */

void gopcorr2( o,v )
int o;
int v;
{
#if OBJECT==1
	if ( Opt_Obj ) 
	  fprintf(Objlist_File,"\n\t;Int correction to %04d: %d",JADDR()+o,v);
#endif
	JINBUF2(o,v);
}  /* end of gopcorr2 */

#endif

#if MACRO_CODE==1

void gopbegmod( modname )
char *modname;
{
	if ( Opt_Macro ) fprintf(Macro_File,"\nMODULE( %s )",modname);
}

void gopendmod( void )
{
	if ( Opt_Macro ) fprintf(Macro_File,"\nENDMODULE()");
}

void gopendf()
{
	if ( Opt_Macro ) fprintf(Macro_File,"\nENDFUNCTION()");
}

void gopendst()
{
	if ( Opt_Macro ) fprintf(Macro_File,"\nENDSTATEMENT()");
}

void gopendspe()
{
	if ( Opt_Macro ) fprintf(Macro_File,"\nENDSPEC()");
}

#endif
