/* $Id: cj.c,v 1.2 1999/09/24 10:29:32 alena Exp $ */
/*-------------------------------------*/
/* UNI-LINKED REFAL                    */
/* (C) Copyright 1990, N.Mansurov      */
/*                                     */
/* RCOMP Object Module Generation      */
/*                                     */
/*-------------------------------------*/

#include "rcdecl.h"

#define BUF_LENG 6000
#define MAX_REL 4
 
static char rcs_id[]="$Id: cj.c,v 1.2 1999/09/24 10:29:32 alena Exp $";

char Buffer[ BUF_LENG ];
int  Curr_Byte;
char rel[ MAX_REL ];    /*  a small buffer to hold max REL item */


/*  Ҽ  (  ұһ )  */

#define C_END 0xFF

#define TYP_FUNC 0
#define TYP_SYST 1
#define TYP_SS   2
#define TYP_XS   3
#define TYP_BOX  4
#define TYP_EMP  5


typedef struct e_node {
	char e_name[9];
	NODE *node;
	struct e_node *next;
	} E_NODE;


E_NODE *Entry_Begin,  /* ߻ ү entry-⦻ */

		 *Extrn_Begin,  /* ߻ ү extrn-⦻ */
		 *Last_Extrn;   /*  ү extrn-⦻ */

NODE   *Local_Begin,  /* ߻ ү local-⦻ */
		 *Last_Local;   /* ұ local-һ */

unsigned int Extrn_Number;
unsigned int Entry_Number;
unsigned int Local_Number;
unsigned int Rel_Number;

int  Aux1_File;
int  Aux2_File;

char Aux1_Path[]="(###@1)_.$$$";
char Aux2_Path[]="(###@2)_.$$$";

unsigned long   Curr_Addr;
NODE  *Curr_Node;
E_NODE *Curr_E_Node;

int Flag_sjump;  /*  if there was SJUMP in the current buffer */
unsigned int Offset_sjump;  /* location of SJUMP offset in the current buffer */


#define IN_BYTE( i )  { Buffer[ Curr_Byte++ ]=(i); }

#define IN_WORD( i )  {  \
	Buffer[ Curr_Byte++ ]=(unsigned char)(i); \
	Buffer[ Curr_Byte++ ]=(unsigned char)((i)>>8); \
	}

#define IN_WORD_ARR(Buf, c, i )  {  \
	Buf[ c ]=(unsigned char)(i); \
	Buf[ c+1 ]=(unsigned char)((i)>>8); \
	}

#define IN_LONG( l )  { \
	Buffer[ Curr_Byte++ ]=(unsigned char)(l); \
	Buffer[ Curr_Byte++ ]=(unsigned char)((l)>>8); \
	Buffer[ Curr_Byte++ ]=(unsigned char)((l)>>16); \
	Buffer[ Curr_Byte++ ]=(unsigned char)((l)>>24); \
	}

#define IN_STRING( s ) { len=strlen( (s) ); \
		Buffer[ Curr_Byte++ ]=len; \
		strcpy( (Buffer+Curr_Byte),(s) ); \
		Curr_Byte+=len; \
		}

#define IN_ESTRING( s ) { strncpy( (Buffer+Curr_Byte),(s),8 ); \
		Curr_Byte+=8; \
		}

void JSTART( )
{

	Curr_Addr=0;
	Curr_Byte=0;
	Extrn_Number=0;
	Entry_Number=0;
	Local_Number=0;
	Rel_Number=0;
	Last_Local=NULL;
	Last_Extrn=NULL;

	Entry_Begin=NULL;
	Local_Begin=NULL;
	Extrn_Begin=NULL;

	Flag_sjump=FALSE;
#ifdef MSC
	Aux1_File=open(Aux1_Path, O_CREAT | O_TRUNC | O_RDWR, 
                           0666 );
#else
	Aux1_File=open(Aux1_Path, O_CREAT | O_TRUNC | O_BINARY,
			S_IREAD | S_IWRITE);
#endif
		if ( Aux1_File == -1 ) {
			msgerr( FILER,Aux1_Path);
			exit(5);
			}
#ifdef MSC
	Aux2_File=open(Aux2_Path, O_CREAT | O_TRUNC | O_RDWR,
                        0666 );
#else
	Aux2_File=open(Aux2_Path, O_CREAT | O_TRUNC | O_BINARY,
			S_IREAD | S_IWRITE);
#endif
		if ( Aux2_File == -1 ) {
			msgerr( FILER, Aux2_Path);
			exit(5);
			}

	return;
}    /*   end of  JSTART    */

void JPREV_OUT ( sentence )
int sentence;
{
int flag;
	if ( Flag_sjump ) {
		if ( sentence ) 	
		  { IN_WORD_ARR(Buffer,Offset_sjump,Curr_Byte-1); }
		else  	
		  { IN_WORD_ARR(Buffer,Offset_sjump,0); }
		Offset_sjump++;
		}

	flag=write(Aux1_File,Buffer,Curr_Byte);
/* printf("JPREV_OUT: (%d) \n",flag); */
	Curr_Addr+=Curr_Byte;
   Curr_Byte=0;
	if ( Curr_Addr > 65535 ) {
		msgerr( MODTOOLONG );
		Shutdown();
		}
	return;
	}     /* end of JPREV_OUT  */

void  JSJUMP ()
{
	Flag_sjump=TRUE;
	JCHKBUF( 3 );
	Buffer[ Curr_Byte++ ]=N_SJUMP;
	Offset_sjump=Curr_Byte;
	Curr_Byte+=2;
	return;
}       /* end of JSJUMP  */



unsigned int JWHERE()
{
	return (unsigned int)(Curr_Addr + Curr_Byte);
} /* end of JWHERE  */

unsigned int JOFFSET()
{
	return (unsigned int)(Curr_Byte);
} /* end of JOFFSET  */

unsigned int JADDR()  /* alena */
{
	return (unsigned int)(Curr_Addr);
} /* end of JADDR  */



void JBYTE( Byte )
unsigned char   Byte;

{
	JCHKBUF( 1 );
	Buffer[ Curr_Byte++ ]=Byte;

}

void JLONG ( PP )
unsigned long PP;
{
	JCHKBUF( 4 );
        IN_LONG( PP );
	return;
}  /*  end of JLONG */

void JINT ( Offset )
unsigned int Offset;
{

	JCHKBUF( 2 );
        IN_WORD(Offset);
	return;
}  /*  end of JLONG */

void JEXT ( Node1 )
NODE *Node1;
{
	int i;
	/* int Flag_Name;
	char c;
	char *ident;
        */
	i = JWHERE();
	IN_WORD_ARR(rel,0,i);
	i=(int) Node1->addr;
	IN_WORD_ARR(rel,2,i);
	write(Aux2_File,rel,MAX_REL);

	JCHKBUF( 2 );
	IN_BYTE(0xFF);
	IN_BYTE(0xFF);

	Rel_Number++;
	return;
}  /*  end of JEXT */

void JLOC (Offset)
unsigned int Offset;
{
  int i;
	i = JWHERE();
	IN_WORD_ARR(rel,0,i);
	IN_WORD_ARR(rel,2,-1);
	write(Aux2_File,rel,MAX_REL);

        IN_WORD(Offset);
	Rel_Number++;
	return;
}  /*  end of JLOC */

void JCHKBUF ( BB )
unsigned int BB;
{
	if ( Curr_Byte+BB < BUF_LENG ) return;
	else {
		msgerr( SENTTOOLONG );
		Shutdown();
		}
} /* end of JCHKBUF */

void JINBUF1 ( offset, code )
unsigned int offset;
unsigned char code;
{
	if (offset != 0)  Buffer[ offset ]= code;

}  /* end of JINBUF */

void JINBUF2 ( offset, value )
unsigned int offset;
int value;
{
	if (offset != 0)  *(int*)(Buffer+ offset)= value;

}  /* end of JINBUF2 */

unsigned char JOUTBUF1( offset )
unsigned int offset;
{
	return Buffer[ offset ];
} /* end of JOUTBUF1 */

void JENTRY(New_Node,Ident)
NODE* New_Node;
char *Ident; /*   ENTRY- */

{
	if ( strcmp(Mod_Name,Ident)==0 ) msgerr( ENTRYMOD, Ident ); /* what is it here? */
	Curr_E_Node=Entry_Begin;
	while ( Curr_E_Node != NULL ) {
		if ( strncmp(Curr_E_Node->e_name,Ident,8)==0 ) {
			msgerr( DUPLENTRY, Ident );
			return;
			}
		Curr_E_Node=Curr_E_Node->next; /*  ұ entry-һ */
		}

	Curr_E_Node=(E_NODE*)malloc(sizeof(E_NODE));
	if (Curr_E_Node == NULL) {
		msgerr( NOMEMORY );
		Shutdown();
		}
	Curr_E_Node->next=Entry_Begin;
	Entry_Begin=Curr_E_Node;
	Curr_E_Node->node=New_Node;
	strncpy(Curr_E_Node->e_name,Ident,8);

	Connect_Local( New_Node );
	Entry_Number++;
	return;

}  /*  end of JENTRY  */


void JEXTRN(New_Node,Ident)
NODE *New_Node;
char *Ident;
{
	Curr_E_Node=(E_NODE*)malloc(sizeof(E_NODE));
	if (Curr_E_Node == NULL) {
		msgerr( NOMEMORY );
		Shutdown();
		}

	Curr_E_Node->node=New_Node;

	if ( Last_Extrn == NULL ) {
		Extrn_Begin = Curr_E_Node;
		Last_Extrn = Curr_E_Node;
		}
	Last_Extrn->next=Curr_E_Node;
	Last_Extrn=Curr_E_Node;

	strncpy(Curr_E_Node->e_name,Ident,8);

	New_Node->addr = Extrn_Number;

	Extrn_Number++;
	return;

}  /*  end of JEXTRN  */

void JLABEL(Node1)
NODE* Node1;

{
	Node1->def=Line_Number;
	Node1->addr=JWHERE();
	Connect_Local( Node1 );
	return;

} /* end of JLABEL */

void  JREF(Node1)
NODE* Node1;

{
	Connect_Local( Node1 );
	return;

} /* end of JREF */

void Connect_Local ( Node1 )
NODE *Node1;
{
	if ( Node1->order != NULL ) return;

/* local-⦻ ұ  ű ⯻ Ҧ  order */
	if ( Last_Local == NULL ) {
		Local_Begin = Node1;
		Last_Local = Node1;
		}
	Last_Local->order=Node1;
	Last_Local=Node1;
	Node1->order=Node1;

	Node1->ref=Local_Number;
	Local_Number++;

	return;

}  /* end of Connect_Local */


void JEND()
{
	E_NODE *P;
	NODE *N;
	unsigned char crc,g_crc,type;
	unsigned int len,i;
	unsigned long File_Length,bytes;

	Mod_Length=Curr_Addr;
	if (Local_Number != 0)	Last_Local->order =NULL;
	if (Extrn_Number != 0)	Last_Extrn->next=NULL;

	lseek(Aux1_File,0,SEEK_SET);
	lseek(Aux2_File,0,SEEK_SET);

/* HEADER-AREA GENERATION */
	Curr_Byte=0;
	IN_BYTE( 'R' );
	IN_BYTE( 'U' );
	IN_BYTE( 'L' );
	IN_BYTE( 'E' );
	IN_BYTE( 'X' );

	IN_WORD( Mod_Length );
	IN_WORD( Local_Number  );  /*  locals */
	IN_WORD( Entry_Number );
	IN_WORD( Extrn_Number );
	IN_WORD( Rel_Number );

	File_Length=(unsigned long)Mod_Length+(unsigned long)Rel_Number*4+
			(unsigned long)Entry_Number*11+
			(unsigned long)Extrn_Number*9+
			(unsigned long)Local_Number*11;


        IN_LONG( File_Length );
	IN_ESTRING( Mod_Name );

	IN_BYTE( VERSION );
	IN_BYTE( RELEASE );
#ifdef MSC
	IN_BYTE( 0x00 );
	IN_BYTE( 0x00 );
	IN_BYTE( 0x00 );
	IN_BYTE( 0x00 );

	IN_WORD( 0x00 );
#else
	IN_BYTE( CURR_TIME.ti_hour );
	IN_BYTE( CURR_TIME.ti_min );
	IN_BYTE( CURR_DATE.da_day );
	IN_BYTE( CURR_DATE.da_mon );

	IN_WORD( CURR_DATE.da_year );
#endif
/* calculate CRC and store it */
	g_crc=0;
	for (i=0,crc=0;i< Curr_Byte; crc+=Buffer[i++]);
	g_crc+=crc;
	crc=~crc+1;
	IN_BYTE( crc );

	write(Object_File,Buffer,Curr_Byte);
	Curr_Byte=0;

	bytes=0L;

/* ENT-AREA GENERATION*/
	Curr_E_Node=Entry_Begin;
	while (Curr_E_Node!=NULL) {
		N=Curr_E_Node->node;
		if (  N->type & T_box ) type=TYP_BOX;
		else if ( N->type & T_func ) type=TYP_FUNC;
		else if ( N->type & T_ss )   type=TYP_SS;
		else if ( N->type & T_xs )   type=TYP_XS;

		IN_ESTRING( Curr_E_Node->e_name );
		IN_WORD( N->ref );  /* spill local offset */
		IN_BYTE( type );
		write(Object_File,Buffer,Curr_Byte);

		bytes+=(unsigned long)Curr_Byte;

		Curr_Byte=0;
		Curr_E_Node=Curr_E_Node->next;
		}


/*  EXT-AREA GENERATION */
	Curr_Byte=0;
	Curr_E_Node=Extrn_Begin;
	while (Curr_E_Node!=NULL) {
		N=Curr_E_Node->node;
		if ( N->type & T_sys ) type=TYP_SYST;
		else if ( N->type & T_ss ) type=TYP_SS;
		else if ( N->type & T_xs ) type=TYP_XS;
		else if ( N->type & T_func  ) type=TYP_FUNC;

		IN_ESTRING( Curr_E_Node->e_name );
		IN_BYTE( type );

		write(Object_File,Buffer,Curr_Byte);
		bytes+=(unsigned long)Curr_Byte;

		Curr_Byte=0;
		Curr_E_Node=Curr_E_Node->next;
		}

/* FUNC-AREA GENERATION */
	Curr_Byte=0;
	Curr_Node=Local_Begin;
	while (Curr_Node!=NULL) {
		if ( Curr_Node->type == 0x00 ) continue; 
/* 30/06/92 Prevents unused names to consume place in func table */
		if ( Curr_Node->type & T_box ) IN_BYTE( TYP_BOX )
		else if ( Curr_Node->type & T_empt ) IN_BYTE( TYP_EMP )
		else if ( Curr_Node->type & T_ss ) IN_BYTE( TYP_SS )
		else if ( Curr_Node->type & T_xs ) IN_BYTE( TYP_XS )
		else 	IN_BYTE( TYP_FUNC );
		IN_WORD( Curr_Node->addr );
		IN_ESTRING( Curr_Node->ident );
		write(Object_File,Buffer,Curr_Byte);

		bytes+=(unsigned long)Curr_Byte;

		Curr_Byte=0;
		Curr_Node=Curr_Node->order;
		}

/*  TEXT-AREA GENERATION */

	Curr_Byte=0;
	do {
		len=read(Aux1_File,Buffer,BUF_LENG);
		write(Object_File,Buffer,len);

		bytes+=(unsigned long)len;

		} while(len !=0);

/* RLD-AREA GENERATION */

	Curr_Byte=0;
	do {
		len=read(Aux2_File,Buffer,BUF_LENG);
		write(Object_File,Buffer,len);

		bytes+=(unsigned long)len;

		} while(len !=0);

/* END-AREA GENERATION */
	Buffer[0]=C_END;
	write(Object_File,Buffer,1);

/*JTERM:*/   /* TERMINATION */
	close(Aux1_File);
	close(Aux2_File);
	unlink(Aux1_Path);
	unlink(Aux2_Path);

	Curr_E_Node=Entry_Begin;
	while( Curr_E_Node != NULL ) {
		P=Curr_E_Node;
		Curr_E_Node=Curr_E_Node->next;
		free( P );
		}
	Curr_E_Node=Extrn_Begin;
	while( Curr_E_Node != NULL ) {
		P=Curr_E_Node;
		Curr_E_Node=Curr_E_Node->next;
		free( P );
		}


	return;

}   /* end of JEND  */

