/* $Id: cs.c,v 1.2 1999/09/24 10:29:33 alena Exp $ */
/*-------------------------------------*/
/* UNI-LINKED REFAL  Version           */
/* (C) Copyright 1990, N.Mansurov      */
/*                                     */
/* RCOMP Higher Level TNAME Access     */
/*                                     */
/*-------------------------------------*/

#include "rcdecl.h"

int gfun( char * , char *, int);
int    Flag_Ident,
		 Flag_Def;

int    Numbers[10];		/* FOR PRINTING CROSS-REFERENCES */
int    Nref;		/* NUMBER OF REFERENCES */

 
static char rcs_id[]="$Id: cs.c,v 1.2 1999/09/24 10:29:33 alena Exp $";

void FNDEF( Ident )
char *Ident;
{
	 NODE* New_Node;

	if ( Ident[0] != EOL ) {  /* A NEW FUNCTION */
		New_Node=LOOKUP( Ident );
		Curr_Stmnmb=1;
		New_Node->type |= T_func;
		if ( New_Node->mode & M_def )  msgerr( DUPLLABEL, Ident );
		else {
			New_Node->mode |= M_local | M_def;
			JPREV_OUT( FALSE ); /* spill previous without SJUMP */
			JLABEL( New_Node ); /* Әөӡ Ӊ */
			JSJUMP();
#if OBJECT==1
			gof( Ident );
			gos( Curr_Stmnmb );
#endif
			}
		}
	else {  /*  JUST ANOTHER SENTENCE OF THE SAME FUNCTION */
		Curr_Stmnmb++;
		JPREV_OUT ( TRUE );  /* spill previous with SJUMP  */
		JSJUMP();
#if OBJECT==1
		gos( Curr_Stmnmb );
#endif
		}
	return;

}  /* end of FNDEF */


void SEMPTY( ID )
char *ID;
{
	NODE* New_Node;

	New_Node=LOOKUP( ID );
	New_Node->type |= T_func | T_empt;
	if ( New_Node->mode & M_def  )   msgerr( DUPLLABEL, ID );
	else {
		New_Node->mode |= M_local | M_def;
		JPREV_OUT( FALSE ); /* spill previous without SJUMP */
		JLABEL(New_Node);
#if MACRO_CODE == 1
                /* gof( ID );
                gopendf(); */
		gfun( ID,NULL, 4);
#endif
		}
	return;
}  /* end of SEMPTY  */

void SSWAP( ID )
char *ID;
{
	NODE *New_Node;

	New_Node=LOOKUP( ID );
	New_Node->type |= T_func | T_box;
	if ( New_Node->mode & M_def )  msgerr( DUPLLABEL, ID );
	else {
		New_Node->mode |= M_local | M_def;
		JPREV_OUT( FALSE ); /* spill previous without SJUMP */
		JLABEL(New_Node);
#ifdef MACRO_CODE
		gfun(ID,NULL,3);
#endif 
		}
	return;
}  /* end of SSWAP */

void SENTRY( ID,IDE )
char *ID, *IDE;
{
	NODE *New_Node;
	New_Node=LOOKUP( ID );
	New_Node->mode |= M_entry | M_local;
	JENTRY(New_Node,IDE);
#ifdef MACRO_CODE
	gfun(ID, IDE,0);
#endif 
	return;
}  /* end of SENTRY */

void SEXTRN( ID,IDE )
char *ID, *IDE;
{
	NODE *New_Node;

	New_Node=LOOKUP( ID );
	if ( New_Node->mode & M_def  )  msgerr( DUPLLABEL, ID );
	else {
		New_Node->def=Line_Number;
		New_Node->mode |= M_extrn | M_def;
		JEXTRN(New_Node,IDE);
#ifdef MACRO_CODE
	       gfun(ID, IDE,1);
#endif 
		}
	return;
}   /* end of SEXTRN  */

void SSYSTEM( ID,IDE )
char *ID, *IDE;
{
	NODE *New_Node;

	New_Node=LOOKUP( ID );
	if ( New_Node->mode & M_def  )  msgerr( DUPLLABEL, ID );
	else {
		New_Node->type |= T_sys;
		New_Node->mode |= M_extrn | M_def;
		New_Node->def=Line_Number;
		JEXTRN(New_Node,IDE);
#ifdef MACRO_CODE
	gfun(ID, IDE,2);
#endif 
		}
	return;
}   /* end of SSYSTEM  */

NODE* FNREF( ID )
char* ID;

{
	NODE *New_Node;

	New_Node=LOOKUP( ID );
	New_Node->type |= T_func;
	if (  New_Node->mode & M_def );
	else {
		New_Node->mode |= M_local;
		JREF( New_Node );
		}
	return New_Node;
} /* end of FNREF */


NODE*  spref(id,d,s)
char* id;
int d;
int s;
{
	NODE *New_Node;

	New_Node=LOOKUP( id );

	if ( s ) New_Node->type |= T_ss;
	else New_Node->type |= T_xs;

	if ( d && !( New_Node->mode & M_def ) )  msgerr(  NOLABEL, id );
	if ( !(New_Node->mode & M_extrn) ) JREF( New_Node );  /* bind to locals */
	return New_Node;
}  /* end of spref  */

void spdef( id,s )
char *id;
int s;
{
	NODE *New_Node;

	if ( id[0]==EOL ) msgerr( NOSTMTLBL );
	else {  /* A LABEL IS PRESENT */
		New_Node=LOOKUP( id );
		if ( s ) New_Node->type |= T_ss;
		else New_Node->type |= T_xs;
		if ( New_Node->mode & M_def  )  msgerr( DUPLLABEL, id );
		else {
			New_Node->mode |= M_def;
			JLABEL(New_Node);
#if OBJECT==1
			gosp ( New_Node->ident );
#endif
			}
		}
	return;
}  /* end of spdef  */


void end_module()
{
	JPREV_OUT( FALSE ); /* spill previous without SJUMP */
	THROUGH(CHECK_ID);
	return;
}

void CHECK_ID(Check_Node)
		 /* NAME CONSISTENCY CHECK */
NODE  *Check_Node;
{
	NODE *New_Node;

	New_Node=Check_Node;
	if ( !( New_Node->mode & M_def) )
		msgerr( NOLABEL, Check_Node->ident );
	if ( ( New_Node->mode & M_entry ) && ( New_Node->mode & M_extrn )  )
		msgerr( ENTRYEXTRN,Check_Node->ident );

	if ( ( New_Node->type & T_func ) && ( New_Node->type & T_ss ) )
		msgerr( SSFUNC,Check_Node->ident );
	if ( ( New_Node->type & T_func ) && ( New_Node->type & T_xs ) )
		msgerr( SSFUNC,Check_Node->ident );
	if ( ( New_Node->type & T_xs ) && ( New_Node->type & T_ss ) )
		msgerr( SSXS,Check_Node->ident );
	if ( ( New_Node->type & T_empt ) && ( New_Node->type & T_box ) )
		msgerr( EMPBOX,Check_Node->ident );

/*	if (  New_Node->type == 0x00  ) msgerr( NOTUSED,Check_Node->ident);*/

} /*    END CHECK_ID;   */


void S_INIT()
		 /*  MODULE INITIALIZATION      */
{
#if MACRO_CODE==1
	gopbegmod( Mod_Name );
#endif
        Curr_Stmnmb=0;
	return;
}

void S_TERM()
		 /*    MODULE TERMINATION */
{
#if MACRO_CODE==1
	if ( Curr_Stmnmb != 0 ) gopendf();
	gopendmod();
#endif

	LUTERM();
	return;
}

void PR_XREF()
{
	fputc('\n',Listing_File);
	fputs ("METKA          OPE              COŔOBAHE", Listing_File);
	fputc ('\n',Listing_File);
	fputc ('\n',Listing_File);
	THROUGH(PR_XREF_ID);
	return;
}

void PR_XREF_ID(P)
			 /* CROSS REFERENCES FOR A SINGLE NAME */
NODE * P;
{
int	  K;
NODE_REF * Q;

	Flag_Ident=FALSE;
   Flag_Def=FALSE;
	if ( strlen(P->ident) >13 ) {
			/*  THE NAME DOESN'T FIT */
		fputs( P->ident,Listing_File );
		fputc('\n',Listing_File);
		Flag_Ident=TRUE;
		}
	Q=P->first_ref;
	Nref=0;
	while (Q != NULL) {
		K=0;
		while (Q->numb[K]!=0 && K<6 ) {
			if ( Nref==10 ) {
				PR_REFS( P );
				Nref=0;
				}
			Numbers[Nref]=Q->numb[K];
			Nref++;
			K++;
			}
		Q=Q->next;
		}
	PR_REFS( P );
} /*     END PR_XREF_ID; */

void PR_REFS( P )
NODE * P;
{
char  ID_DEF[19],
		NMB_DEF[5];
int   K;

	if ( Flag_Def ) {
		if ( Nref==0 ) return;
		strcpy( ID_DEF,"                   ");
		}
	else {
		if ( P->def==0 ) 	strcpy(NMB_DEF,"*****");
		else 	 sprintf( NMB_DEF," %04d",  P->def );
		if ( Flag_Ident )  sprintf(ID_DEF,"              %4s", NMB_DEF);
		else 	 sprintf(ID_DEF,"%-13s %4s",P->ident,NMB_DEF);
		}
	fputs (ID_DEF,Listing_File );
	for (K=0;K<Nref;K++) fprintf( Listing_File, " %04d" , Numbers[K] );
	fputc('\n',Listing_File);
	Flag_Ident=TRUE;
	Flag_Def=TRUE;
} /*       END PR_REFS;  */
