/* $Id: rcdecl.h,v 1.2 1999/09/24 10:29:14 alena Exp $ */
/*-------------------------------------*/
/* UNI-LINKED REFAL                    */ 
/* (C) Copyright 1990, N.Mansurov      */
/*                                     */
/* RCOMP Main Definitions              */
/*                                     */
/*-------------------------------------*/

/* Turbo C include files */

#include <stdio.h>
#include <stdlib.h>
/*#include <conio.h>*/
/*#include <dos.h>*/
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>

#ifdef MSC
#include <malloc.h>
#else
#include <malloc.h>
#endif

#include <time.h>

#ifdef MSC
#include <sys/types.h>
#include <stdarg.h>
#endif

#include <sys/stat.h>


/*   ӡӍ  쏉 ӘөӍ     */
/*      Әө DEFINE_GLOBALS                */

#define VERSION 2
#define RELEASE 0
#define OBJECT 1
#define MACRO_CODE 1

#ifdef DEFINE_GLOBALS
#define GLOBAL
#else
#define GLOBAL extern
#endif


typedef struct node {
	int ref;   /* REF-TABLE OFFSET FOR THIS ENTRY */
	int mode;
	int type;
	int addr; /* LOC ADDRESS OR RLD-NUM (for extrn) */
	int length; /* NAME LENGTH */
	struct node * left; /*  LEFT NEIGHBOUR REFERENCE */
	struct node * right; /* RIGHT NEIGHBOUR REFERENCE */
	struct node * order; /*  ʪ local-ӯӭ  */
	struct node_ref * first_ref; /* LIST OF REFERENCES */
	struct node_ref * last_ref;  /* Ӆ   */
	int def;        /* LINE OF DEFINITION */
	int incl;         /* INCLINATION TYPE */
					 /* 0 - NO INCLINATION */
					 /* 2 - INCLINATION TO THE LEFT */
					 /* 1 - INCLINATION TO THE RIGHT */
	char * ident; /* A POINTER TO NAME (STRING) */
	} NODE;

typedef  void (*FUNC) ();
typedef  void (*FUNC_STRUCT) ( struct node * );
typedef	struct node_ref {
	struct node_ref * next;
	int  numb[6];
	} NODE_REF;

#define offset( x ) (int)(JWHERE()-(int)(x))
#define PRINTLINE_F(File) { fputs(Pr_Line,File);fputc('\n',File); }
#define NEWLINE_F(File) { fputc('\n',File); }

#define PRINTLINE { \
		PRINTLINE_F(stdout);\
		if (Opt_List) PRINTLINE_F(Listing_File);\
		}
#define NEWLINE {\
		NEWLINE_F(stdout);\
		if (Opt_List) NEWLINE_F(Listing_File);\
		}


#define TRUE 1
#define FALSE 0
#define EOL '\0'
#define EOLCH '\n'
#define MAX_ID 255
#define MAX_LINE 80
#define MAX_LST 100

#define MAX_TE 100
#define MAX_JS 10
#define MAX_HOLE 50
#define MAX_BR 500


/*  TNAME  MODE and TYPE  definitions  */
#define M_undef 0x00
#define M_local 0x40
#define M_extrn 0x80
#define M_entry 0x20
#define M_def   0x10

#define T_unkn  0x00
#define T_func  0x10
#define T_sys   0x20
#define T_box   0x40
#define T_ss    0x01
#define T_xs    0x02
#define T_empt  0x04

/*  specificators descriptions */

#define   O_SPEC   0
#define   S_SPEC   1

/*  tokens definitions */
typedef enum { TOK_ERR,TOK_SC,TOK_LB,TOK_RB,TOK_SVAR,TOK_WVAR,TOK_EVAR,
	TOK_LF,TOK_RF,TOK_RIG,TOK_END } token;

#define UNDEF 64
/* INTERFACE VARIABLES */

GLOBAL  FILE *Source_File,	 *Listing_File;

#if OBJECT==1
GLOBAL  FILE *Objlist_File;
#endif
#if MACRO_CODE==1
GLOBAL  FILE *Macro_File;
#endif

GLOBAL int    Object_File;
GLOBAL char   Pr_Line[ MAX_LST ];

		  /* INTERFACE TO SCANNER */
GLOBAL unsigned int Line_Number;   /*  CURRENT LINE NUMBER */
GLOBAL char Mod_Name[ MAX_ID ];  /*  NAME OF THE MODULE */
GLOBAL unsigned int Curr_Stmnmb; /* CURRENT STATEMENT NUMBER IN THE FUNCTION */
GLOBAL unsigned int Mod_Length;  /*  LENGTH OF THE MODULE*/
GLOBAL char File_Name[ MAX_ID ];

GLOBAL char ID[ MAX_ID ];   /* BUFFER FOR IDENTIFIER */
GLOBAL char IDE [ MAX_ID ];   /*  BUFFER FOR EXTERNAL IDENTIFIER */

GLOBAL char  source[MAX_LINE+1];  /* BUFFER FOR CURRENT LINE (SOURCE) */
GLOBAL char  line[MAX_LINE+1]; /* WORK BUFFER FOR CURRENT LINE */
GLOBAL char *c;
GLOBAL int   Left_Part;  /* LEFT PART IS BEING PROCESSED */
GLOBAL int   Scn_State;  /* SCANNER STATE */
GLOBAL char   Stm_Lbl[ MAX_ID ]; /* STATEMENT LABEL */
GLOBAL int Flag_skip;  /* SKIP BAD CONTINUATION WHEN READ_LINE */

#ifdef OS2 
GLOBAL int Flag_Reverse; /* the current sentence was marked with R */
#endif

#ifdef MSC
/* */
#else
GLOBAL  struct date CURR_DATE;
		 /*       int da_year
					 char da_mon
					 char da_day   */

GLOBAL  struct time CURR_TIME;
		  /*      unsigned char ti_hour
					 unsigned char ti_min
					 unsigned char ti_sec
					 unsigned char ti_hund; */
#endif

	  /* OPTIONS */
GLOBAL int Opt_List,
			  Opt_Xref,
			Opt_Nopt,
#if OBJECT==1
			  Opt_Obj,
#endif
#if MACRO_CODE==1
			  Opt_Macro,
#endif
			  Opt_Ext;


			 /* SENTENCE ELEMENT FROM SCANNER */
GLOBAL  struct  scn_e   {
					token T;
					char CI;
					 int V;
				  unsigned char TAG;
					long CODE;
					int split;
					 } SCN_E;


			/* LEFT PART BUFFER LAYOUT */
GLOBAL struct    {
	int  P;
	int  Q;
	token T;
	int  I;
	unsigned char TAG;
	long CODE;
	int  NEXT;
	int  PAIR;
	int  V;
	int  EOEMRK;
	int  E_LEVEL;
	int  split;
} X[ MAX_TE+2 ];


/* SYSTEM CONSTANT DEFINITIONS */

#include "rul_tags.h"  	/*  definitions of tags */
#include "op_codes.h" /*  definitions of REFASS OP-CODES */
#include "sp_codes.h"   /*  definitions of spec codes     */
#include "errors.h"     /*  error messages */

/*   arguments control  modern style  */

#include "rcfunc.h"
