/* $Id: ref-gen-make.c,v 1.1.1.1 1999/09/24 10:04:31 alena Exp $ */
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include  <time.h>
#define MAX_DOP_LEN 1024
#define MAX_MOD_LEN 1024

char Mod[MAX_MOD_LEN]="";
char Dop[MAX_DOP_LEN]="";
char deps[MAX_DOP_LEN]="";
char * RefHome;
char RefH[]="$(REFAL_BIN)";
char RefL[]="$(REFAL_LIB)";
char GlobName[256]="";
FILE * MakeF;
char Makefile[]="Makefile";

static char rcs_id[]="$Id: ref-gen-make.c,v 1.1.1.1 1999/09/24 10:04:31 alena Exp $";

static char *  deexp(char * f1, char * e2)
{
int i;
static char w[MAX_DOP_LEN];
for (i=strlen(f1)-1;i>0 && f1[i]!='/';i--) 
  if (f1[i]=='.') break;
strcpy(w,f1);
if (f1[i]=='.') 
  if (e2[0]!=0)
     strcpy(w+i+1,e2);
  else
    w[i]=0;
else
  if (e2[0]!=0)
    { 
      i=strlen(f1);
      w[i]='.';
      strcpy(w+i+1,e2);
    }
  else
  {
      i=strlen(f1);
      w[i]=0;
  }
return w;
}


int  exp(char * f1, char * e2)
{
int i;
for (i=strlen(f1)-1;i>0 && f1[i]!='/';i--) 
  if (f1[i]=='.') break;
if (e2[0]==0 && ( i==0 || f1[i]=='/') ) return 1;
return (strcmp(f1+i+1,e2)==0);
}

int refsou(char * s)
{
return (exp(s,"ref") || exp(s,"") || exp(s,"mod"));
}

int csou(char * s)
{
return (exp(s,"c") || exp(s,"o"));
}

main(int argc, char ** argv)
{
int i=1;
time_t tp;
printf("Make generator for REFAL project\n");
if (argc==1)
{
  printf("No files in project\n");
  printf("Usage: %s [options] files\n",argv[0]);
  printf("      -o Name of make goal (first file name for default)\n");
  printf("      -m Name of make file (\"Makefile\" for default)\n");
  exit(1);
}

while(argv[i][0]=='-')
{
switch( argv[i][1])
{
  case 'o':
    if (argv[i][2]==0) {
      strcpy(GlobName,deexp(argv[i+1],""));
      i++;
    }
    else strcpy(GlobName,deexp(argv[i]+2,""));

    break;
  case 'm':
    if (argv[i][2]==0) {
      strcpy(Makefile,deexp(argv[i+1],""));
      i++;
    }
    else strcpy(Makefile,deexp(argv[i]+2,""));
    break;
   default:
    printf("Unknown option -%c\n",argv[i][1]);

}
i++;
}

if (GlobName[0]==0) strcpy(GlobName,deexp(argv[i],""));
  for(;i<argc;i++)
  {
    if (refsou(argv[i]))
    {
      assert(strlen(Mod)+strlen(argv[i])<MAX_MOD_LEN);
      strcat(Mod,deexp(argv[i],"mod "));
    }
    else
    if (csou(argv[i]))
    {
      assert(strlen(Dop)+strlen(argv[i])<MAX_DOP_LEN);
      strcat(Dop,deexp(argv[i],"o "));
    }
    else
    if (exp(argv[i],"a"))
    {
      assert(strlen(Dop)+strlen(argv[i])<MAX_DOP_LEN);
      strcat(Dop,argv[i]);
      strcat(Dop," ");
    }
    else
    {
      fprintf(stderr,"File %s has unknown extension. Skipped\n",argv[i]);
    }
  }
  MakeF = fopen(Makefile,"r");
  if (MakeF != NULL)
  {
    int c;
    printf("Old %s exist. Overwrite it?(y/n):", Makefile);
    c=getchar();
    if (c!='y' && c!='Y')
    {
      printf("Skiped\n");
      exit(0);
    }
  }
  MakeF = fopen(Makefile,"w");
  if (MakeF ==  NULL )
  {
    printf("Can't open %s for writing\n",Makefile);
    exit(1);
  }
  if ((RefHome=getenv("REFAL_HOME"))==NULL) 
    { RefHome=(char *)malloc(2);
      RefHome[1]=0;
      RefHome[0]='.';
    }
    else
    {
    int l=strlen(RefHome);
    if (RefHome[l-1]=='/') { RefHome[l-1]=0; l--; }
    else RefHome[l+1]=0;
    }
  if (Mod[0]!=0) Mod[strlen(Mod)-1]=0;
  if (Dop[0]!=0) Dop[strlen(Dop)-1]=0;
  tp=time(NULL);
  fprintf(MakeF,"# Generated automatically. %s\n",ctime(&tp));
  fprintf(MakeF,"REFAL_HOME=%s\n",RefHome);
  fprintf(MakeF,"REFAL_LIB=$(REFAL_HOME)/lib/\n");
  fprintf(MakeF,"REFAL_BIN=$(REFAL_HOME)/bin/\n");
  fprintf(MakeF,"MOD=%s\n",Mod);
  fprintf(MakeF,"CC=gcc\n");
  fprintf(MakeF,"CFLAGS=\n\n");
  fprintf(MakeF,".SUFFIXES: .ref .mod\n\n");
  fprintf(MakeF,"all: %s\n\n",GlobName);
  sprintf(deps,"%s.o %s %sri.o %srlib.a %srlib2.a\n",
      GlobName,Dop, RefL,RefL,RefL);
  fprintf(MakeF,"%s: %s",GlobName,deps);
  fprintf(MakeF,"\t$(CC) -o %s %s\n\n",GlobName,deps);
  
  sprintf(deps,"%s.o %s %srit.o %srlib.a %srlib2.a %strace.a\n",
      GlobName,Dop, RefL,RefL,RefL,RefL);
  fprintf(MakeF,"debug: %s",deps);
  fprintf(MakeF,"\t$(CC) -o %s %s\n\n",GlobName,deps);

  fprintf(MakeF,"%s.c: $(MOD)\n\t%srmod2c -o %s.c $(MOD)\n\n",
      GlobName,RefH,GlobName);
  fprintf(MakeF,".ref.mod:\n\t%srcomp $*.ref\n\n",RefH);
  fprintf(MakeF,".c.o:\n\t$(CC) $(CFLAGS) -c $*.c\n\n");
  fclose(MakeF);
  return 0;
}
