/* $Id: hashtabl.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $ */
static char rcs_id[]="$Id: hashtabl.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $";
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rulex.h"

	/*    tabh:  */
#define ATABE 0  /* p  tabe */
#define L 2      /*  - */
#define M 3      /*  pp tabe   */
#define FREE 4   /*   FREE */
#define HTOP 5   /*  -  tabh */

	/*   p  tab_op_elem  */
#define OLD  0        /*    */
#define NEW  50       /*   */
#define STAR 127      /*  -   p '*' */
#define ERROR 255     /*  */

  /*   :  */
#define MNEWT 0
#define MDLTH 1
#define MPRTH 2
#define MCLTH 3
#define MTSIZE 4
#define MSWRH 5
#define MSWRN 6
#define MRDRH 7
#define MWTRH 8
#define MSWRF 9
#define MPTRH 10
#define MIDXH 11
#define MINFH 12
#define MGTBH 13
#define MPTBH 14
#define MRSIZE 15

   /*    tabe */
static struct elem {
      int key_len;   /*   */
      int offset;    /*   .     FREE */
      cell *key_ref; /*    */
      cell *inf_ref; /*    */
  } *pe,*ptabe;

static cell *st,*key1,*key2;
static int ne;
static int *ph,*ptabh;

static int ll,chain;  /*  for print  */
static int cols=70;

int is_box (cell *);
int is_table (cell *);
int make_table (cell *);
int del_table (cell *);
void *get_table (cell *);
void *put_table (cell *, void *);
char *name_table (cell *);
char *name_box (cell *);
cell *get_box (cell *);

int tab_op_elem(int);
void tab_avost(int,int);
int tab_day_elem(int);
int tab_kosv(int);
void tab_pr_vf(cell *,cell *);
void tab_pr_unit(char *);

/**********************************************************/
/*  :   <newt St Sl>                      */
/*  St -  , Sl -     (L) */
/**********************************************************/

newt() {

  cell *sl,*c;
  int i;

	st=b1->next;    /*    St  */
	sl=st->next;    /*    Sl  */

	if ((is_box(st) != 1) || (st->next == b2))
		goto ERR;   /*    */

	c=get_box(st);
	if (c != NULL) { /*  */
		st=c;
		if ((i=is_table(st)) == -1)
			goto ERR;   /*    */
		if (i == 1) {   /*    */
			tab_avost(MNEWT,1);
			return 1;
			}
		}

    if (sl->tag != T_INTP) goto ERR;  /*    */
    if ((sl->inf.n == 0) || (sl->inf.n > 32000)) {
       /*      */
		  tab_avost(MNEWT,3);
		  return 1;
    }

    make_table(st);    /*        */

 /*      tabh ()  tabe ()  */

	 ptabh=(int *)malloc((sl->inf.n + HTOP) * sizeof(int));
	 ptabe=(struct elem *)malloc(sl->inf.n  * sizeof(struct elem));
	 if ((ptabh == NULL) || (ptabe == NULL)) {
		 /*  no memory  */
		  tab_avost(MNEWT,5);
        return 1;
    }

	 put_table(st,(int*)ptabh);    /*   -  tabh */

	 *(long *)ptabh=(long)ptabe; /*   tabh  tabe */
	 *(ptabh+L)=sl->inf.n;   /*  L -  -  */
	 *(ptabh+M)=sl->inf.n;   /*  M - pp tabe    */
	 *(ptabh+FREE)=1;        /*     FREE  */

	 ph=ptabh+HTOP;
	 pe=ptabe;
	 for (i=0;i<sl->inf.n;i++) {
        *ph++=0;         /*   -  tabh  */
		  pe->key_len=-1;        /*   tabe    */
		  pe->offset=i+2;        /*           */
		  pe++;                  /*      (FREE)                 */
    }

	 return 0;

  /*---  error  ---*/

    ERR:
       /*      */
		  tab_avost(MNEWT,0);
        return 1;

}


/**********************************************************/
/* p   pp :   <tsize St>         */
/*  St -                                        */
/**********************************************************/

tsize() {

	 if (tab_kosv(MTSIZE) == ERROR) {   /* p p p */
        return 1;
		  }

	 ptabh=(int *)get_table(st);

	/*   pp  (M)   */
	  succ_cell   /*     */
     b->tag=T_INTP;
	  b->inf.n=*(ptabh+M);

	return 0;
}


/**********************************************************/
/*  p     ,     */
/*         :   <rsize St>         */
/*  St -                                        */
/**********************************************************/

rsize() {

	 if (tab_kosv(MRSIZE) == ERROR) {   /* p p p */
        return 1;
		  }

	 ptabh=(int *)get_table(st);

	/*    (FREE-1)   */
	  succ_cell   /*     */
     b->tag=T_INTP;
	  b->inf.n=*(ptabh+FREE) - 1;

	return 0;
}


/**********************************************************/
/*  :   <dlth St>                          */
/*  St -                                        */
/**********************************************************/

dlth() {

  cell *c1,*c2;
  int i,m;

	 if (tab_kosv(MDLTH) == ERROR) {   /* p p p */
        return 1;
		  }

	 ptabh=(int *)get_table(st);
	 (long)ptabe=*(long *)ptabh;
 /*   tabe,    p p  */
	 pe=ptabe;
	 m=*(ptabh+M);
	 for (i=0;i<m;i++) {
			if (pe->key_len != -1) { /* p  */
				c2=pe->key_ref;   /*    */
				c1=c2->next;      /*    */
				c2->next=b->next;
				b->next=c1;
				c2=pe->inf_ref;      /*   Ey */
				if (c2 != NULL) {
					c1=c2->next;      /*   Ey */
					c2->next=b->next;
					b->next=c1;
					}
				}
			pe++;
			}

 /*    - tabh  tabe  */
	 free((int *)ptabh);
	 free((struct elem *)ptabe);

 /*        */

	 del_table(st);

	return 0;
}


/**********************************************************/
/*  :   <clth St>                            */
/*  St -                                        */
/**********************************************************/

clth() {

  cell *c1,*c2;
  int i,l,m;

	 if (tab_kosv(MCLTH) == ERROR) {   /* p p p */
        return 1;
		  }

	 ptabh=(int *)get_table(st);
	 (long)ptabe=*(long *)ptabh;

 /*   - */
	 ph=ptabh+HTOP;
	 l=*(ptabh+L);
	 for (i=0;i<l;i++) *ph++=0;

 /*   tabe,    p p , */
 /*    p tabe   FREE */
	 pe=ptabe;
	 m=*(ptabh+M);
	 for (i=0;i<m;i++) {
			if (pe->key_len != -1) { /* p  */
				c2=pe->key_ref;   /*    */
				c1=c2->next;      /*    */
				c2->next=b->next;
				b->next=c1;
				c2=pe->inf_ref;      /*   Ey */
				if (c2 != NULL) {
					c1=c2->next;      /*   Ey */
					c2->next=b->next;
					b->next=c1;
					}
				pe->key_len=-1;      /* p .  */
				}
			pe->offset=i+2;
			pe++;
			}

	 *(ptabh+FREE)=1;    /*    FREE */

	return 0;
}


/**********************************************************/
/*  :   <prth St>                            */
/*  St -                                        */
/**********************************************************/

prth() {

  cell *c1,*c2;
  int i,m;

	 if (tab_kosv(MPRTH) == ERROR) {   /* p p p */
        return 1;
		  }

	 ptabh=(int *)get_table(st);
	 (long)ptabe=*(long *)ptabh;

 /*   */
	 printf("    ");
	 printf("%s\n",name_table(st));

 /*   tabe  p p  */
	 pe=ptabe;
	 m=*(ptabh+M);
	 for (i=0;i<m;i++) {
			if (pe->key_len != -1) { /* p  */
				printf("%6d  ",i+1);  /* p  */
				c2=pe->key_ref;   /*    */
				c1=c2->next;      /*    */
				tab_pr_vf(c1,c2); /*   */
				printf("%9c\n",'=');
				printf("%8c",' ');
				c2=pe->inf_ref;      /*   Ey */
				if (c2 != NULL) {
					c1=c2->next;      /*   Ey */
					tab_pr_vf(c1,c2); /*  p */
					}
				else putchar('\n');
				}
			pe++;
			}

	return 0;
}


/**********************************************************/
/*                        */
/*  p p :  <swrh St (Ez) Ex> */
/*  St -  , Ez - , Ex - p          */
/**********************************************************/

swrh() {

  cell *c,*c1,*c2;
  int rc;

  rc=tab_op_elem(MSWRH);    /*  p ,  */
                            /*       */

/*   ne -  .; ph  pe -   .  tabh  tabe */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

   /*  ne   */
	  succ_cell   /*     */
     b->tag=T_INTP;
	  b->inf.n=ne;

  if (rc < NEW) {  /*    */
   /*    */
        /*  Ey  ,      */
     c2=pe->inf_ref;   /*   Ey */
     if (c2 != NULL) { /* Ey   */
        c=b->next;
        c1=c2->next;
        b->next=c1;
        c2->next=c;
        b=c2;
        }
     }
 /*      */
  c2=b2->inf.a;   /*   Ex */
  if (key2 == c2) pe->inf_ref=NULL; /* Ex empty */
  else {
	  c2->next=key2->next;    /*  Ex */
     key2->next=b2;
	  pe->inf_ref=c2; /*     . . */
	  }
	return 0;
}


/**********************************************************/
/*  :  <swrn St (Sn)>                          */
/*  St -  , Sn -                   */
/**********************************************************/

swrn() {

  cell *c,*c1,*c2,*lb;
  int rc;

  rc=tab_op_elem(MSWRN);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe; */
/*         ptabh -  tabh; ptabe -  tabe.                 */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

 /*         */
     c2=pe->key_ref;   /*    */
	  c1=c2->next;      /*    */
     lb=NULL;         /*     */
MULE1:
		if ( c1->tag ==T_BE ) {
			c=b;
			succ_cell
			b->tag=T_BE;
			b->inf.a = c;
			c=lb;
			lb=c->inf.a;
			c->inf.a=b;
			}
		else {
			succ_cell
			b -> tag = c1 -> tag;
			if ( c1->tag <= T_SHT ) b->inf.n = c1->inf.n;
			else if ( c1->tag ==T_BH) {
				b->inf.a=lb;
				lb=b;
				}
			else if ( c1->tag ==T_END ) c->inf.a =b;
			else c=b;
			}
		if ( c1 != c2 ) {
			c1=c1->next;
			goto MULE1;
			}
	return 0;
}


/**********************************************************/
/*  p :  <rdrh St (Ez)>           */
/*  St -  , Ez -                            */
/**********************************************************/

rdrh() {

  cell *c,*c1,*c2,*lb;
  int rc;

  rc=tab_op_elem(MRDRH);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe; */
/*         ptabh -  tabh; ptabe -  tabe.                 */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

 /*  p (Ey)       */
	  c2=pe->inf_ref;   /*   p */
	  if (c2 == NULL) return 0;  /* Ey empty */
	  c1=c2->next;      /*   p */
     lb=NULL;         /*     */
MULE1:
		if ( c1->tag ==T_BE ) {
			c=b;
			succ_cell
			b->tag=T_BE;
			b->inf.a = c;
			c=lb;
			lb=c->inf.a;
			c->inf.a=b;
			}
		else {
			succ_cell
			b -> tag = c1 -> tag;
			if ( c1->tag <= T_SHT ) b->inf.n = c1->inf.n;
			else if ( c1->tag ==T_BH) {
				b->inf.a=lb;
				lb=b;
				}
			else if ( c1->tag ==T_END ) c->inf.a =b;
			else c=b;
			}
		if ( c1 != c2 ) {
			c1=c1->next;
			goto MULE1;
			}
	return 0;
}


/**********************************************************/
/*   p   p:     */
/*          <wtrh St (Ez) Ex>                             */
/*  St -  , Ez - ,  -  p    */
/**********************************************************/

wtrh() {

  cell *c1,*c2;
  int rc;

  rc=tab_op_elem(MWTRH);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe; */
/*         ptabh -  tabh; ptabe -  tabe.                 */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

 /*  Ey  ,  p    .  */
	  c2=pe->inf_ref;   /*   Ey */
	  if (c2 != NULL) {
		  c1=c2->next;      /*   Ey */
		  c2->next=b->next;
		  b->next=c1;
		  }
 /*    p  */
	  if (key2->next == b2) pe->inf_ref=NULL; /* Ex empty */
	  else {
				c2=b2->inf.a;        /*    */
				c2->next=key2->next; /*   */
				key2->next=b2;       /* p  p. */
				pe->inf_ref=c2;      /*    tabe */
			  }
	return 0;
}


/**********************************************************/
/*    :  <swrf St (Ez)>          */
/*  St -  , Ez -                            */
/**********************************************************/

swrf() {

  cell *c1,*c2;
  int rc,i,l;
  struct elem *pe1;

  rc=tab_op_elem(MSWRF);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe; */
/*         ptabh -  tabh; ptabe -  tabe.                 */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

 /* p   .    p  */
	  c2=pe->key_ref;   /*    */
	  c1=c2->next;      /*    */
	  c2->next=b->next;
	  b->next=c1;
	  c2=pe->inf_ref;      /*   Ey */
	  if (c2 != NULL) {
		  c1=c2->next;      /*   Ey */
		  c2->next=b->next;
		  b->next=c1;
		  }
 /*----     ----*/
		 /*   -   */
	  ph=ptabh+HTOP;
	  l=*(ptabh+L);
	  for (i=0;i<l;i++)
		  if (*(ph+i) == ne) { /*  - */
				*(ph+i)=pe->offset;   /*     */
				goto IN_FREE;         /*     FREE */
				}
		 /*      tabe */
	  pe1=ptabe;
	  while (pe1->offset != ne) pe1++;
	  pe1->offset=pe->offset;  /*     */
 /*     FREE */
IN_FREE:
			pe->key_len = -1;
			pe->offset=*(ptabh+FREE);
			*(ptabh+FREE)=ne;
			return 0;
}


/**********************************************************/
/*   p :  <ptrh St (Ez) Ex>  */
/*  St -  , Ez - ,  -              */
/**********************************************************/

ptrh() {

  cell *c,*c1,*c2;
  int rc;

  rc=tab_op_elem(MPTRH);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe; */
/*         ptabh -  tabh; ptabe -  tabe.                 */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

 /*    Ey */
	  if (key2->next == b2) return 0; /* Ex empty */
	  c2=b2->inf.a;    /*   Ex */
	  c1=key2->next;   /*   Ex */
	  key2->next=b2;   /* p  p. */
	  c=pe->inf_ref;   /*   Ey */
	  if (c == NULL)      /* Ey empty */
			 c2->next=c1;      /*   */
	  else {              /* Ey not empty */
			 c2->next=c->next; /*   */
			 c->next=c1;
			 }
	  pe->inf_ref=c2;
	  return 0;
}


/**********************************************************/
/*  p :  <idxh St (Ez)>                */
/*  (    ,   )       */
/*  St -  , Ez -                            */
/**********************************************************/

idxh() {

  int rc;

  rc=tab_op_elem(MIDXH);    /*  p ,  */
                            /*       */

/*   ne -  .; ph  pe -   .  tabh  tabe */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

  if (rc == NEW)
     pe->inf_ref=NULL;  /* Ey empty */

   /*  ne   */
	  succ_cell   /*     */
     b->tag=T_INTP;
	  b->inf.n=ne;
	return 0;
}


/**********************************************************/
/* p   p : <infh St (Ez)> */
/*  ('+' - p , '-' -  )               */
/*  St -  , Ez -                            */
/**********************************************************/

infh() {

  int rc;
  char s;

  rc=tab_op_elem(MINFH);    /*  p ,   */

/*   ne -  .; ph  pe -   .  tabh  tabe */

  if (rc == STAR) return 0;  /*    '*'  */
  if (rc == ERROR) return 1; /*     */

  s=(pe->inf_ref == NULL)? '-' : '+';
	/*  s   */
	  succ_cell   /*     */
	  b->tag=T_CHR;
	  b->inf.c=s;
	return 0;
}

/**************************************************************/
/*       */
/**************************************************************/
int tab_kosv(int mop) {

	st=b1->next;    /*    St  */

	if (is_box(st) == 1) {		/*  */
		st=get_box(st);
		if (is_table(st) != 1) {   /* p p p */
			tab_avost(mop,0);
			return ERROR;
			}
		}

	else if (is_table(st) != 1) {   /* p p p */
		tab_avost(mop,0);
		return ERROR;
		}

return 0;
}

/**********************************************************/
/*            */
/*      .  : St(Ez)Ex     */
/*   SWRH  IDXH -   .  */
/**********************************************************/

int tab_op_elem(int mop) {

  cell *c,*c1,*c2;
  int kl,nh;
  long sum;

	c=b1->next;       /*    */

	if (tab_kosv(mop) == ERROR) {   /* p p p */
		return ERROR;
		}
  ptabh=(int *)get_table(st);     /*    tabh */
  (long)ptabe=*(long *)ptabh;           /*    tabe */
     /*   */
  key1=c->next;    /*   */
  key2=key1->inf.a; /*   */
  if ( (key1->tag != T_BH) || (key2->tag != T_BE) || (key1->next == key2) )
    goto ERR;  /*    */
  c=key1->next;  /*    */

  if (c->tag == T_INTP)  {  /*  -  Sn */
     if (c->next != key2) goto ERR; /* Sn   */
	  if ( ((ne=c->inf.n) > *(ptabh+M)) || (ne == 0) )
			goto REZ_STAR; /*   . */
	  pe=ptabe+ne-1;    /*  */
	  if (pe->key_len == -1) goto REZ_STAR; /* .  */
	  ph=NULL;
     return 0;
     }
  else {  /*  -  Ez */
    /*       */
	  sum=kl=0;
     while (c != key2) {
		  sum=sum+c->tag+((c->tag < T_SHT)? c->inf.n : 0);
        kl++;
        c=c->next;
        }
     if (kl < 0) { /*    */
		  tab_avost(mop,4);
        return ERROR;
        }
    /*   - */
	  nh=sum % *(ptabh+L);
	  ph=ptabh+HTOP+nh;
    /*    */
	  ne=*ph;

     if (ne != 0) goto CEP;

    /*    "" */
     if ( (mop != MSWRH) && (mop != MIDXH) )  goto REZ_STAR;

	 /*    */
	  pe=ptabe;  /*    */
	  if (tab_day_elem(mop)==ERROR) return 1; /*   ne  .  */
	  *ph=ne; /*   tabh - */
TOG:
     pe=ptabe+ne-1;    /*  */
       /*    */
     pe->key_len=kl;
     pe->offset=0;
     c2=key2->inf.a;
	  c2->next=key1->next;   /*   */
     key1->next=key2;
     pe->key_ref=c2;

     return NEW;

  /*    "" ,      */
CEP:
     while (ne != 0) {
			pe=ptabe+ne-1;    /* ""  */
			if (kl == pe->key_len) {  /*    */
           /*    */
           c2=pe->key_ref;
           c1=c2->next;
           c=key1;
			  while ( 1 ) {
				c=c->next;
				if ( c == key2 ) goto NEXTEL;
				if ( c->tag != c1->tag  ) goto NEXTEL;
				if ( ( c->tag < T_SHT ) && ( c->inf.n != c1->inf.n ) ) goto NEXTEL;
				if ( c1 != c2 ) c1=c1->next;
				else return OLD;   /*   */
				}
			}
NEXTEL:    ne=pe->offset;  /*    */
        }

    /*   c  "" */
     if ( (mop != MSWRH) && (mop != MIDXH) )  goto REZ_STAR;

	 /*    */
	  if (tab_day_elem(mop)==ERROR) return 1; /*   ne  .  */
     pe->offset=ne; /*    */
     goto TOG;

     }

REZ_STAR:  /*  '*'   */
		  succ_cell
		  b->tag=T_CHR;
		  b->inf.c='*';
        return STAR;

ERR:  /*    */
		  tab_avost(mop,0);
        return ERROR;
}

/**********************************************************/
/*                             */
/**********************************************************/

int tab_day_elem(int mop) {

  int i,size;
  struct elem *pe1;

	  size=*(ptabh+M);  /*    tabe */
	  ne=*(ptabh+FREE); /*   .  */

	  if (ne > size) {	 /*    */
		  i=pe-ptabe;  /* . . p,  p  pe */
			 /*  tabe  50 . */
		  ptabe=realloc(ptabe,(size+50) * sizeof(struct elem));
		  if (ptabe == NULL) {
			  tab_avost(mop,5);
			  return ERROR;
			  }
		  pe=ptabe+i;    /* p pe   ptabe */
		  *(long *)ptabh=(long)ptabe; /*   tabh   tabe */
        *(ptabh+M)+=50;   /*  pp tabe  50 . */
			 /*  p     FREE */
		  pe1=ptabe+size;
		  for (i=0;i<50;i++) {
			  pe1->key_len=-1;
			  pe1->offset=size+i+2;
			  pe1++;
			  }
	  }
	  *(ptabh+FREE)=((struct elem *)(ptabe+ne-1))->offset;  /*   FREE */
	  return 0;
}

/**********************************************************/
/*                                */
/**********************************************************/

static char name_op[15][5] = { "NEWT",
										 "DLTH",
										 "PRTH",
										 "CLTH",
										 "SIZE",
										 "SWRH",
										 "SWRN",
										 "RDRH",
										 "WTRH",
										 "SWRF",
										 "PTRH",
										 "IDXH",
										 "INFH",
										 "GTBH",
										 "PTBH"  };

void tab_avost(int mop,int numb) {

  char *str;

  printf(" ***  ABOCT   ");
  printf("%s\n",&name_op[mop][0]);

  switch (numb) {
    case 0:   str="  "; break;
    case 1:   str="   "; break;
    case 2:   str="   "; break;
    case 3:   str="   "; break;
    case 4:   str="   32000"; break;
    case 5:   str="    "; break;
    }
  printf("%s",str);
  if ((numb != 0) && (numb != 4))  printf("%s",name_table(st));
  printf("\n");

        
}

/*********************************************************/

#define MAX_ELEM 20
static char unit[MAX_ELEM];
void tab_pr_vf(c1,c2)
	/*	c1   - */
	/*	c2   - */
cell *c1, *c2;
{

int i;
char *name_box_p;

ll=0;
chain=FALSE;
while ( 1 ) {
		for( i=0;i<MAX_ELEM;i++) unit[i]='\0';

		if ( chain && c1->tag != T_CHR ) {
			tab_pr_unit("\'");
			chain=FALSE;
			}
		switch (c1->tag) {
			case T_CHR :
				if (c1->inf.c == '\'') {
					tab_pr_unit("\'\'");
					break;
					}
				if ( !chain ) {
					unit[0]='\'';
					unit[1]=c1->inf.c;
					unit[2]='\0';
					tab_pr_unit(unit);
					chain=TRUE;
					break;
					}
				unit[0]=c1->inf.c;
				unit[1]='\0';
				tab_pr_unit(unit);
				break;

			case T_INTP :
				unit[0]='/';
				sprintf(unit+1,"%10u",c1->inf.n);
				strcat(unit,"/");
				tab_pr_unit(unit);
				break;
			case T_INTM :
				unit[0]='/';
				unit[1]='-';
				sprintf(unit+2,"%10u",c1->inf.n);
				strcat(unit,"/");
				tab_pr_unit(unit);
				break;
			case T_LAB : /* call name_box */
				unit[0]='/';
				name_box_p=name_box(c1);
				if (name_box_p == NULL ) name_box_p="????";
				strcpy(unit+1,name_box_p);
				strcat(unit,"/");
				tab_pr_unit(unit);
				break;
			case T_BH :
				tab_pr_unit("(");
				break;
			case T_BE :
				tab_pr_unit(")");
				break;
			default :
				tab_pr_unit("@");
				break;
			}
		if (c1 == c2) break;
		c1 = c1 -> next;
	}
if ( chain ) tab_pr_unit("\'");
putchar('\n');
}

void tab_pr_unit( str)
char *str;
{
int el;
	el=strlen( str );
	if ( ll+ el+1 >= cols ) { /* max number of columns */
		if ( chain )  {
			if ( el==1 && str[0]=='\'' ) {
				putchar('\'');
				putchar('\n');
            printf("%8c",' ');
				ll=0;
				return;
				}
			else if ( el==2 && str[0]=='\'' ) {
				putchar('\'');
				putchar('\n');
            printf("%8c",' ');
				ll=0;
				chain=FALSE;
				}
			else {
				putchar('\'');
				putchar('\n');
            printf("%8c",' ');
				putchar('\'');
				ll=1;
				}
			}
		else {
			putchar('\n');
         printf("%8c",' ');
			ll=0;
			}
		}
	printf("%s",str);
	ll+=el;
	return;
}
