/* $Id: logic_f.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $ */
static char rcs_id[]="$Id: logic_f.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $";
#include <rulex.h>

/*********************************************************/
/*      :       */
/*     nbitof,nbiton,numand,numor,numxor,numcmp,         */
/*     gnumbit,numbit,bitnum,numlenb,numtm,ntbit,        */
/*             ngetbit,nputbit                           */
/*********************************************************/


/*********************************************************/
/*  nbitof -  i-                    */
/*                                                       */
/*  :  <nbitof s1 s2>                                */
/*         s1 -     ,  */
/*         s2 -     ,       */
/*                 (0-23)            */
/*  : [ ss ]                                        */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
nbitof()
{ cell *c,*q,*r,*w;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; q = b;
                           w = c;
                           q -> tag = T_INTP;
                           goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
                 w = q;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  i = c -> inf.n;
  if (r -> next != b2) return 1;
  if (i > 23) return 1;
  j = 1;
  j = j << (23-i);
  j = (~j ) & 0xffffff;
  q -> inf.n = w -> inf.n & j;
  return 0;
 }

/*********************************************************/
/*  nbiton -  i-                    */
/*                                                       */
/*  :  <nbiton s1 s2>                                */
/*         s1 -     ,  */
/*         s2 -     ,       */
/*                 (0-23)            */
/*  : [ ss ]                                        */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
nbiton()
{ cell *c,*q,*r,*w;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; q = b;
                           w = c;
                           q -> tag = T_INTP;
                           goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
                 w = q;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  i = c -> inf.n;
  if (r -> next != b2) return 1;
  if (i > 23) return 1;
  j = 1;
  j = j << (23-i);
  q -> inf.n = w -> inf.n | j;
  return 0;
 }
 
/*********************************************************/
/*  numand -  AND                               */
/*                                                       */
/*  :  <numand s1 s2>                                */
/*         s1 -             */
/*         s2 -             */
/*  : [ ss = s1&s2 ]                                */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
numand()
{ cell *c,*q,*r,*w;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; q = b;
                           w = c;
                           q -> tag = T_INTP;
                           goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
                 w = q;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
	  { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  if (r -> next != b2) return 1;
  q -> inf.n = w -> inf.n & c -> inf.n;
  return 0;
 }

/*********************************************************/
/*  numor -  OR                                 */
/*                                                       */
/*  :  <numor s1 s2>                                 */
/*         s1 -             */
/*         s2 -             */
/*  : [ ss = s1|s2 ]                                */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
numor()
{ cell *c,*q,*r,*w;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; q = b;
                           w = c;
                           q -> tag = T_INTP;
                           goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
                 w = q;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  if (r -> next != b2) return 1;
  q -> inf.n = w -> inf.n | c -> inf.n;
  return 0;
 }

/*********************************************************/
/*  numxor -  XOR                               */
/*                                                       */
/*  :  <numxor s1 s2>                                */
/*         s1 -             */
/*         s2 -             */
/*  : [ ss = s1^s2 ]                                */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
numxor()
{ cell *c,*q,*r,*w;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; q = b;
                           w = c;
                           q -> tag = T_INTP;
                           goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
                 w = q;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  if (r -> next != b2) return 1;
  q -> inf.n = w -> inf.n ^ c -> inf.n;
  return 0;
 }

/*********************************************************/
/*  numcmp -                                             */
/*                                                       */
/*  :  <numcmp s1 >                                  */
/*         s1 -             */
/*  : [ ss = ~s1 ]                                  */
/*         ss - ,    ,     */
/*                          */
/*********************************************************/
numcmp()
{ cell *c,*q,*r;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { succ_cell; b ->tag =T_INTP;
  			   q = c;r=b; goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
		 if (q->tag != T_INTP) return 1;
		 r = q;
     } else return 1;
  number:
  if (c -> next != b2) return 1;
  r -> inf.n = ~q -> inf.n;
  r -> inf.n = r -> inf.n & 0xffffff;
  return 0;
 }

/*********************************************************/
/*  gnumbit -                                            */
/*                                                       */
/*  :  <gnumbit s1 s2 [s3...sN]>                     */
/*         s1 -             */
/*         s2,s3...sN -                        */
/*         s2...sN > 1  < 24  N < 25                    */
/*            ,   9(1) */
/*          32(24)                                     */
/*  : [ s2...sN ]                                   */
/*         s2...sN -     s2...sN */
/*********************************************************/
gnumbit()
{ cell *c,*q;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { q = c; goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
     } else return 1;
 number:
 while(c -> next != b2)
 { succ_cell;
   b -> tag = T_INTP;
   b -> inf.n = 0;
   c = c -> next;
   if (c -> tag != T_INTP) return 1;
   if (c -> inf.n > 23) return 1;
   i = 1;
   i = i << (23 - c -> inf.n);
   if ( q -> inf.n & i  ) b -> inf.n = 1;
 };
  return 0;
 }

/*********************************************************/
/*  numbit -               */
/*                                                       */
/*  :  <numbit s1 >                                  */
/*         s1 -             */
/*  : [ ss ]                                        */
/*         ss -  -            */
/*********************************************************/
numbit()
{ cell *c,*q;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { q = c; goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
     } else return 1;
  number:
  if (c -> next != b2) return 1;
  i = 1;
  i = i << 23;
  for (j=0;j<24;j++)
  { succ_cell; b -> tag = T_CHR; b -> inf.n = 0;
  if ( q -> inf.n & i  ) { b -> inf.c = '1'; }
                else b -> inf.c = '0'; i = i >> 1;
  };
  return 0;
 }

/*********************************************************/
/*  bitnum -    -   */
/*           ,    0  1           */
/*                                                       */
/*  :  <numbit e1 >                                  */
/*         e1 -  0  1   24,  */
/*                                                  */
/*  : [ ss ]                                        */
/*         ss -                                */
/*********************************************************/
bitnum()
{ cell *c,*q;
  cell* get_box(cell*);
  long i,j;

 i = 0;
 c=b1->next;
 for(j=0;j<24;j++)
 { if (c == b2) break;
	if (c -> tag != T_CHR) return 1;
   i = i << 1;
	switch(c -> inf.c)
   { case '0': break;
     case '1': i++; break;
     default: return 1;
	};
	c = c -> next;
 };
  if ( c != b2 ) return 1;
   succ_cell; b -> tag = T_INTP; b -> inf.n = i;
  return 0;
 }

/*********************************************************/
/*  numlenb -                                            */
/*                                                       */
/*  :  <numbit 1 >                                  */
/*         1 -                                */
/*  : [ s0 e1 ]                                     */
/*         s0 -  -                  */
/*********************************************************/
numlenb()
{ cell *c,*q;
  long i,j;
  int k;

 i = 0;
 c=b1->next;
 if (c == b2) { succ_cell; b -> inf.n = 0;
                b -> tag = T_INTP; return 0; };
  while ( c-> next != b2)
  { if (c -> tag != T_INTP) return 1;
    if (c -> inf.n != 0) break;
    c = c -> next;
  };
  j = 1;
  while(j <= c -> inf.n)
  { i++; j = j << 1;
  };
  while ( c -> next != b2)
  { if (c -> tag != T_INTP) return 1;
    i = i + 24;
    c = c -> next;
  };
  end_look:
  succ_cell;
  b -> tag = T_INTP;
  b -> inf.n = i;
  q = b -> next;
  b -> next = b1 -> next;
  b = c;
  c -> next = q;
  b1 -> next = b2;
  return 0;
 }

/*********************************************************/
/*  numtm -                                              */
/*                                                       */
/*  :  <numbit s1 s2 wt wf>                          */
/*         s1 -             */
/*         s2 -             */
/*         wt,wf -                                  */
/*  : [ wt,  s1&s2 >0 ]                         */
/*         [ wf,  s1&s2 =0 ]                         */
/*********************************************************/
numtm()
{ cell *c,*q,*r;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { q = c; goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  if (r -> next == b2) return 1;
  if (q -> inf.n & c -> inf.n) goto first;
  r = r -> next;
  if (r -> tag == T_BH) r = r -> inf.a;
  c = r -> next;
  if (c -> tag == T_BH) c = c -> inf.a;
  if (c -> next != b2) return 1;
  c -> next = b -> next;
  b -> next = r -> next;
  b = c;
  r -> next = b2;
  return 0;
  first:
  c = r -> next;
  if (c -> tag == T_BH) c = c -> inf.a;
  q = c -> next;
  c -> next = b -> next;
  b -> next = r -> next;
  b = c;
  r -> next = q;
  if (q -> tag == T_BH) q = q -> inf.a;
  if (q -> next != b2) return 1;

  return 0;
 }
/*********************************************************/
/*  ntbit -                                              */
/*                                                       */
/*  :  <numbit s1 s2 wt wf>                          */
/*         s1,s2 -                             */
/*         wt,wf -                                  */
/*  : [ wt,  s1(s2)=1 ]                         */
/*         [ wf,  s1(s2)=0 ]                         */
/*********************************************************/

ntbit()
{ cell *c,*q,*r;
  cell* get_box(cell*);
  long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) { q = c; goto number; };
 if (is_box(c)==1)
     { q=get_box(c);
       if (q==NULL) return 1;
                 if (q->tag != T_INTP) return 1;
     } else return 1;
  number:
  c = c -> next;
  r = c;
  if (c == b2) return 1;
  if (c -> tag == T_INTP) goto number_1;
  if (is_box(c)==1)
     { c=get_box(c);
       if (c==NULL) return 1;
       if (c->tag != T_INTP) return 1;
     } else return 1;
  number_1:
  if (r -> next == b2) return 1;
  if (c -> inf.n > 23) return 1;
  j = 1;
  j = j << (23 - c -> inf.n);
  if (q -> inf.n & j) goto first;
  r = r -> next;
  if (r -> tag == T_BH) r = r -> inf.a;
  c = r -> next;
  if (c -> tag == T_BH) c = c -> inf.a;
  if (c -> next != b2) return 1;
  c -> next = b -> next;
  b -> next = r -> next;
  b = c;
  r -> next = b2;
  return 0;
  first:
  c = r -> next;
  if (c -> tag == T_BH) c = c -> inf.a;
  q = c -> next;
  c -> next = b -> next;
  b -> next = r -> next;
  b = c;
  r -> next = q;
  if (q -> tag == T_BH) q = q -> inf.a;
  if (q -> next != b2) return 1;

  return 0;
 }

/*********************************************************/
/*  ngetbit -                                            */
/*                                                       */
/*  :  <ngetbit sf n1 n2>                            */
/*         n1 -   -  ,                */
/*         n2 -   -  ,               */
/*         sf -            */
/*  : [ n3 ]                                        */
/*         n3 -  -    -    */
/*              ,   n1  n2                 */
/*********************************************************/
ngetbit()
{
	 cell *c,*q,*r,*w,*v;
	 cell* get_box(cell*);
	 long i,j;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) {
	  w = c;
	  goto number;
 };
 if (is_box(c)==1) {
	  q=get_box(c);
	  if (q==NULL) return 1;
	  if (q->tag != T_INTP) return 1;
	  w = q;
 }
 else return 1;
 number:

 c = c -> next;
 r = c;
 if (c == b2) return 1;
 if (c -> tag != T_INTP) return 1;
 if (c -> inf.n > 23) return 1;

 c = c -> next;
 v = c;
 if (c == b2) return 1;
 if (c -> tag != T_INTP) return 1;
 if (c -> inf.n > 23) return 1;

 if (v -> next != b2) return 1;

 succ_cell;
 b -> tag = T_INTP;
 b -> inf.n = w -> inf.n >> (23 - v -> inf.n);
 i = 0xffffff;
 i = i >> (23 - v -> inf.n + r -> inf.n);
 b -> inf.n = b -> inf.n & i;
 return 0;
}
/*********************************************************/
/*  nputbit -                                            */
/*                                                       */
/*  :  <nputbit sf n1 n2 n3>                         */
/*         n1 -   -  ,                */
/*         n2 -   -  ,               */
/*			  n3 -  -                                */
/*         sf -            */
/*  : [ sf bkb gecnjn3 ]                            */
/*********************************************************/
nputbit()
{
	 cell *c,*q,*r,*w,*v,*s;
	 cell* get_box(cell*);
	 long i;

 c=b1->next;
 if (c == b2) return 1;
 if (c -> tag == T_INTP) {
	  succ_cell;
	  q = b;
	  w = c;
	  q -> tag = T_INTP;
	  goto number;
 };
 if (is_box(c)==1) {
	  q=get_box(c);
	  if (q==NULL) return 1;
	  if (q->tag != T_INTP) return 1;
	  w = q;
 }
 else return 1;
 number:

 c = c -> next;
 r = c;
 if (c == b2) return 1;
 if (c -> tag != T_INTP) return 1;
 if (c -> inf.n > 23) return 1;

 c = c -> next;
 v = c;
 if (c == b2) return 1;
 if (c -> tag != T_INTP) return 1;
 if (c -> inf.n > 23) return 1;

 c = c -> next;
 s = c;
 if (c == b2) return 1;
 if (c -> tag != T_INTP) return 1;

 if (s -> next != b2) return 1;

 i = 0xffffff;
 i = i >> (23 - v -> inf.n + r -> inf.n);
 s -> inf.n = s -> inf.n & i;
 s -> inf.n = s -> inf.n << (23 - v -> inf.n);
 i = i << (23 - v -> inf.n);
 i = ~ i;
 q -> inf.n = w -> inf.n & i;
 q -> inf.n = q -> inf.n | s -> inf.n;
 return 0;
}




