/* $Id: tmx_nvec.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $ */
static char rcs_id[]="$Id: tmx_nvec.c,v 1.1.1.1 1999/09/24 10:04:33 alena Exp $";
#include <stdio.h>
#ifdef MSC
#include <malloc.h>
#else
#include <alloc.h>
#endif
#include "rulex.h"
#define YES 1
#define NO  0

	char *itoa();
	char *ltoa();
	cell *get_box();

	static unsigned int i;
	static unsigned long l;
	static unsigned int n1,n2;

	typedef struct SVEC_B {
		int  TYP_B;
		int  LEN_B;
		int  FRE_B;
		unsigned char * VEC_B;
	} SVEC_B;

	typedef struct SVEC_H {
		int  TYP_H;
		int  LEN_H;
		int  FRE_H;
		unsigned int  * VEC_H;
	}SVEC_H  ;

	static struct SVEC_F {
		int  TYP_F;
		int  LEN_F;
		int  FRE_F;
		unsigned long * VEC_F;
	} *D;

	typedef struct SVEC_D {
		int  TYP_D;
		int  LEN_D;
		int  FRE_D;
		struct {
			unsigned long L;
			unsigned long R;
		} * VEC_D;
	} SVEC_D;

	static struct SVEC_O {
		int  TYP_O;
		int  LEN_O;
		int  FRE_O;
		struct {
			cell *H;
			cell *T;
		} * VEC_O;
	} *A, *B;

	static cell *P;
	static cell *G;
	static long *E;
	static int  WAS_ALLOCATED;
	static int  LOG_MAX;
	static int  LOG_FRE;
	static int  POP_FLG;
	static char C;
	static unsigned int  K,N;

 /********************************************************************/
 /*                                                                  */
 /* AC MACK B      BEKTOP                                       */
 /*                                                                  */
 /* <MSKWTV  S EX> -> <CTO>                                       */
 /*                 -> '*' - P OKE                              */
 /* EX - MACKA      BEKTOPA                                          */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /*                                                                  */
 /********************************************************************/

MSKWTV() {

  /* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};

  A=G->inf.n;
  A=*(long *)A;

  C=A->TYP_O;
  P = P->next;
  switch(C) {
     case 'B' : {
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_B*)A)->VEC_B[0]=0xFF;
        else { /* MACKA ECT */
			  ((struct SVEC_B*)A)->VEC_B[0]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
        };
     }; break;
     case 'H' : {
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_H*)A)->VEC_H[0]=0xFFFF;
        else { /* MACKA ECT */
			  ((struct SVEC_H*)A)->VEC_H[0]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
        };
     }; break;
     case 'F' : {
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_F*)A)->VEC_F[0]=0xFFFFFFFFL;
        else { /* MACKA ECT */
			  *(unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
        };
     }; break;
     case 'D' : {
        /* EPEM MACK */
		  if (P==b2)  {/* MACK HET */
			  ((struct SVEC_D*)A)->VEC_D[0].L=0xFFFFFFFFL;
			  ((struct SVEC_D*)A)->VEC_D[0].R=0xFFFFFFFFL;
			  }
        else { /* MACKA ECT */
			  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  };
     }; break;
  };
  return(0);
};

 /********************************************************************/
 /*                                                                  */
 /* ABEEHE      BEKTOPA                                           */
 /*                                                                  */
 /* <NEWSV ST SN [ EM ]> -> S                                       */
 /* ST - T EMEHTA B H F D - CMBO                               */
 /*      B - AT                                                    */
 /*      H - OCOBO                                               */
 /*      F - COBO                                                   */
 /*      D - BOHOE COBO                                           */
 /* SN - KOECTBO EMEHTOB      BEKTOPA - MAKPOPA              */
 /* EM - MACKA  OCKA - MAKPOP O 16 T                     */
 /* S - M      BEKTOPA - CMBO-METKA                             */
 /*                                                                  */
 /********************************************************************/

NEWV() {

  int n;

  /* B T */
  P = b1->next; C = P->inf.c;
  /* B H */
  P = P->next; l = P->inf.n;

  if ((E=malloc(4))==NULL) return(2);

  P = P->next;
  switch(C) {
	  case 'B' : {
		  n=l+1;
			if ((A=malloc(n+6))==NULL) return(2);
			/* initialize by zeros */
			for (i=1;i<=l;i++) {
				((struct SVEC_B*)A)->VEC_B[i]=0;
		  }
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_B*)A)->VEC_B[0]=0xFF;
        else { /* MACKA ECT */
			  ((struct SVEC_B*)A)->VEC_B[0]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  };
     }; break;
	  case 'H' : {
		  n=2*(l+1);
			if ((A=malloc(n+6))==NULL) return(2);
			/* initialize by zeros */
			for (i=1;i<=l;i++) {
				((struct SVEC_H*)A)->VEC_H[i]=0;
		  }
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_H*)A)->VEC_H[0]=0xFFFF;
        else { /* MACKA ECT */
			  ((struct SVEC_H*)A)->VEC_H[0]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  };
     }; break;
	  case 'F' : {
		  n=4*(l+1);
			if ((A=malloc(n+6))==NULL) return(2);
			/* initialize by zeros */
			for (i=1;i<=l;i++) {
				((struct SVEC_F*)A)->VEC_F[i]=0;
		  }
        /* EPEM MACK */
		  if (P==b2)  /* MACK HET */
			  ((struct SVEC_F*)A)->VEC_F[0]=0xFFFFFFFFL;
        else { /* MACKA ECT */
			  *(unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  };
     }; break;
	  case 'D' : {
		  n=8*(l+1);
			if ((A=malloc(n+6))==NULL) return(2);
			/* initialize by zeros */
			for (i=1;i<=l;i++) {
				((struct SVEC_D*)A)->VEC_D[i].L=0L;
				((struct SVEC_D*)A)->VEC_D[i].R=0L;
			}
        /* EPEM MACK */
		  if (P==b2)  {/* MACK HET */
			  ((struct SVEC_D*)A)->VEC_D[0].L=0xFFFFFFFFL;
			  ((struct SVEC_D*)A)->VEC_D[0].R=0xFFFFFFFFL;
			  }
        else { /* MACKA ECT */
			  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
			  P = P->next;
			  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
        };
	  }; break;
	  case 'O' : {
		  n=8*(l+1);
			if ((A=malloc(n+6))==NULL) return(2);

			/* initialize by zeros */
			for (i=1;i<=l;i++) ((struct SVEC_O*)A)->VEC_O[i].H=NULL;
	  }; break;
  };

	A->LEN_O=l;
	A->TYP_O=C;
	A->FRE_O=1;

  /* OBAEM PETAT */
  succ_cell
  b->tag=T_REF;
  *E=A;
  b->inf.n=E;
  return(0);

};

 /********************************************************************/
 /*                                                                  */
 /* AC B      BEKTOP O HOMEP                                   */
 /*                                                                  */
 /* <WTRV  S SN EX> -> <CTO>                                      */
 /*                  -> S '*' EX - P OKE                       */
 /* EX - TEO EMEHTA - MAKPOP                                  */
 /* S - M      EKTOPA - CMBO-METKA  K C HM              */
 /* SN - HOMEP EMEHTA                                              */
 /*                                                                  */
 /********************************************************************/

WTRV() {

  /* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

  /* B HOMEP */
  P = P->next; N = P->inf.n;
  C=A->TYP_O;

  /* POBEPKA HA BXO A PAH */
  if (N>A->LEN_O )  error();

  switch(C) {

	  case 'B' : {
		  P = P->next;
		  ((struct SVEC_B*)A)->VEC_B[N]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
	  }; break;

	  case 'H' : {
		  P = P->next;
		  ((struct SVEC_H*)A)->VEC_H[N]=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
	  }; break;

	  case 'F': {
		  P = P->next;
		  *(unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[N]))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  P = P->next;
		  *((unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[N]))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
	  }; break;

	  case 'D' : {
		  P = P->next;
		  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].L))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  P = P->next;
		  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].L))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  P = P->next;
		  *(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].R))=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
		  P = P->next;
		  *((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].R))+1)=(P->tag==T_INTM)?-P->inf.n:P->inf.n;;
	  }; break;

	  case 'O' : {
/*dbg  return(0);*/
			G=P;
			P = P->next;
			if (((struct SVEC_O*)A)->VEC_O[N].H!=NULL) { /* was not empty */
				/* return to the free chain */
				((struct SVEC_O*)A)->VEC_O[N].T->next=b->next;
				b->next=((struct SVEC_O*)A)->VEC_O[N].H;
			};
			/* hang target */
		if (G==b2->inf.a) {
			((struct SVEC_O*)A)->VEC_O[N].H=NULL;
		} else {
			((struct SVEC_O*)A)->VEC_O[N].H=P;
			((struct SVEC_O*)A)->VEC_O[N].T=b2->inf.a;
			/* making safe */
			G->next=b2;
			b2->inf.n=G;
		};
	  }; break;
  };

  return(0);
};


 /********************************************************************/
 /*                                                                  */
 /* CTBAHE        BEKTOPA O HOMEP                            */
 /*                                                                  */
 /* <RDRV  S SN> -> EX                                              */
 /*               -> '*' - P OKE                                */
 /* EX - TEO EMEHTA - MAKPOP                                  */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /* SN - HOMEP EMEHTA                                              */
 /*                                                                  */
 /********************************************************************/

RDRV() {

	cell *c1;
	cell *c2;
	cell *lb;
	cell *c;

  /* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

  /* B HOMEP */
  P = P->next; N = P->inf.n;
  C=A->TYP_O;

  if (N>A->LEN_O) {
	  error();
	  return(0);
  }
  switch(C) {

	  case 'B' : {
		  succ_cell;
		  b->inf.n=((struct SVEC_B*)A)->VEC_B[N];
		  b->tag=T_INTP;
	  }; break;

	  case 'H' : {
		  succ_cell;
		  b->inf.n=((struct SVEC_H*)A)->VEC_H[N];
		  b->tag=T_INTP;
	  }; break;

	  case 'F' : {
        succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[N]))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[N]))+1);b->tag=T_INTP;
	  }; break;

	  case 'D' : {
		  succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].L))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].L))+1);b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].R))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[N].R))+1);b->tag=T_INTP;
	  }; break;

	  case 'O' : {
/*dbg  return(0);*/
			if (((struct SVEC_O*)A)->VEC_O[N].H!=NULL) {
				c2=((struct SVEC_O*)A)->VEC_O[N].T;   /*   */
				c1=((struct SVEC_O*)A)->VEC_O[N].H;   /*   */
				lb=NULL;         /*     */
MULE1:
				if ( c1->tag ==T_BE ) {
					c=b;
					succ_cell
					b->tag=T_BE;
					b->inf.a = c;
					c=lb;
					lb=c->inf.a;
					c->inf.a=b;
					}
				else {
					succ_cell
					b -> tag = c1 -> tag;
					if ( c1->tag <= T_SHT ) b->inf.n = c1->inf.n;
					else if ( c1->tag ==T_BH) {
						b->inf.a=lb;
						lb=b;
					}
					else if ( c1->tag ==T_END ) c->inf.a =b;
					else c=b;
				}
				if ( c1 != c2 ) {
					c1=c1->next;
					goto MULE1;
				}
			};
	  }; break;
  };

  return(0);
}

 /********************************************************************/
 /*                                                                  */
 /* CTBAHE        BEKTOPA O HOMEP                            */
 /*                                                                  */
 /* <P1V   S SN> ->                                                 */
 /*               -> '*' - P OKE                                */
 /* EX - TEO EMEHTA - MAKPOP                                  */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /* SN - HOMEP EMEHTA                                              */
 /*                                                                  */
 /********************************************************************/

P1V() {

	cell *c1;
	cell *c2;
	cell *lb;
	cell *c;

  /* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

  /* B HOMEP */
  P = P->next; N = P->inf.n;
  C=A->TYP_O;

  if (N>A->LEN_O) {
	  error();
	  return(0);
  }
  switch(C) {

	  case 'B' : {
		  error();
		  return(0);
	  }; break;

	  case 'H' : {
		  ((struct SVEC_H*)A)->VEC_H[N]=((struct SVEC_H*)A)->VEC_H[N]+1;
	  }; break;

	  case 'F' : {
		  ((struct SVEC_F*)A)->VEC_F[N]=((struct SVEC_F*)A)->VEC_F[N]+1;
	  }; break;

	  case 'D' : {
		  error();
		  return(0);
	  }; break;

	  case 'O' : {
		  error();
		  return(0);
	  }; break;
  };

  return(0);
}


 /********************************************************************/
 /*                                                                  */
 /* PACEATKA      BEKTOPA                                          */
 /*                                                                  */
 /* <PRTV  S [ SN ! S1 S2]>                                         */
 /* S - M              - CMBO-METKA  K C HM              */
 /* SN - EHH HOMEP EMEHTA                                    */
 /* S1 - C KAKOO EMEHTA                                           */
 /* S2 - O KAKOO EMEHTA                                          */
 /*                                                                  */
 /********************************************************************/

PRTV() {

	int n1,n2;

	/* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

  /* B HOMEP */
  if (P->next==b2)  { /* BBOM BCE */
	  n1=1;
	  n2=A->LEN_O;
	  PRT();
  };

  P=P->next; n1 = P->inf.n;

  if (P->next==b2)  { /* BBOM BCE */
	  PRT();
  };

  P=P->next; n2 = P->inf.n;

  PRT(n1,n2);

  return(0);
};

static PRT(int n1,int n2) {

	int i;
	char buf[10];

	printf("*** BEKTOP ***\n");

	C=A->TYP_O;
	for (i=n1;i<=n2;i++) {
		printf("%d",i);
		printf("  -  ");
		switch(C) {
			case 'B' : {
				printf("%x",((struct SVEC_B*)A)->VEC_B[i]);
			}; break;
			case 'H' : {
				printf("%x\n",((struct SVEC_H*)A)->VEC_H[i]);
			}; break;
			case 'F' : {
				printf("%x",((struct SVEC_F*)A)->VEC_F[i]);
			}; break;
			case 'D' : {
				printf("%x",((struct SVEC_D*)A)->VEC_D[i]);
			}; break;
		};
	};
};


 /********************************************************************/
 /*                                                                  */
 /* CTBAHE        BEKTOPA MACK                                */
 /*                                                                  */
 /* <MSKRDV S> -> EX                                                */
 /*              -> '*' - P OKE                                 */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /* EX - MACKA      BEKTOPA                                          */
 /*                                                                  */
 /********************************************************************/

MSKRDV() {

	/* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

	C=A->TYP_O;

	switch(C) {
	  case 'B' : {
		  succ_cell;
		  b->inf.n=((struct SVEC_B*)A)->VEC_B[0];
		  b->tag=T_INTP;
	  }; break;

	  case 'H' : {
		  succ_cell;
		  b->inf.n=((struct SVEC_H*)A)->VEC_H[0];
		  b->tag=T_INTP;
	  }; break;

	  case 'F' : {
		  succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_F*)A)->VEC_F[0]))+1);b->tag=T_INTP;
	  }; break;

	  case 'D' : {
		  succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].L))+1);b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*(unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))  ;b->tag=T_INTP;
		  succ_cell
		  b->inf.n=*((unsigned int *)(&(((struct SVEC_D*)A)->VEC_D[0].R))+1);b->tag=T_INTP;
	  }; break;
  };

  return(0);

};

 /********************************************************************/
 /*                                                                  */
 /* CTBAHE        BEKTOPA H                                */
 /*                                                                  */
 /* <LENV  S> -> SN                                                 */
 /*            -> '*' - P OKE                                   */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /* SN - HA      BEKTOPA                                          */
 /*                                                                  */
 /********************************************************************/

LENV() {

	/* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	A=*(long *)A;

  succ_cell
  b->inf.n=A->LEN_O;
  b->tag=T_INTP;

  return(0);

}

 /********************************************************************/
 /*                                                                  */
 /* AEHE      BEKTOPA                                            */
 /* <DELV  S> -> <CTO>                                            */
 /*            -> '*' - P OKE                                   */
 /* S - M      BEKTOPA - CMBO-METKA  K C HM              */
 /*                                                                  */
 /********************************************************************/

DELV() {

	/* B M CTEK-BEKTOPA */
	P = b1->next;
	G=P;
	if (is_box(P)) {
		G=get_box(P);
		G=G->next;
	};
	A=G->inf.n;
	B=*(long *)A;
	if (B==NULL) {
		error();
		return(0);
	}
	*(long *)A=NULL;

	switch (A->TYP_O) {
		case 'O' : {
			for (i=1;i<=B->LEN_O;i++) {
				if (B->VEC_O[N].H!=NULL) { /* was not empty */
					/* return to the free chain */
					B->VEC_O[N].T->next=b->next;
					b->next=B->VEC_O[N].H;
				};
			};
		}; break;
	};

	free(B);

	return(0);

}

 /********************************************************************/
 /*                                                                  */
 /********************************************************************/

static ERROR() {

	succ_cell;
	b->tag=T_CHR;
	b->inf.c= '*';  /*    */

}

