#ifdef __MSDOS__
#ifndef __LARGE__
#error Memory model must be large
#endif
#include<alloc.h>
#else
#include<stdlib.h>
#endif

#include<string.h>

#ifndef MM_LIB
#define MM_LIB

typedef void* MM_handle;

#ifdef __cplusplus
extern "C" {
#endif
typedef enum
{
	No_block,
	No_init,
	No_memory,
	Error_size,
	H_overflow,
	No_EMB_memory,
	Free_locked_block,
	Unlock_without_lock
} MM_error_type;

static MM_error_type MM_error;
/*
	       
*/

static int MM_init(long size,int a)
{
    return(1);
}
/*
	   .
	 size -     (   );
		  ==-1  -   .
	 :
		 0 -   
		 1 -  
          - MALLOC
     ( CALLOC   MALLOC )    
         NULL (     )
           
     -.  ,  use_low_memory ( .  )
        -   ,  
        ,   ,
      MALLOC  CALLOC,     
     ,        
      ,   .
*/

static int MM_close(void)
{
    return(0);
}
/*
	   .
    :
		 0 -   
       1 -  
     - MALLOC.
*/

static MM_handle MM_alloc(size_t size)
{
    return(malloc(size));
}
/*
	     size .  
 ,       -
  .
      =0,     .
*/

static void* MM_lock(MM_handle handle) { return(handle);}
/*
        handle  .  
 ,     ,    , -
    - malloc,  calloc.       -
  ,        ,  -
 ,      .  -
  ,   ,  .
	      -    
 . ,      
          0,   
      .
	  NULL    .
*/

static int MM_unlock(MM_handle handle) { return(1);}
/*
          handle.    
   1.
    :
       0 -   
		 1 -  
*/
    
static int MM_free(MM_handle handle) { free(handle);return(1);}
/*
	     handle.     
 .
	 :
       0 -   
		 1 -  
*/

static int MM_unlock_and_free(MM_handle handle) {free(handle);return(1);}
/*
	     handle,   1  -
.    ,  ,    
  1 .
	 :
		 0 -   
		 1 -  
*/
static unsigned relocate_avaiable;
/*
	 ,    EMB.  
  .
	 =0 -   .
	 =1 -  (    ).
*/
#ifdef __MSDOS__
static unsigned long MM_coreleft(int type) { return(coreleft());}
#else
static unsigned long MM_coreleft(int type) { return((unsigned)(-1));}
#endif
/*
	 type=
		  0 -   -    EMB
		  1 -       EMB
*/
static size_t MM_h_size(MM_handle h);
/*
	     h
*/
static unsigned use_low_memory;
/*
	 ,     .
	     .
	 =0 -     . (  
	 ,    EMB )
	 =1 -    (    ).
*/
static unsigned alloc_only_in_EMB;
/*
	 ,     . 
	        .
	     .
	 =1 -       EMB
	 =0 -        , 
	  EMB   (    ).
*/
static void MM_clear_low_memory(unsigned type) { return;}
/*
	         EMB
	 type==0 -  
		  ==1 -  
*/
static int MM_sh_cmp(char *str,MM_handle h)
{
    int i;
    if((i=strcmp(str,h))==0) return(0);
    if(i<0) return(-1);else return(1);
}

/*
	   (..  '\0')  str 
	    h.
	 :	0 - 
						1 - str > h
					 - 1 - str < h
						2 - 
*/
static int MM_2h_cmp(MM_handle h1,MM_handle h2)
{
    int i;
    if((i=strcmp(h1,h2))==0) return(0);
    if(i<0) return(-1);else return(1);
}
/*
	   (..  '\0')  2- 
	  h1  h2.
	 :	0 - 
						1 - h1 > h2
					 - 1 - h1 < h2
						2 - 
*/
static int MM_2h_copy(MM_handle h1,MM_handle h2,size_t how)
{
    memcpy(h1,h2,how);
    return(1);
}
static int MM_write(MM_handle h,unsigned h_off,void *str,unsigned len)
{
    char *s=h;
    memcpy(&s[h_off],str,len);
    return(1);
}
/*
	     h   h_off   
	     str  len 
*/
#define MM_hs_cpy(h,sr) MM_write(h,0,sr,strlen(sr)+1)
/*
	     h  sr,  '\0'
*/
#define MM_hs_memcpy(h,sr,len) MM_write(h,0,sr,len)
/*
	     h	   
	 sr  len 
*/
static int MM_read(MM_handle h,unsigned h_off,void *str,unsigned len)
{
    char *s=h;
    memcpy(str,&s[h_off],len);
    return(1);
}
/*
	     h   h_off   
	      str len 
*/
#define MM_sh_memcpy(sr,h,len) MM_read(h,0,sr,len)
/*
	     h     
	 str len 
*/

/*
          -   -
	 , 
*/
static int MM_working=0;
#ifdef __cplusplus
}
#endif

#endif
