/*  RULEX-C INTERFACE DEFINITIONS */
#include <stdio.h>

	/*** Rulex cell structure ***/
typedef struct cell  {
	unsigned char tag  ; /* type of the cell */
	union {
		struct cell *a;	/* BR or one of the LONGs: ptr to the cell */
		unsigned int  f;	/* function :offset in func table. */
		unsigned char c;		/* symbol: actual value. */
		unsigned long n; /* one of the SHORTs: contents */
		} inf;
	struct cell *next; /* ptr to following cell */
	} cell;

		/*** Rulex  global variables ***/

#ifdef DEFINE_EXTERNALS
#define EXTERNAL
#else
#define EXTERNAL extern
#endif

EXTERNAL cell *b1, *b2, *b;

	/*  Define some handy constants */
#ifdef MSC
#define succ_cell {if(b->next==NULL)ri_getcells();b=b->next;}
#else
#define succ_cell; {if(b->next==NULL)ri_getcells();b=b->next;}
#endif

#define FALSE 0
#define TRUE 1

/*  RULEX 0.00   definitions of tags */

/*  0..19  shorts */
/*  20..24 right brackets BE FE FIX */
/*  25..34 longs  */
/*  35..45 structures */

#define T_SHT  20  /* c->tag < T_SHT  short */
#define T_STR  24  /* c->tag > T_STR  structure */

#define T_INN  0  /* 00 */
#define T_CHR  1  /* 01 */
#define T_TXT  2  /* 02 */
#define T_INTP 3  /* 03 */
#define T_INTM 4  /* 04 */

#define T_BIN  5  /* 05 */
#define T_REAL 6  /* 06 */
#define T_REF  7  /* 07 */

#define T_LAB  8  /* 08 */
#define T_SYS  9  /* 09 */
#define T_END  10 /* 0A */

#define T_LTXT 25  /*  */
#define T_LINTP 26  /*  */
#define T_LINTM 27
#define T_DBL 28
#define T_LBIN 29  /*  */

#define T_BH   35  /*  */
#define T_FH   36  /*  */

#define T_BE   20  /*  */
#define T_FE   21  /*  */
#define T_FIX  22  /*  */

