/* $Id: trace.c,v 1.2 1999/09/24 10:43:37 alena Exp $ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>

#include "rulex.h"
#include "funct.h"
#include "status.h"
#include "trace.h"
#include "mtrace.h"
#include "trc_func.h"
#include "window.h"
#include "keydefs.h"
#include "zat.h"
 
static char rcs_id[]="$Id: trace.c,v 1.2 1999/09/24 10:43:37 alena Exp $";

void key_break()
{
if ( flag_break ) {
	flag_break=FALSE;
	flag_switch=flag_trcscr;
	tracer_screen();
	window_urgent("User break");
	dial(2);
	if ( !flag_switch )user_screen();
	flag_break=TRUE;
	}
return;
}

void init_trace( )
{
/* tap rulex key parameters */
signal(SIGINT,key_break_c);
signal(SIGKILL,key_break_c);
signal(SIGILL,int_error);
signal(SIGSEGV,int_error);
signal(SIGKILL,int_error);


ate=(cell**)getvect( INT1 );
anst=(unsigned long*)ate[1];
afunc_head=(cell**)ate[0];
afunc_base=(func*)ate[2];
afunc_end=(func*)ate[3];
afunc_rec=(func**)ate[4];
avf_b=(cell*)ate[5];
avf_e=(cell*)ate[6];
ares_head=(cell**)ate[7];
aimm_flag=(int*)ate[8];
aimm_func=(int*)ate[9];
ab1=(cell**)ate[10];
afunc_tail=(cell**)ate[11];
ab=(cell**)ate[12];
asystem_cell=(cell*)ate[13];
aname_base=(char*)ate[14];
aname_end=(char*)ate[15];

flag_trace=FALSE;
flag_abort=FALSE;
flag_chkmem=FALSE;
flag_report=FALSE;
flag_refass=FALSE;
min_nst=1;
max_nst=0xffffffff;

max_fsi=MAX_FS_ITEM * fs_item; /* precompute max offset into fs */

/* install trace */
setvect( INT1,(ifunc *)trace_start);
setvect( INT2,(ifunc *)trace_end);
setvect( INT3,(ifunc *)trace_stop);

/* show 'em how much core 'ave they got */
start_screen();
/*tracer_screen();*/
/* memory(); */

flag_break=TRUE;
return;
} /* end of init_trace */

void trace_end(  )
{

/* flag_break=FALSE;*/
if ( flag_chkmem ) {
	chkmem_status=check_memory();
	if ( chkmem_status != 0 ) {
		tracer_screen();
		errmsg("List memory error: %s",list_msg[chkmem_status]);
		}
	if ( !check_free() ) {
		tracer_screen();
		errmsg("Free list is corrupted");
		}
	}
if ( flag_trace ) { /* manual override */
	tracer_screen();
	end_step();
	goto FINE;
	}

if ( NST < min_nst || NST > max_nst ) goto FINE;
/*  within range */

if (FUNC_REC->trace & M_BRK ) {
	tracer_screen();
	end_step();
	dial(1);
	}

FINE:
if ( NST==max_nst ) {
	/* let 'em know we are about to leave range */
	tracer_screen();
	message("About to leave range");
	dial(1);
	}

flag_break=TRUE;
return;
} /* end of trace_end */

void trace_start()
{
unsigned char sta;
int flag_start;

if ( flag_abort ) {
	abort_status=FUNC_REC->status;
	FUNC_REC->status=STATUS_ABORT;
	}
CHECK_FOR_MORE:
if ( fsi >0 ) { /* check for pending tracepoints */
		fsi-=fs_item;
		if ( FS_HP==FUNC_HEAD ) {
			if ( ! flag_trace && NST < max_nst ) {
				tracer_screen();
				window_puts(MAIN,"*** RESULT\n");
				message("Result of function %.8s from step %lu",nameptr(FS_FN),FS_ST);
				if ( FS_B2->tag==T_FH )
					win_vf(MAIN,FS_B1,(FS_B2->inf.a)->next);
				else	win_vf(MAIN,FS_B1,FS_B2);
				dial(0);
				goto CHECK_FOR_MORE;
				}
			}
		else 	fsi+=fs_item;
		}

if ( flag_trace ) {
			tracer_screen();
			start_step();
			dial(0);
			goto FINS;
			}
if ( NST < min_nst || NST > max_nst ) goto FINS;
/*  within range */

flag_start=FALSE;
if ( NST==min_nst ) {
	/* let 'em know we've arrived */
	/*tracer_screen();*/
	start_step();
	if ( NST != 1 ) message("Entered range");
	flag_start=TRUE;
	dial(0);
	}

if ( (sta=FUNC_REC->trace) == 0x00 ) goto FINS;

/* request is pending */
if ( sta & M_BRK )	{
	tracer_screen();
	if (! flag_start ) start_step();
	message("Function break on %.8s",nameptr(FUNC_REC));
	}
if ( sta & M_FUNC ) {
	if ( fsi > max_fsi ) { /* fs overflow */
		tracer_screen();
		errmsg("Too many func-tracepoints");
		}
	else {
		tracer_screen();
		if ( !flag_start ) start_step();
		message("Function tracepoint on %.8s",nameptr(FUNC_REC));
		FS_B1=*ares_head;
		FS_B2=ate[1]->next;
		FS_HP=FUNC_TAIL;
		FS_ST=NST;
		FS_FN=FUNC_REC;
		fsi+=fs_item;
		}
	}

dial(0);

FINS:
if( FUNC_REC->status==STATUS_SYS || flag_refass ) 	user_screen();

flag_break=TRUE;
ate[4]=(cell *)flag_refass;
return;
} /* end of trace_start */

void trace_stop()
{
int retcode;
/* func* next_rec; */
long space;

flag_break=FALSE;
if ( flag_abort ) {
	FUNC_REC->status=abort_status;
	flag_abort=FALSE;
	}
tracer_screen();
LAST_CHECK:
if ( fsi >0 ) { /* last check for pending tracepoints */
		fsi-=fs_item;
		if ( FS_HP==NULL ) {
			if ( ! flag_trace && NST < max_nst ) {
				window_puts(MAIN,"*** RESULT\n");
				message("Result of function %.8s from step %lu",nameptr(FS_FN),FS_ST);
				win_vf(MAIN,FS_B1,FS_B2);
				dial(2);
				goto LAST_CHECK;
				}
			}
		}
fsi=0;

retcode=(int)ate[2];

ultoamy(NST,buff,10);
window_puts(MAIN,"*** Number of Steps: ");
window_puts(MAIN,buff);
window_puts(MAIN,"\n");
if (retcode == 0) {
	message(ret_msg[0]);
	window_puts(MAIN,"\n*** View Field:\n");
	win_vf(MAIN,avf_b,avf_e);
	}
else {
	if (retcode<0 || retcode>9 ) retcode=9;
	errmsg(ret_msg[retcode]);
	if (retcode!=6) {
		 window_puts(MAIN,"\n*** Current function: ");
		 put_name(MAIN,nameptr(FUNC_REC));
		 }
	if ( retcode != 2 ) {
		window_puts(MAIN,"\n*** Current view field:\n");
		win_vf(MAIN,ate[0],ate[1]);
		window_puts(MAIN,"*** Left side of view field:\n");
		win_vf(MAIN,avf_b,(*ares_head)->next);
		window_puts(MAIN,"*** Right side of view field:\n");
		win_vf(MAIN,ate[1],avf_e);
		}
	}
/*
  if ( message("Contents of boxes")!= BIOS_ESC ) {
	for (next_rec=afunc_base;next_rec< afunc_end; next_rec++)
		if ( view_box( next_rec )== BIOS_ESC ) break; */ /* ESC aborts */
/*	} */

space = sizeof(cell) * (long)ate[3] * (int)ate[4];
window_puts(MAIN,"*** Memory allocated: ");
ultoamy(space,buff,10);
window_puts(MAIN,buff);
window_puts(MAIN," bytes\n");
dial(2);
user_screen();
return;
}
          /*---------------------------------------------------*/

void dial( flag )
int flag;
{
int done,key;
func* rec;
long temp;

done=FALSE;
while ( !done ) {
	key=bioskey( 0 );
	switch (key) {
		case BIOS_F1 :
			info(help1);
			break;
		case BIOS_F5 :
			user_screen();
			/* bioskey(0); */
			tracer_screen();
			break;
		case BIOS_F6 :
			flag_refass=! flag_refass;
			if ( flag_refass ) message("Refal Internal Debugger is ON");
			else message("Refal Internal Debugger is OFF");
			break;
		case BIOS_F7 :
			flag_trace=TRUE;
			done=TRUE;
			break;
		case BIOS_F8 :
			if (flag==2) break;  /* please, not in a key_break mode */
			if ( fsi > max_fsi ) { /* fs overflow */
				errmsg(" Too many tracepoints");
				}
			else {
				flag_trace=FALSE;
				FS_B1=*ares_head;
				if (flag==0) FS_B2= ate[1]->next;
				else FS_B2=(*ab)->next;
				FS_HP=FUNC_TAIL;
				FS_ST=NST;
				FS_FN=FUNC_REC;
				fsi+=fs_item;
				done=TRUE;
				}
			break;

		case BIOS_F9 :
			flag_trace=FALSE;
			done=TRUE;
			break;

		case BIOS_F10 :
			flag_trace=FALSE;
			flag_abort=TRUE;
			if ( flag==0 ) {     /* if on start abort immediately */
				abort_status=FUNC_REC->status;
				FUNC_REC->status=STATUS_ABORT;
				}
			done=TRUE;
			NST=0;
			break;

		case BIOS_ESC :
		case BIOS_ENTER :
		case BIOS_space :
			done=TRUE;
			break;

		case BIOS_b :
			if ( input(" Function to break: ",buff) ) {
			/*	strupr(buff); */
				rec=seek_name( buff );
				if ( rec==NULL ) errmsg(" Function %s not found",buff);
				else rec->trace |= M_BRK;
				}
			break;
		case BIOS_f :
			if ( input(" Function to trace: ",buff) ) {
			/*	strupr(buff);*/
				rec=seek_name( buff );
				if ( rec==NULL ) errmsg(" Function %s not found",buff);
				else rec->trace |= M_FUNC;
				}
			break;
		case BIOS_r :
			if ( input(" Min step of range: ",buff) ) {
				if ( (temp=atol(buff))!=0) min_nst=temp;
				else errmsg(" Invalid number");
				}
			if ( input(" Max step of range: ",buff) )  {
				if ( (temp=atol(buff))!=0) max_nst=temp;
				else errmsg(" Invalid number");
				}
			if ( max_nst<min_nst )max_nst=min_nst;
			break;
		case BIOS_v :
			if ( input("Name of box: ",buff) ) {
			/*	strupr( buff );*/
				rec=seek_name( buff );
				if ( rec==NULL ) errmsg(" Name %s not found",buff);
				else if ( rec->status != STATUS_BOX && rec->status != STATUS_UNINIT )
					errmsg(" %s is not a box",buff);
				else view_box( rec );
				}
			break;
		case BIOS_u :
			if ( input(" Function to un-trace: ",buff) ) {
			/*	strupr(buff);*/
				rec=seek_name( buff );
				if ( rec==NULL ) errmsg(" Function %s not found",buff);
				else rec->trace = 0x00;
				}
			break;
		case BIOS_c :
			for (rec=afunc_base;rec< afunc_end; rec++) rec->trace=0x00;
			break;
		case  BIOS_m :
			flag_chkmem=!flag_chkmem;
			if ( flag_chkmem )
				message("List memory checking is now ON");
			else message("List memory checking is now OFF");
			break;
		case BIOS_l :
			flag_report=!flag_report;
			if ( flag_report )
				message("List reporting is now ON");
			else message("List reporting is now OFF");
			break;
		case BIOS_p :
			window_puts(MAIN,"\n**** View Field: ****\n");
			win_vf(MAIN,avf_b,(*ares_head)->next);
			win_vf(MAIN,ate[1],avf_e);
			window_puts(MAIN,"*********************\n");
			break;
		default:
			errmsg("Invalid command");
			break;
		}
	}
}  /* end of dial */

void end_step()
{

window_puts(MAIN,"*** ON EXIT:\n");
win_vf(MAIN,*ares_head,(*ab)->next);

if ( flag_chkmem && chkmem_status !=0 ) 
	window_puts(MAIN,"\n*** List error:\n");
if ( flag_report ) {
	window_puts(MAIN,"\n*** View Field:\n");
	win_vf(MAIN,avf_b,avf_e);
	}
return;
}

void start_step()
{
window_puts(MAIN,"\n*** Step ");
ultoamy(NST,buff,10);
window_puts(MAIN,buff);
window_puts(MAIN," Function ");
put_name(MAIN,nameptr(FUNC_REC));
window_putchar(MAIN,'\n');
window_puts(MAIN,"*** ON ENTRY:\n");
win_vf(MAIN,ate[0],ate[1]);
return;
}

int check_memory()
{
cell *c,*c2,*ctmp;
unsigned long str_term,func_term;
unsigned long func_terms;
unsigned long count;

str_term=func_term=0L;
func_terms=0L;
count=0L;
c=(cell*)avf_b;
c2=(cell*)avf_e;
while( c->next !=c2 ) {
	if ( *aimm_flag && (*ab1==c) ) {
		func_term++;
		func_terms++;
		}
	c=c->next;
	count++;

	if ( c->tag==T_BH ) {
		str_term++;
		ctmp=c->inf.a;
		if ( ctmp->tag != T_BE ) return 9;
		}
	else if ( c->tag==T_BE ) {
		str_term--;
		if ( str_term<0 ) return 1;
		}
	else if ( c->tag==T_FH ) {
		func_term++;
		func_terms++;
		c=c->next;
/*		if ( c->tag != T_BH ) return 2; */
		ctmp=c->inf.a;
		ctmp=ctmp->next;
		if ( ctmp->tag != T_FE ) return 10;
		c=c->next;
		if ( c->tag != T_LAB ) return 3;
		}
	else if ( c->tag==T_FE ) {
		func_term--;
		if ( func_term<0 ) return 4;
		}
	else if ( c->tag > T_FE ) return 5;
	if ( count > 10000 ) return 6;
	}
if ( str_term != 0 ) return 7;
if ( func_term != 0 ) return 8;

if ( flag_report ) {
	user_screen();
	printf("*** List contains %lu cells; Tree consists of %lu functions\n",
			count,func_terms);
	printf("*** Functions: \n");
	c=asystem_cell->inf.a;
	while ( c != NULL && func_term != func_terms ) {
		if ( c== *afunc_head ) printf("* ");
		c=c->next;
		c2=c->next;
		printf("%s\n",(char*)(aname_base+c2->inf.f));
		func_term++;
		c=c->inf.a;
		c=c->next;
		c=c->inf.a;
		}
	}
return 0;
} /* end of check_memory */

int check_free()
{
cell *c;
long count;

count=0L;
c=(cell*)asystem_cell;

while( c != NULL ) {
	c=c->next;
	if ( count++ > 1000000000 ) return 0;
	}

if ( flag_report ) {
	user_screen();
	printf("*** Free list contains %lu cells\n",	count);
	count=coreleft();
	printf("*** Available memory %lu bytes\n", count);
	}
return 1;
} /* end of check_free */

int view_box( rec )
func* rec;
{
cell box_head;
cell *c;
int key=0;

if ( rec ->status == STATUS_BOX ) {
	/*window(BOX);*/
	strcpy(buff,"Contents of box ");
	strncat(buff,nameptr(rec),8);
	window_title(BOX,buff);
	c=(cell*)(rec->addr);
	box_head.next=c->next;
	c->next=&box_head;
	win_vf(BOX,&box_head,&box_head);
	c->next=box_head.next;
	/*key=bioskey(0);*/
	window_hide(BOX);
	}
else if (rec ->status == STATUS_UNINIT ) {
	window(BOX);
	strcpy(buff,"Contents of box ");
	strncat(buff,nameptr(rec),8);
	window_title(BOX,buff);
	window_puts(BOX,"Box is empty\n");
	/*key=bioskey(0); */
	window_hide(BOX);
	}
return key;
} /* end of view_box */

func *seek_name( ident )
char *ident;
{
char *rec;
unsigned int i;
/* char number[20]; */
i=0;
for (rec=aname_base;rec<=aname_end; rec+=8,i+=sizeof(func)) {
	if ( strncmp(ident,rec,8)==0 ) {
/*		itoa(i,number,10);
		window_puts(MAIN,number);*/
		return (func*)((char*)afunc_base+i);
		}
	}
return NULL;
}

char * nameptr( rec )
func* rec;
{
if (*aimm_flag)
return (char*)(aname_base+(unsigned int)(((*aimm_func)/sizeof(func))*8));
else
return (char*)(aname_base+((rec-afunc_base)<<3));
}

void put_name( int win,char* name )
{
int i;
for(i=0;i<8 && name[i]!='\0';i++) window_putchar(win,name[i]);
return;
}

/*
main(argc,argv)
int argc;
char *argv[];
{
int flag;

printf("\nREFAL-M  Interactive Tracer  Ver 2.00  (C) N.Mansurov %s\n",__DATE__);
if ( argc==1 )	exit(1);


start_screen();


end_screen();

printf("\nBye-bye from RTRACE\n");
exit(0);
} 

*/

