/* $Id: trc_scr.c,v 1.2 1999/09/24 10:43:38 alena Exp $ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>

#include "rulex.h"
#include "funct.h"
#include "trc_func.h"
#include "window.h"
#include "keydefs.h"
#include "zat.h"
 
static char rcs_id[]="$Id: trc_scr.c,v 1.2 1999/09/24 10:43:38 alena Exp $";

#define TRACE_PAGE 3
#define USER_PAGE  0

#define MAIN 1
#define TOP 2
#define BOT 3
#define ERR 4
#define INP 5
#define MSG 6
#define BOX 7
#define INF 8

#define TIME_POS 35
#define STEP_POS 64
#define TIMER_POS 51
#define NST_POS 70

#define F1_POS  1
#define F5_POS  10
#define F7_POS  27
#define F8_POS  38
#define F9_POS  48
#define F10_POS 56
#define FUNC_HELP " F1-Help  F5-User screen \
  F7-Trace   F8-Apply  F9-Run  F10-Abort"

static char buffer[300];
extern long* anst;

extern int flag_trcscr;
extern int maxx,maxy,minx,miny;

static int pop_x,pop_y;

wincolors main_colors={0,0,0x13,0,0xb0};
wincolors top_colors={0,0,0x70,0,0x74};
wincolors bot_colors={0,0,0x70,0,0x74};
wincolors err_colors={2,0x4f,0x4f,0x4f,0x4E};
wincolors inp_colors={1,0x70,0x70,0x74,0x70};
wincolors msg_colors={1,0x31,0x31,0x31,0x3E};
wincolors box_colors={1,0x31,0x31,0x31,0x31};
wincolors inf_colors={1,0x70,0x70,0x70,0x7F};

void start_screen()
{
/*int i,j;
unsigned long core;
*/
  char msg[100];
init_window(8,8000);
switch_page( TRACE_PAGE );
cursor_pos( TRACE_PAGE,25,0 );
flag_trcscr=TRUE;

make_window(MAIN,TRACE_PAGE,NULL,1,0,23,79,&main_colors,0);
make_window(TOP,TRACE_PAGE,NULL,0,0,0,79, &top_colors,0);
make_window(BOT,TRACE_PAGE,NULL,24,0,24,79,&bot_colors,0);
make_window(ERR,TRACE_PAGE,"Error",9,15,12,65,&err_colors,1);
make_window(INP,TRACE_PAGE,NULL,9,25,11,55,&inp_colors,1);
make_window(MSG,TRACE_PAGE,NULL,9,15,11,65,&msg_colors,1);
make_window(BOX,TRACE_PAGE,NULL,5,10,20,60,&box_colors,1);


window(TOP);
sprintf(msg," REFAL-M  Tracer  (C) N.Mansurov %s\n",__DATE__);
window_puts(TOP,msg);
window_xy(TOP,0,STEP_POS);
/*window_puts(TOP,"Step: ");
window_hilit(TOP,0,STEP_POS,STEP_POS+4);
window_puts(TOP,"\n");
*/
/*
window(BOT);
window_puts(BOT,FUNC_HELP);
window_hilit(BOT,0,F1_POS,F1_POS+1);
window_hilit(BOT,0,F5_POS,F5_POS+1);
window_hilit(BOT,0,F7_POS,F7_POS+1);
window_hilit(BOT,0,F8_POS,F8_POS+1);
window_hilit(BOT,0,F9_POS,F9_POS+1);
window_hilit(BOT,0,F10_POS,F10_POS+2);
window_puts(TOP,"\n");
*/
window(MAIN);
pop_x=2;
pop_y=2;

return;
}

void tracer_screen()
{
/*long diff_time;
int diff_ms;

if ( !flag_trcscr ) {
	flag_trcscr=TRUE;
	switch_page( TRACE_PAGE );
	}
window_xy(TOP,0,NST_POS);
ultoa(*anst,buffer,10);
window_puts(TOP,buffer);
*/
return;
}

void user_screen()
{
if ( !flag_trcscr ) return;
flag_trcscr=FALSE;
switch_page( USER_PAGE );
return;
}

void end_screen()
{
switch_page( TRACE_PAGE );
window_kill(TOP);
window_kill(BOT);
window_kill(MAIN);

switch_page( USER_PAGE );
return;
}

void errmsg( fmt )
char *fmt;
{
va_list arg_list;
/* int len; */

va_start(arg_list,fmt);
vsprintf(buffer,fmt,arg_list);
va_end(arg_list);
window(ERR);
write_centered(ERR,0,buffer,err_colors.text_color);
/* write_centered(ERR,1,"Press ESC",err_colors.hilit_color);
while ( bioskey(0)!= BIOS_ESC ); */
window_hide(ERR);
return;
}

int input( title,buffer )
char *title;
char *buffer;
{

window_title(INP,title); 
/*window(INP);*/
window_gets(INP,buffer);
window_hide(INP);
if ( buffer[0]=='\0' ) return 0;
return 1;
}

int message( fmt )
char *fmt;
{
va_list arg_list;
int key;

va_start(arg_list,fmt);
vsprintf(buffer,fmt,arg_list);
va_end(arg_list);
window(MSG);
write_centered(MSG,0,buffer,msg_colors.text_color);
/* key=bioskey(0); */
window_hide(MSG);
return key;
}

void info( txt )
char *txt;
{
int len,rows,cols,c;
register int i;
int x,y;

/* figure out dimensions of a box */
len=strlen(txt);
for (i=0,rows=1,cols=0,c=0;i<len;i++,c++) {
	if ( txt[i]=='\n' ) {
		rows++;
		if ( c>cols ) cols=c;
		c=0;
		}
	}
if ( c>cols  ) cols=c;
if ( cols<16 ) cols=16;
cols+=2;
rows+=3;
if ( cols > maxy ) return; /* msg has too many columns */
if ( rows > maxx ) return; /* msg has too many rows */
x=(maxx-rows)/2;
y=(maxy-cols)/2;
make_window(INF,TRACE_PAGE,NULL,x,y,x+rows,y+cols,&inf_colors,1);
window(INF);
window_puts(INF,txt);
/*write_centered(INF,rows-2,"Press any key...",inf_colors.hilit_color);
bioskey(0); */
window_kill(INF);
return;
}

void cursor_pos( page,row,col )
int page,row,col;
{
	return;
}

void memory()
{
unsigned long core;
core=coreleft();
window_urgent(" Available memory: %lu bytes ",core);
}
