/* $Id: trc_win.c,v 1.2 1999/09/24 10:43:38 alena Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "window.h"
#include "zat.h"

#define ESC 27
#define BKSP 8
 
static char rcs_id[]="$Id: trc_win.c,v 1.2 1999/09/24 10:43:38 alena Exp $";

/*static int monochrome;
static char * page_base;
*/
int maxx,maxy,minx,miny; /* screen boundaries */
/* static char *page_addr[4]; */
static wincolors win_colors={1,0x4f,0x4f,0x4f,0x4f};
static char *save_image, * max_image;
static int max_frame;
static int free_image;
/*
static unsigned char corner[5][4]={
        {20,20,20,20},
	{218,191,217,192},
	{201,187,188,200},
	{213,184,190,212},
	{214,183,189,211}
	};
*/
typedef struct {
	char *title;    /* ߫ѡ  рѨ ߂  */
	int image; /* offset of the image */
	int len;   /* length of the image */
	int page; /* video page */
	int startx, endx, starty, endy;
	int curx, cury; /* Ѭ ѡ ߫   */
	int active;
	int popup;
	wincolors wc;
	} window_frame;

window_frame *frame; /*  array of window_frames  */

/*************************************************************/
/*  ѡ Ἷ                                 */
/*************************************************************/
/* 櫺ႌ  ߽  т 틂 ߫ᡫ, тߏ 1;
 тߏ 0 */

int make_window(num, page, title, startx, starty, endx, endy, wc, popup)
int num;       /* р  */
int page; /* р of video page */
char *title;   /* Ѭ߂  */
int startx, starty; /* ႋ X,Y  р  */
int endx, endy;     /* ႋ X,Y    */
wincolors *wc;      /* colors */
int popup;          /* 1-popup; 0-tiled */
{
int len;

	if(num>max_frame) return 0;
	if( startx>maxx || starty>maxy || startx<minx || starty<miny )  return 0;
	if( endx>maxx || endy>maxy )	return 0;
	if(startx>endx || starty>endy ) return 0;
	frame[num].popup=popup;
	if ( popup ) {
		len=2*(endx-startx+1)*(endy-starty+1);
		if ( (free_image+len) > (int)max_image ) {
			window_urgent("Cannot allocate memory");
			len=0;
			return 0;
			}
		else {
			frame[num].image=free_image;
			frame[num].len=len;
			free_image+=len;
			}
		}
	if ( page<0 || page>3 ) return 0;
	else frame[num].page=page;

	if ( wc->border_type==0 ) {
		frame[num].startx = startx;
		frame[num].endx = endx;
		frame[num].starty = starty;
		frame[num].endy = endy;
		}
	else {
		frame[num].startx = startx+1;
		frame[num].endx = endx-1;
		frame[num].starty = starty+1;
		frame[num].endy = endy-1;
		}
	frame[num].title = title;
	frame[num].active = 0;
	frame[num].curx = 0;
	frame[num].cury = 0;
	frame[num].wc=*wc;

	return 1;
}

void window(num)
int num; /* р  */
{
/* ѽႌ  ᬂ󡋼 */
	if( !frame[num].active ) {
		frame[num].active=1;
		if ( frame[num].popup ) save_video(num);
		else window_cls(num);
		}
	draw_border(num);
	display_title(num); /* ߂ title */
}


/* Kill window */
void window_kill(num)
int num;
{
	frame[num].active=0;
	if ( frame[num].popup ) {
		restore_video(num);
		free_image-=frame[num].len;
		frame[num].len=0;
		}
}

void window_hide(num)
int num;
{
	frame[num].active=0;
	if ( frame[num].popup ) restore_video(num);
	frame[num].curx=0;
	frame[num].cury=0;
}

/* ߂    ߫т߂󃎉  */
void display_title(num)
int num;
{ /*
if ( frame[num].active==0 ) return;
if (frame[num].title==NULL || frame[num].wc.border_type==0 ) return;
write_centered(num,-1,frame[num].title,frame[num].wc.title_color);
*/
  if (frame[num].title!=NULL) printf("%s\n",frame[num].title);
}

void draw_border(num)
int num;
{
  /*
register int i;
char *v, *t;
unsigned char bt,bc;
int bsx,bsy,bex,bey;
int bp;

if ( frame[num].active== 0 ) return;
if ( frame[num].wc.border_type ==0 ) return;
bp=frame[num].page;
v = page_addr[bp];
t = v;
bt=frame[num].wc.border_type;
bc=frame[num].wc.border_color;
bsx=frame[num].startx-1;
bex=frame[num].endx+1;
bsy=frame[num].starty-1;
bey=frame[num].endy+1;

for(i=bsx; i<=bex; i++) {
	 v += (i*160) + bsy*2;
	 *v++ =( bt==1 || bt==3 ) ? 179: 186;
	 *v = bc;
	 v = t;
	 v += (i*160) + bey*2;
	 *v++ = ( bt==1 || bt==3 ) ? 179: 186;
	 *v = bc;
	 v = t;
	 }

for(i=bsy; i<=bey; i++) {
	 v += (bsx*160) + i*2;
	 *v++ = (bt== 1 || bt==4)? 196:205;
	 *v = bc;
	 v = t;
	 v += (bex*160) + i*2;
	 *v++ = (bt==1||bt==4)? 196:205;
	 *v = bc;
	 v = t;
	 }
write_char(bp,bsx,bsy, corner[bt][0], bc);
write_char(bp,bsx,bey, corner[bt][1], bc);
write_char(bp,bex,bey, corner[bt][2], bc);
write_char(bp,bex,bsy, corner[bt][3], bc);
*/
}

/**************************************************************/
/*  Ĭ  /                              */
/**************************************************************/

/* ߂ ߂ ᇿ  ѬѨ  ߫
ᡡ . 髺Ⴟ 0 ߽   ᬂ;
 1  󡫼 ߽. */

int window_puts(num, str)
int num;
char *str;
{
 /* 񿂌ߏ,   ᬂ */
/*	if( !frame[num].active ) return 0;
	for( ; *str; str++) window_putchar(num, *str);
	*/
  printf("%s",str);
	return 1;
}

/* ѽ line. 髺Ⴟ 0 ߽   ᬂ;
 1  󡫼 ߽. */

int window_hilit(num,startx,starty,endy)
int num;
int startx,starty,endy;
{
/* int i;
char *v; */
 /* 񿂌ߏ,   ᬂ */
 /*
	if( !frame[num].active ) return 0;
	if( startx<0 || starty<0 || starty>endy )  return 0;
	startx+=frame[num].startx;
	starty+=frame[num].starty;
	endy  +=frame[num].starty;
	if( startx>frame[num].endx || starty>frame[num].endy ||
		endy>frame[num].endy )	return 0;
	v =page_addr[ frame[num].page ] + startx*160 + starty*2;
	for(i=starty; i<=endy; i++) {
			 v++;  
			 *v++ =frame[num].wc.hilit_color;
			 }
 */
	return 1;
}

/* ߂ ߿  Ѭ  ߫
ᡡ . 髺Ⴟ 0 ߽   ᬂ,
 1  󡫼 ߽. */

int window_putchar(num, ch)
int num;
char ch;
{
  /*
register int x, y;
char *v;
int page;

if(!frame[num].active) return 0;
	 x = frame[num].curx + frame[num].startx;
	 y = frame[num].cury + frame[num].starty;

	 if( y> frame[num].endy ) return 1;
	 if( x> frame[num].endx ) return 1;
	 page=frame[num].page;
	 v = page_addr[ page ] + x*160 + y*2;

	 if(ch=='\n') { 
		 if (x==frame[num].endx) {
			window_scroll(num,1);
			x--;
			}
		 else {
			frame[num].curx++;
			x++;
			}
		 y = frame[num].startx;
		 v = page_addr[page] + x*160 + y*2;
		 frame[num].cury = 0;
		 }
    else {
		 frame[num].cury++;
		 *v++ = ch;
		 *v++ = frame[num].wc.text_color; 
		 }
		 */
   /* window_xy(num, frame[num].curx, frame[num].cury); */
   printf("%c",ch); 
   return 1;
 }

void window_title(num,title)
int num;
char* title;
{
frame[num].title=title;
/* draw_border(num); */
display_title(num);
}

int window_cols(num)
int num;
{
return (frame[num].endy-frame[num].starty+1);
}

int window_rows(num)
int num;
{
return (frame[num].endx-frame[num].startx+1);
}

int window_putattr(num, attr)
int num;
unsigned char attr;
{
/* register int x, y;
char *v; */

      /* 񿂌ߏ,   ᬂ */
/*if(!frame[num].active) return 0;
	 x = frame[num].curx + frame[num].startx;
	 y = frame[num].cury + frame[num].starty;

	 if( y >frame[num].endy ) return 1;
	 if( x >frame[num].endx ) return 1;

	 v = page_addr[ frame[num].page ] + x*160 + y*2;
	 v++;  
	 *v++ = attr;
 */
    return 1;
}

  /* ߂ᡫ ߫  ᡡ  .
  髺т 0  󋅫  ᡿;
     󡫼 ߽.  */

int window_xy(num, x, y)
int num, x, y;
{
	if( x<0 || x+frame[num].startx > frame[num].endx )  return 0;
	if( y<0 || y+frame[num].starty > frame[num].endy )  return 0;
	frame[num].curx = x;
	frame[num].cury = y;
	return 1;
}

   /* 懿ႌ ߂  . */
extern char comm_arg[];
void window_gets(num, s)
int num;
char *s;
{
/* char ch, *temp; */

	printf("input: ");
	if (comm_arg[0]==0) {
	fflush(stdout); 
	fgets(s,80,stdin);
	s[strlen(s)-1]=0;
	}
	else{
	strcpy(s,comm_arg);
	printf("%s\n",s);
	fflush(stdout);
	}
	/*
	temp = s;
	for(;;) {
		ch = window_getche(num);
		switch(ch) {
			case '\r':  
				*s='\0';
				return;

			case ESC:  
				*temp='\0';
				return;

			case BKSP:
				if(s>temp) {
					s--;
					frame[num].cury--;
					if( frame[num].cury<0 ) frame[num].cury = 0;
					window_xy(num, frame[num].curx, frame[num].cury);
					write_char(frame[num].page,frame[num].startx+ frame[num].curx,
						frame[num].starty+frame[num].cury, ' ',
						frame[num].wc.text_color);
					}
				break;
			default:  *s = ch;
		s++;
		}
	} */
}

/*  ߿  ႃ  . */

static char russian_letter[]={
	0x94,0x88,0x91,0x82,0x93,0x80,0x8f,0x90,0x98,
	0x8e,0x8b,0x84,0x9c,0x92,0x99,0x87,0x89,0x8a,0x9b,0x85,0x83,0x8c,
	0x96,0x97,0x8d,0x9f };

char window_getche(num)
int num;
{
char key;
/*---------------------------------*/
/*   modified version:             */
/*   handles uppercase translation */
/*   and russian letters support   */
/*   on shifted keys               */
/*   legal are: letters,digits,    */
/*   and "-" "_" signs             */
/*   Date: 25.07.1990              */
/*---------------------------------*/
	if(!frame[num].active) return 0; /* window not active */
	window_xy( num, frame[num].curx, frame[num].cury);
MORE_KEYS:
	key = bioskey(0);    /* ႌ Ⴟ 󿈿 */
	switch( key ) {
		case '\r': /*   ENTER */
		case BKSP: /*  */
		case ESC:  /* ESC */
			return key;
		default:
				if ( key >= '0' && key <= '9' );
				else if ( key == '_' || key == '-' );
				else if ( key >= 'a' && key <= 'z' ) key-=0x20; /* toupper */
			/* here comes russian letters support */
				else if ( key >= 'A' && key <= 'Z' )
							key=russian_letter[ key-'A' ];
			/* if they want it russian let 'em get it */
				else if ( key == 0x7B ) key=0x95;
				else if ( key == 0x7D ) key=0x9A;
				else if ( key == 0x3A ) key=0x86;
				else if ( key == 0x22 ) key=0x9D;
				else if ( key == 0x3C ) key=0x81;
				else if ( key == 0x3E ) key=0x9E;
				else goto MORE_KEYS;
				}
		if(frame[num].cury+frame[num].starty < frame[num].endy) {
			write_char(frame[num].page, frame[num].startx+ frame[num].curx,
				frame[num].starty+frame[num].cury, key,
					frame[num].wc.text_color);
			frame[num].cury++;
			window_xy(num, frame[num].curx, frame[num].cury);
			}
		return key;
}

/* ć߂  */

void window_cls(num)
int num;
{
window_scroll(num,0);

frame[num].curx = 0;
frame[num].cury = 0;
}

/* ć߂   ߂ */
void window_cleol(num)
int num;
{
register int i, x, y;
x = frame[num].curx;
y = frame[num].cury;
window_xy(num, frame[num].curx, frame[num].cury);
for(i=frame[num].cury; i<=frame[num].endy; i++)
	 window_putchar(num,' ');
window_xy(num, x, y);
}

/* рѼ߂ ߫   ߂ р.
ŀ ߯ш рѡ р ѡ ѡ;
 󡫼 ߽ - 0.
*/

int  window_upline(num)
int num;
{
if(frame[num].curx>0) {
	frame[num].curx--;
	window_xy(num, frame[num].curx, frame[num].cury);
	return 1;
	}
return 0;
}

/* рѼ߂ ߫   ߂ 󡿺.
ŀ ߯ш рѡ р ѡ ѡ;
 󡫼 ߽ - 0.
*/
int window_downline(num)
int num;
{
	if(frame[num].curx < frame[num].endx-frame[num].startx) {
		frame[num].curx++;
		window_xy(num, frame[num].curx, frame[num].cury);
		return 1;
		}
	return 1;
}

/* рߏ     */
int window_bksp(num)
int num;
{
	if(frame[num].cury>0) {
		frame[num].cury--;
		window_xy(num, frame[num].curx, frame[num].cury);
		window_putchar(num, ' ');
		frame[num].cury--;
		window_xy(num, frame[num].curx, frame[num].cury);
		}
		return 0;
}

/* window_scroll up */
void window_scroll(num,lines)
int num;
int lines;
{
  /* printf("\nwindow scroll %d %d\n",num,lines); */
	return;
}

/* write string centered */

void write_centered(num,line,str,attr)
int num,line,attr;
char *str;
{
register int x, y, len;
x = frame[num].startx+line;
y = frame[num].starty;
/* 鋇߽  ѡ ѡὌ 
߽ ѽ - string  т 틂 ѡ */

len = strlen(str);
len = (frame[num].endy - y - len) / 2;
if(len<0) return; /* don't display it */
y +=len+1;
write_string(frame[num].page,x,y,str,attr);
return;
}

/********************************************************/
/* 䫯ѽ                                */
/********************************************************/
/* ߂ ߂  ߂ᡫѡ ႀ탂Ἷ */
void write_string(page, x, y, p, attr)
int x, y;
char *p;
unsigned char attr;
int page;
{/*
register int i;
char *v;
	v = page_addr[ page ] + x*160 + y*2; 
	for(i=y; *p; i++)  {
		*v++ = *p++; 
		*v++ = attr; 
		}
*/
  printf("%s\n",p);
}

/* ߂ ߿  cᡫѡ ႀ탂Ἷ */
void write_char(page, x, y, ch, attr)
int x, y;
char ch;
int attr;
int page;
{ /*
char *v;

	v = page_addr[ page ] + x*160 +y*2;
	*v++ = ch;    
	*v = attr;
*/
  printf("%c",ch);
}

/* 櫅᡿ ߫р ߂  */
void save_video(num)
int num;
{
  /* printf("Save video %d\n",num); */
  /*
register int i,j;
char *t;
char *buf_ptr;
int k;
int sx,sy,ex,ey;

	buf_ptr = save_image+frame[num].image;
	if ( frame[num].wc.border_type==0 ) {
		sx=frame[num].startx;
		sy=frame[num].starty;
		ex=frame[num].endx;
		ey=frame[num].endy;
		}
	else {
		sx=frame[num].startx-1;
		sy=frame[num].starty-1;
		ex=frame[num].endx+1;
		ey=frame[num].endy+1;
		}
	k=(maxy-ey+sy)*2;
	t=page_addr[ frame[num].page ]+sx*(maxy+1)*2+2*sy;
	for(i=sx; i<=ex; i++) {
		for(j=sy; j<=ey; j++) {
			*buf_ptr++=*t++;
			*buf_ptr++=*t++;
			*(t-2)=' ';
			*(t-1)=frame[num].wc.text_color;
			}
		t+=k;
		}
		*/
}
/* ߂ᡫ󿂌 ߫р ߂  */
void restore_video(num)
int num;
{
  /* printf("Restore video %d\n",num); */
  /*
register int i,j;
char *t;
char *buf_ptr;
int k;
int sx,sy,ex,ey;

	buf_ptr = save_image + frame[num].image;
	if ( frame[num].wc.border_type==0 ) {
		sx=frame[num].startx;
		sy=frame[num].starty;
		ex=frame[num].endx;
		ey=frame[num].endy;
		}
	else {
		sx=frame[num].startx-1;
		sy=frame[num].starty-1;
		ex=frame[num].endx+1;
		ey=frame[num].endy+1;
		}
	k=(maxy-ey+sy)*2;
	t=page_addr[ frame[num].page ]+sx*(maxy+1)*2+2*sy;
	for(i=sx; i<=ex; i++) {
		for(j=sy; j<=ey; j++) {
			*t++ = *buf_ptr++;  
			*t++ = *buf_ptr++; 
			}
		t+=k;
		}
	frame[num].active = 0; */
}

void window_urgent( fmt )
char *fmt;
{
char buffer[31];
va_list arg_list;

va_start(arg_list,fmt);
vsprintf(buffer,fmt,arg_list);
va_end(arg_list);

window(0);
write_centered(0,0,buffer,frame[0].wc.text_color);
/* bioskey(0); */
window_hide(0);
return;
}


void switch_page(page)
int page;
{
/* printf("Switch page %d\n",page); */
return;
}

int init_window( win_num,image_len )
int win_num,image_len;
{
/*  int i;
int vmode=2;
*/
maxx=24;
maxy=79;
minx=0;
miny=0;

frame=(window_frame*) malloc( sizeof(window_frame)*(win_num+1) );
save_image=(char *)malloc( image_len );
if ( save_image==NULL ) printf("Insufficient memory\n");
max_image=save_image+image_len;
max_frame=win_num;
free_image=0;
make_window(0,0,NULL,9,14,11,66,&win_colors,1);
return 0;
}
